#
# Makefile for the MsgTest on the AIX platform
#
# Copyright 2004, 2005 Tim Armstrong
#
# Revision History
# ================
# Version  Date         Author        Changes
#       1  12 Nov 2004  Tim Armstrong Initial version 
#       2  16 Feb 2005  Tim Armstrong Added MsgTestCmqValues
#       3  11 Jul 2006  Tim Armstrong Added Server Binding Version MsgTestS

# Libraries for Client MQI
LDFLAGSMQCLIENT=-lmqic
LDFLAGSEXPAT=-lexpat

CCINC=-I../expat-1.95.8/lib

# GNU c compiler and linker
all:	MsgTest MsgTestS
# Link objects
MsgTest: MsgTest.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInit.o MsgTestMessages.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o
	cc -o $@ MsgTest.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInit.o MsgTestMessages.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o $(LDFLAGSMQCLIENT) $(LDFLAGSEXPAT)

MsgTestS: MsgTestS.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInitS.o MsgTestMessagesS.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o
	cc -o $@ MsgTest.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInit.o MsgTestMessages.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o $(LDFLAGSMQCLIENT) $(LDFLAGSEXPAT)

# Compile modules

MsgTest.o: MsgTest.c
	cc -c $(CCINC) MsgTest.c

MsgTestS.o: MsgTest.c
	cc -c $(CCINC) MsgTest.c -D__MSGTEST_S

MsgTestCmqValues.o: MsgTestCmqValues.c
	cc -c $(CCINC) MsgTestCmqValues.c

MsgTestCtrlBlk.o: MsgTestCtrlBlk.c
	cc -c $(CCINC) MsgTestCtrlBlk.c

MsgTestConv.o: MsgTestConv.c
	cc -c $(CCINC) MsgTestConv.c

MsgTestFile.o: MsgTestFile.c
	cc -c $(CCINC) MsgTestFile.c

MsgTestInit.o: MsgTestInit.c
	cc -c $(CCINC) MsgTestInit.c

MsgTestInitS.o: MsgTestInit.c
	cc -c $(CCINC) MsgTestInit.c -D__MSGTEST_S

MsgTestMessages.o: MsgTestMessages.c
	cc -c $(CCINC) MsgTestMessages.c

MsgTestMessagesS.o: MsgTestMessages.c
	cc -c $(CCINC) MsgTestMessages.c -D__MSGTEST_S

MsgTestMsgSet.o: MsgTestMsgSet.c
	cc -c $(CCINC) MsgTestMsgSet.c

MsgTestRun.o: MsgTestRun.c
	cc -c $(CCINC) MsgTestRun.c

MsgTestScript.o: MsgTestScript.c
	cc -c $(CCINC) MsgTestScript.c

MsgTestShut.o: MsgTestShut.c
	cc -c $(CCINC) MsgTestShut.c

MsgTestTime.o: MsgTestTime.c
	cc -c $(CCINC) MsgTestTime.c

MsgTestUtil.o: MsgTestUtil.c
	cc -c $(CCINC) MsgTestUtil.c

clean:
# Delete all programs and object files
	rm -f *.o
	rm -f MsgTest

cleanobj:
# Delete all object files
	rm -f *.o