#
# Makefile for the MsgTest on the Linux platform
#
# Copyright 2004, 2005, 2006, 2007 Tim Armstrong
#
# Revision History
# ================
# Version  Date         Author        Changes
#       1  15 Sep 2004  Tim Armstrong Initial version 
#       2  16 Feb 2005  Tim Armstrong Added MsgTestCmqValues
#       3  11 Jul 2006  Tim Armstrong Added Server Binding Version MsgTestS
#       4  15 Oct 2007  Clem          Added LDFLAGSMQSERVER and Expat library path

# Libraries for Client MQI
LDFLAGSMQCLIENT=-lmqic
LDFLAGSMQSERVER=-lmqm
LDFLAGSEXPAT=-L/home/mqm/expat/lib -lexpat -lm

# Per expat doc, use following, or export LD_LIBRARY_PATH at run time
LD_RUN_PATH=/home/mqm/expat/lib
export LD_RUN_PATH

# GNU c compiler and linker
all:	MsgTest MsgTestS
# Link objects
MsgTest: MsgTest.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInit.o MsgTestMessages.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o
	cc -o $@ MsgTest.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInit.o MsgTestMessages.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o $(LDFLAGSMQCLIENT) $(LDFLAGSEXPAT)

MsgTestS: MsgTestS.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInitS.o MsgTestMessagesS.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o
	cc -o $@ MsgTest.o MsgTestCmqValues.o MsgTestCtrlBlk.o MsgTestConv.o MsgTestFile.o MsgTestInit.o MsgTestMessages.o MsgTestMsgSet.o MsgTestRun.o MsgTestScript.o MsgTestShut.o MsgTestTime.o MsgTestUtil.o $(LDFLAGSMQSERVER) $(LDFLAGSEXPAT)

# Compile modules

MsgTest.o: MsgTest.c
	cc -c -I/home/mqm/expat/include MsgTest.c

MsgTestS.o: MsgTest.c
	cc -c -I/home/mqm/expat/include MsgTest.c -D__MSGTEST_S

MsgTestCmqValues.o: MsgTestCmqValues.c
	cc -c -I/home/mqm/expat/include MsgTestCmqValues.c

MsgTestCtrlBlk.o: MsgTestCtrlBlk.c
	cc -c -I/home/mqm/expat/include MsgTestCtrlBlk.c

MsgTestConv.o: MsgTestConv.c
	cc -c -I/home/mqm/expat/include MsgTestConv.c

MsgTestFile.o: MsgTestFile.c
	cc -c -I/home/mqm/expat/include MsgTestFile.c

MsgTestInit.o: MsgTestInit.c
	cc -c -I/home/mqm/expat/include MsgTestInit.c

MsgTestInitS.o: MsgTestInit.c
	cc -c -I/home/mqm/expat/include MsgTestInit.c -D__MSGTEST_S

MsgTestMessages.o: MsgTestMessages.c
	cc -c -I/home/mqm/expat/include MsgTestMessages.c

MsgTestMessagesS.o: MsgTestMessages.c
	cc -c -I/home/mqm/expat/include MsgTestMessages.c -D__MSGTEST_S

MsgTestMsgSet.o: MsgTestMsgSet.c
	cc -c -I/home/mqm/expat/include MsgTestMsgSet.c

MsgTestRun.o: MsgTestRun.c
	cc -c -I/home/mqm/expat/include MsgTestRun.c

MsgTestScript.o: MsgTestScript.c
	cc -c -I/home/mqm/expat/include MsgTestScript.c

MsgTestShut.o: MsgTestShut.c
	cc -c -I/home/mqm/expat/include MsgTestShut.c

MsgTestTime.o: MsgTestTime.c
	cc -c -I/home/mqm/expat/include MsgTestTime.c

MsgTestUtil.o: MsgTestUtil.c
	cc -c -I/home/mqm/expat/include MsgTestUtil.c

clean:
# Delete all programs and object files
	rm -f *.o
	rm -f MsgTest

cleanobj:
# Delete all object files
	rm -f *.o
