/*==========================================================================*/
/* MsgTestCmqValues.c contains code for resolving constant strings from the */
/* various cmq prefixed header files that can be used in script elements    */
/*==========================================================================*/
/* (C) Copyright Tim Armstrong 2003, 2004, 2005, 2006, 2007, 2008           */
/*==========================================================================*/
/* Includes                                                                 */
/*==========================================================================*/
#ifndef __TJAINC_MSGTEST_H
#include "MsgTest.h"
#endif /* __TJAINC_MSGTEST_H */

#ifndef __TJAINC_MATH_H
#define __TJAINC_MATH_H
#include <math.h>
#endif /* __TJAINC_MATH_H */

/*------------------------------------------------------------------------------------------------------------------*/
/* MQGMO_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQGMO_PFX =                       "MQGMO_\0";
static char* kpszMQGMO_WAIT =                      "MQGMO_WAIT\0";
static char* kpszMQGMO_NO_WAIT =                   "MQGMO_NO_WAIT\0";
static char* kpszMQGMO_SET_SIGNAL =                "MQGMO_SET_SIGNAL\0";
static char* kpszMQGMO_FAIL_IF_QUIESCING =         "MQGMO_FAIL_IF_QUIESCING\0";
static char* kpszMQGMO_SYNCPOINT =                 "MQGMO_SYNCPOINT\0";
static char* kpszMQGMO_SYNCPOINT_IF_PERSISTENT =   "MQGMO_SYNCPOINT_IF_PERSISTENT\0";
static char* kpszMQGMO_NO_SYNCPOINT =              "MQGMO_NO_SYNCPOINT\0";
static char* kpszMQGMO_MARK_SKIP_BACKOUT =         "MQGMO_MARK_SKIP_BACKOUT\0";
static char* kpszMQGMO_BROWSE_FIRST =              "MQGMO_BROWSE_FIRST\0";
static char* kpszMQGMO_BROWSE_NEXT =               "MQGMO_BROWSE_NEXT\0";
static char* kpszMQGMO_BROWSE_MSG_UNDER_CURSOR =   "MQGMO_BROWSE_MSG_UNDER_CURSOR\0";
static char* kpszMQGMO_MSG_UNDER_CURSOR =          "MQGMO_MSG_UNDER_CURSOR\0";
static char* kpszMQGMO_LOCK =                      "MQGMO_LOCK\0";
static char* kpszMQGMO_UNLOCK =                    "MQGMO_UNLOCK\0";
static char* kpszMQGMO_ACCEPT_TRUNCATED_MSG =      "MQGMO_ACCEPT_TRUNCATED_MSG\0";
static char* kpszMQGMO_CONVERT =                   "MQGMO_CONVERT\0";
static char* kpszMQGMO_LOGICAL_ORDER =             "MQGMO_LOGICAL_ORDER\0";
static char* kpszMQGMO_COMPLETE_MSG =              "MQGMO_COMPLETE_MSG\0";
static char* kpszMQGMO_ALL_MSGS_AVAILABLE =        "MQGMO_ALL_MSGS_AVAILABLE\0";
static char* kpszMQGMO_ALL_SEGMENTS_AVAILABLE =    "MQGMO_ALL_SEGMENTS_AVAILABLE\0";
static char* kpszMQGMO_NONE =                      "MQGMO_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQPMO_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQPMO_PFX =                       "MQPMO_\0";
static char* kpszMQPMO_SYNCPOINT =                 "MQPMO_SYNCPOINT\0";
static char* kpszMQPMO_NO_SYNCPOINT =              "MQPMO_NO_SYNCPOINT\0";
static char* kpszMQPMO_NEW_MSG_ID =                "MQPMO_NEW_MSG_ID\0";
static char* kpszMQPMO_NEW_CORREL_ID =             "MQPMO_NEW_CORREL_ID\0";
static char* kpszMQPMO_LOGICAL_ORDER =             "MQPMO_LOGICAL_ORDER\0";
static char* kpszMQPMO_NO_CONTEXT =                "MQPMO_NO_CONTEXT\0";
static char* kpszMQPMO_DEFAULT_CONTEXT =           "MQPMO_DEFAULT_CONTEXT\0";
static char* kpszMQPMO_PASS_IDENTITY_CONTEXT =     "MQPMO_PASS_IDENTITY_CONTEXT\0";
static char* kpszMQPMO_PASS_ALL_CONTEXT =          "MQPMO_PASS_ALL_CONTEXT\0";
static char* kpszMQPMO_SET_IDENTITY_CONTEXT =      "MQPMO_SET_IDENTITY_CONTEXT\0";
static char* kpszMQPMO_SET_ALL_CONTEXT =           "MQPMO_SET_ALL_CONTEXT\0";
static char* kpszMQPMO_ALTERNATE_USER_AUTHORITY =  "MQPMO_ALTERNATE_USER_AUTHORITY\0";
static char* kpszMQPMO_FAIL_IF_QUIESCING =         "MQPMO_FAIL_IF_QUIESCING\0";
static char* kpszMQPMO_NONE =                      "MQPMO_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQMO_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQMO_PFX =                        "MQMO_\0";
static char* kpszMQMO_MATCH_MSG_ID =               "MQMO_MATCH_MSG_ID\0";
static char* kpszMQMO_MATCH_CORREL_ID =            "MQMO_MATCH_CORREL_ID\0";
static char* kpszMQMO_MATCH_GROUP_ID =             "MQMO_MATCH_GROUP_ID\0";
static char* kpszMQMO_MATCH_MSG_SEQ_NUMBER =       "MQMO_MATCH_MSG_SEQ_NUMBER\0";
static char* kpszMQMO_MATCH_OFFSET =               "MQMO_MATCH_OFFSET\0";
static char* kpszMQMO_MATCH_MSG_TOKEN =            "MQMO_MATCH_MSG_TOKEN\0";
static char* kpszMQMO_NONE =                       "MQMO_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQMF_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQMF_PFX =                        "MQMF_\0";
static char* kpszMQMF_SEGMENTATION_INHIBITED =     "MQMF_SEGMENTATION_INHIBITED\0";
static char* kpszMQMF_SEGMENTATION_ALLOWED =       "MQMF_SEGMENTATION_ALLOWED\0";
static char* kpszMQMF_MSG_IN_GROUP =               "MQMF_MSG_IN_GROUP\0";
static char* kpszMQMF_LAST_MSG_IN_GROUP =          "MQMF_LAST_MSG_IN_GROUP\0";
static char* kpszMQMF_SEGMENT =                    "MQMF_SEGMENT\0";
static char* kpszMQMF_LAST_SEGMENT =               "MQMF_LAST_SEGMENT\0";
static char* kpszMQMF_NONE =                       "MQMF_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQRO_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQRO_PFX =                        "MQRO_\0";
static char* kpszMQRO_EXCEPTION =                  "MQRO_EXCEPTION\0";
static char* kpszMQRO_EXCEPTION_WITH_DATA =        "MQRO_EXCEPTION_WITH_DATA\0";
static char* kpszMQRO_EXCEPTION_WITH_FULL_DATA =   "MQRO_EXCEPTION_WITH_FULL_DATA\0";
static char* kpszMQRO_EXPIRATION =                 "MQRO_EXPIRATION\0";
static char* kpszMQRO_EXPIRATION_WITH_DATA =       "MQRO_EXPIRATION_WITH_DATA\0";
static char* kpszMQRO_EXPIRATION_WITH_FULL_DATA =  "MQRO_EXPIRATION_WITH_FULL_DATA\0";
static char* kpszMQRO_COA =                        "MQRO_COA\0";
static char* kpszMQRO_COA_WITH_DATA =              "MQRO_COA_WITH_DATA\0";
static char* kpszMQRO_COA_WITH_FULL_DATA =         "MQRO_COA_WITH_FULL_DATA\0";
static char* kpszMQRO_COD =                        "MQRO_COD\0";
static char* kpszMQRO_COD_WITH_DATA =              "MQRO_COD_WITH_DATA\0";
static char* kpszMQRO_COD_WITH_FULL_DATA =         "MQRO_COD_WITH_FULL_DATA\0";
static char* kpszMQRO_PAN =                        "MQRO_PAN\0";
static char* kpszMQRO_NAN =                        "MQRO_NAN\0";
static char* kpszMQRO_NEW_MSG_ID =                 "MQRO_NEW_MSG_ID\0";
static char* kpszMQRO_PASS_MSG_ID =                "MQRO_PASS_MSG_ID\0";
static char* kpszMQRO_COPY_MSG_ID_TO_CORREL_ID =   "MQRO_COPY_MSG_ID_TO_CORREL_ID\0";
static char* kpszMQRO_PASS_CORREL_ID =             "MQRO_PASS_CORREL_ID\0";
static char* kpszMQRO_DEAD_LETTER_Q =              "MQRO_DEAD_LETTER_Q\0";
static char* kpszMQRO_DISCARD_MSG =                "MQRO_DISCARD_MSG\0";
static char* kpszMQRO_NONE =                       "MQRO_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQMT_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQMT_PFX =                        "MQMT_\0";
static char* kpszMQMT_REQUEST =                    "MQMT_REQUEST\0";
static char* kpszMQMT_REPLY =                      "MQMT_REPLY\0";
static char* kpszMQMT_REPORT =                     "MQMT_REPORT\0";
static char* kpszMQMT_DATAGRAM =                   "MQMT_DATAGRAM\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQFMT_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQFMT_PFX =                       "MQFMT_\0";
static char* kpszMQFMT_NONE =                      "MQFMT_NONE\0";
static char* kpszMQFMT_ADMIN =                     "MQFMT_ADMIN\0";
static char* kpszMQFMT_CHANNEL_COMPLETED =         "MQFMT_CHANNEL_COMPLETED\0";
static char* kpszMQFMT_CICS =                      "MQFMT_CICS\0";
static char* kpszMQFMT_COMMAND_1 =                 "MQFMT_COMMAND_1\0";
static char* kpszMQFMT_COMMAND_2 =                 "MQFMT_COMMAND_2\0";
static char* kpszMQFMT_DEAD_LETTER_HEADER =        "MQFMT_DEAD_LETTER_HEADER\0";
static char* kpszMQFMT_DIST_HEADER =               "MQFMT_DIST_HEADER\0";
static char* kpszMQFMT_EVENT =                     "MQFMT_EVENT\0";
static char* kpszMQFMT_IMS =                       "MQFMT_IMS\0";
static char* kpszMQFMT_IMS_VAR_STRING =            "MQFMT_IMS_VAR_STRING\0";
static char* kpszMQFMT_MD_EXTENSION =              "MQFMT_MD_EXTENSION\0";
static char* kpszMQFMT_PCF =                       "MQFMT_PCF\0";
static char* kpszMQFMT_REF_MSG_HEADER =            "MQFMT_REF_MSG_HEADER\0";
static char* kpszMQFMT_RF_HEADER =                 "MQFMT_RF_HEADER\0";
static char* kpszMQFMT_RF_HEADER_2 =               "MQFMT_RF_HEADER_2\0";
static char* kpszMQFMT_STRING =                    "MQFMT_STRING\0";
static char* kpszMQFMT_TRIGGER =                   "MQFMT_TRIGGER\0";
static char* kpszMQFMT_WORK_INFO_HEADER =          "MQFMT_WORK_INFO_HEADER\0";
static char* kpszMQFMT_XMIT_Q_HEADER =             "MQFMT_XMIT_Q_HEADER\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQMD_VERSION_ Values                                                                                             */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQMD_PFX =                        "MQMD_\0";
static char* kpszMQMD_STRUC_ID =                   "MQMD_STRUC_ID\0";
static char* kpszMQMD_VERSION_1 =                  "MQMD_VERSION_1\0";
static char* kpszMQMD_VERSION_2 =                  "MQMD_VERSION_2\0";
static char* kpszMQMD_CURRENT_VERSION =            "MQMD_CURRENT_VERSION\0";
/*------------------------------------------------------------------------------------------------------------------*/
/* MQEI_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQEI_PFX =                        "MQEI_\0";
static char* kpszMQEI_UNLIMITED =                  "MQEI_UNLIMITED\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQFB_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQFB_PFX =                        "MQFB_\0";
static char* kpszMQFB_NONE =                       "MQFB_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQPRI_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQPRI_PFX =                       "MQPRI_\0";
static char* kpszMQPRI_PRIORITY_AS_Q_DEF =         "MQPRI_PRIORITY_AS_Q_DEF\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQPRI_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQPER_PFX =                       "MQPER_\0";
static char* kpszMQPER_NOT_PERSISTENT =            "MQPER_NOT_PERSISTENT\0";
static char* kpszMQPER_PERSISTENT =                "MQPER_PERSISTENT\0";
static char* kpszMQPER_PERSISTENCE_AS_Q_DEF =      "MQPER_PERSISTENCE_AS_Q_DEF\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQOL_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQOL_PFX =                        "MQOL_\0";
static char* kpszMQOL_UNDEFINED =                  "MQOL_UNDEFINED\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQENC_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQENC_PFX =                       "MQENC_\0";
static char* kpszMQENC_NATIVE =                    "MQENC_NATIVE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCCSI_ Values                                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCCSI_PFX =                      "MQCCSI_\0";
static char* kpszMQCCSI_UNDEFINED =                "MQCCSI_UNDEFINED\0";
static char* kpszMQCCSI_DEFAULT =                  "MQCCSI_DEFAULT\0";
static char* kpszMQCCSI_Q_MGR =                    "MQCCSI_Q_MGR\0";
static char* kpszMQCCSI_INHERIT =                  "MQCCSI_INHERIT\0";
static char* kpszMQCCSI_EMBEDDED =                 "MQCCSI_EMBEDDED\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQMI_NONE, MQCI_NONE, MQGI_NONE Values                                                                           */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQMI_PFX =                        "MQMI_\0";
static char* kpszMQMI_NONE =                       "MQMI_NONE\0";
static char* kpszMQCI_PFX =                        "MQCI_\0";
static char* kpszMQCI_NONE =                       "MQCI_NONE\0";
static char* kpszMQGI_PFX =                        "MQGI_\0";
static char* kpszMQGI_NONE =                       "MQGI_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQACT_NONE Values                                                                                                */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQACT_PFX =                       "MQACT_\0";
static char* kpszMQACT_NONE =                      "MQACT_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQAT_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQAT_PFX =                        "MQAT_\0";
static char* kpszMQAT_UNKNOWN =                    "MQAT_UNKNOWN\0";
static char* kpszMQAT_NO_CONTEXT =                 "MQAT_NO_CONTEXT\0";
static char* kpszMQAT_CICS =                       "MQAT_CICS\0";
static char* kpszMQAT_MVS =                        "MQAT_MVS\0";
static char* kpszMQAT_OS390 =                      "MQAT_OS390\0";
static char* kpszMQAT_ZOS =                        "MQAT_ZOS\0";
static char* kpszMQAT_IMS =                        "MQAT_IMS\0";
static char* kpszMQAT_OS2 =                        "MQAT_OS2\0";
static char* kpszMQAT_DOS =                        "MQAT_DOS\0";
static char* kpszMQAT_AIX =                        "MQAT_AIX\0";
static char* kpszMQAT_UNIX =                       "MQAT_UNIX\0";
static char* kpszMQAT_QMGR =                       "MQAT_QMGR\0";
static char* kpszMQAT_OS400 =                      "MQAT_OS400\0";
static char* kpszMQAT_WINDOWS =                    "MQAT_WINDOWS\0";
static char* kpszMQAT_CICS_VSE =                   "MQAT_CICS_VSE\0";
static char* kpszMQAT_WINDOWS_NT =                 "MQAT_WINDOWS_NT\0";
static char* kpszMQAT_VMS =                        "MQAT_VMS\0";
static char* kpszMQAT_GUARDIAN =                   "MQAT_GUARDIAN\0";
static char* kpszMQAT_NSK =                        "MQAT_NSK\0";
static char* kpszMQAT_VOS =                        "MQAT_VOS\0";
static char* kpszMQAT_IMS_BRIDGE =                 "MQAT_IMS_BRIDGE\0";
static char* kpszMQAT_XCF =                        "MQAT_XCF\0";
static char* kpszMQAT_CICS_BRIDGE =                "MQAT_CICS_BRIDGE\0";
static char* kpszMQAT_NOTES_AGENT =                "MQAT_NOTES_AGENT\0";
static char* kpszMQAT_USER =                       "MQAT_USER\0";
static char* kpszMQAT_BROKER =                     "MQAT_BROKER\0";
static char* kpszMQAT_JAVA =                       "MQAT_JAVA\0";
static char* kpszMQAT_DQM =                        "MQAT_DQM\0";
static char* kpszMQAT_CHANNEL_INITIATOR =          "MQAT_CHANNEL_INITIATOR\0";
static char* kpszMQAT_DEFAULT =                    "MQAT_DEFAULT\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQIIH_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQIIH_PFX =                       "MQIIH_\0";
static char* kpszMQIIH_STRUC_ID =                  "MQIIH_STRUC_ID\0";
static char* kpszMQIIH_VERSION_1 =                 "MQIIH_VERSION_1\0";
static char* kpszMQIIH_CURRENT_VERSION =           "MQIIH_CURRENT_VERSION\0";
static char* kpszMQIIH_LENGTH_1 =                  "MQIIH_LENGTH_1\0";
static char* kpszMQIIH_NONE =                      "MQIIH_NONE\0";
static char* kpszMQIIH_PASS_EXPIRATION =           "MQIIH_PASS_EXPIRATION\0";
static char* kpszMQIIH_UNLIMITED_EXPIRATION =      "MQIIH_UNLIMITED_EXPIRATION\0";
static char* kpszMQIIH_REPLY_FORMAT_NONE =         "MQIIH_REPLY_FORMAT_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQIAUT_ Values                                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQIAUT_PFX =                      "MQIAUT_\0";
static char* kpszMQIAUT_NONE =                     "MQIAUT_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQITII_ Values                                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQITII_PFX =                      "MQITII_\0";
static char* kpszMQITII_NONE =                     "MQITII_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQITS_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQITS_PFX =                       "MQITS_\0";
static char* kpszMQITS_IN_CONVERSATION =           "MQITS_IN_CONVERSATION\0";
static char* kpszMQITS_NOT_IN_CONVERSATION =       "MQITS_NOT_IN_CONVERSATION\0";
static char* kpszMQITS_ARCHITECTED =               "MQITS_ARCHITECTED\0";
static char  kpszMQITS_IN_CONVERSATION_VALUE =     MQITS_IN_CONVERSATION;
static char  kpszMQITS_NOT_IN_CONVERSATION_VALUE = MQITS_NOT_IN_CONVERSATION;
static char  kpszMQITS_ARCHITECTED_VALUE =         MQITS_ARCHITECTED;

/*------------------------------------------------------------------------------------------------------------------*/
/* MQICM_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQICM_PFX =                       "MQICM_\0";
static char* kpszMQICM_COMMIT_THEN_SEND =          "MQICM_COMMIT_THEN_SEND\0";
static char* kpszMQICM_SEND_THEN_COMMIT =          "MQICM_SEND_THEN_COMMIT\0";
static char  kpszMQICM_COMMIT_THEN_SEND_VALUE =    MQICM_COMMIT_THEN_SEND;
static char  kpszMQICM_SEND_THEN_COMMIT_VALUE =    MQICM_SEND_THEN_COMMIT;

/*------------------------------------------------------------------------------------------------------------------*/
/* MQISS_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQISS_PFX =                       "MQISS_\0";
static char* kpszMQISS_CHECK =                     "MQISS_CHECK\0";
static char* kpszMQISS_FULL =                      "MQISS_FULL\0";
static char  kpszMQISS_CHECK_VALUE =               MQISS_CHECK;
static char  kpszMQISS_FULL_VALUE =                MQISS_FULL;

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCIH_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCIH_PFX =                       "MQCIH_\0";
static char* kpszMQCIH_STRUC_ID =                  "MQCIH_STRUC_ID\0";
static char* kpszMQCIH_VERSION_1 =                 "MQCIH_VERSION_1\0";
static char* kpszMQCIH_VERSION_2 =                 "MQCIH_VERSION_2\0";
static char* kpszMQCIH_CURRENT_VERSION =           "MQCIH_CURRENT_VERSION\0";
static char* kpszMQCIH_LENGTH_1 =                  "MQCIH_LENGTH_1\0";
static char* kpszMQCIH_LENGTH_2 =                  "MQCIH_LENGTH_2\0";
static char* kpszMQCIH_CURRENT_LENGTH =            "MQCIH_CURRENT_LENGTH\0";
static char* kpszMQCIH_NONE =                      "MQCIH_NONE\0";
static char* kpszMQCIH_PASS_EXPIRATION =           "MQCIH_PASS_EXPIRATION\0";
static char* kpszMQCIH_UNLIMITED_EXPIRATION =      "MQCIH_UNLIMITED_EXPIRATION\0";
static char* kpszMQCIH_REPLY_WITHOUT_NULLS =       "MQCIH_REPLY_WITHOUT_NULLS\0";
static char* kpszMQCIH_REPLY_WITH_NULLS =          "MQCIH_REPLY_WITH_NULLS\0";
static char* kpszMQCIH_SYNC_ON_RETURN =            "MQCIH_SYNC_ON_RETURN\0";
static char* kpszMQCIH_NO_SYNC_ON_RETURN =         "MQCIH_NO_SYNC_ON_RETURN\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCRC_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCRC_PFX =                       "MQCRC_\0";
static char* kpszMQCRC_OK =                        "MQCRC_OK\0";
static char* kpszMQCRC_CICS_EXEC_ERROR =           "MQCRC_CICS_EXEC_ERROR\0";
static char* kpszMQCRC_MQ_API_ERROR =              "MQCRC_MQ_API_ERROR\0";
static char* kpszMQCRC_BRIDGE_ERROR =              "MQCRC_BRIDGE_ERROR\0";
static char* kpszMQCRC_BRIDGE_ABEND =              "MQCRC_BRIDGE_ABEND\0";
static char* kpszMQCRC_APPLICATION_ABEND =         "MQCRC_APPLICATION_ABEND\0";
static char* kpszMQCRC_SECURITY_ERROR =            "MQCRC_SECURITY_ERROR\0";
static char* kpszMQCRC_PROGRAM_NOT_AVAILABLE =     "MQCRC_PROGRAM_NOT_AVAILABLE\0";
static char* kpszMQCRC_BRIDGE_TIMEOUT =            "MQCRC_BRIDGE_TIMEOUT\0";
static char* kpszMQCRC_TRANSID_NOT_AVAILABLE =     "MQCRC_TRANSID_NOT_AVAILABLE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCC_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCC_PFX =                        "MQCC_\0";
static char* kpszMQCC_OK =                         "MQCC_OK\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQRC_ Values                                                                                                     */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQRC_PFX =                        "MQRC_\0";
static char* kpszMQRC_NONE =                       "MQRC_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCUOWC_ Values                                                                                                  */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCUOWC_PFX =                     "MQCUOWC_\0";
static char* kpszMQCUOWC_ONLY =                    "MQCUOWC_ONLY\0";
static char* kpszMQCUOWC_CONTINUE =                "MQCUOWC_CONTINUE\0";
static char* kpszMQCUOWC_FIRST =                   "MQCUOWC_FIRST\0";
static char* kpszMQCUOWC_MIDDLE =                  "MQCUOWC_MIDDLE\0";
static char* kpszMQCUOWC_LAST =                    "MQCUOWC_LAST\0";
static char* kpszMQCUOWC_COMMIT =                  "MQCUOWC_COMMIT\0";
static char* kpszMQCUOWC_BACKOUT =                 "MQCUOWC_BACKOUT\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCGWI_ Values                                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCGWI_PFX =                      "MQCGWI_\0";
static char* kpszMQCGWI_DEFAULT =                  "MQCGWI_DEFAULT\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCLT_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCLT_PFX =                       "MQCLT_\0";
static char* kpszMQCLT_PROGRAM =                   "MQCLT_PROGRAM\0";
static char* kpszMQCLT_TRANSACTION =               "MQCLT_TRANSACTION\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCODL_ Values                                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCODL_PFX =                      "MQCODL_\0";
static char* kpszMQCODL_AS_INPUT =                 "MQCODL_AS_INPUT\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCADSD_ Values                                                                                                  */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCADSD_PFX =                     "MQCADSD_\0";
static char* kpszMQCADSD_NONE =                    "MQCADSD_NONE\0";
static char* kpszMQCADSD_SEND =                    "MQCADSD_SEND\0";
static char* kpszMQCADSD_RECV =                    "MQCADSD_RECV\0";
static char* kpszMQCADSD_MSGFORMAT =               "MQCADSD_MSGFORMAT\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCCT_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCCT_PFX =                       "MQCCT_\0";
static char* kpszMQCCT_YES =                       "MQCCT_YES\0";
static char* kpszMQCCT_NO =                        "MQCCT_NO\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCTES_ Values                                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCTES_PFX =                      "MQCTES_\0";
static char* kpszMQCTES_NOSYNC =                   "MQCTES_NOSYNC\0";
static char* kpszMQCTES_COMMIT =                   "MQCTES_COMMIT\0";
static char* kpszMQCTES_BACKOUT =                  "MQCTES_BACKOUT\0";
static char* kpszMQCTES_ENDTASK =                  "MQCTES_ENDTASK\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCFAC_ Values                                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCFAC_PFX =                      "MQCFAC_\0";
static char* kpszMQCFAC_NONE =                     "MQCFAC_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCFUNC_ Values                                                                                                  */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCFUNC_PFX =                     "MQCFUNC_\0";
static char* kpszMQCFUNC_MQCONN =                  "MQCFUNC_MQCONN\0";
static char* kpszMQCFUNC_MQGET =                   "MQCFUNC_MQGET\0";
static char* kpszMQCFUNC_MQINQ =                   "MQCFUNC_MQINQ\0";
static char* kpszMQCFUNC_MQOPEN =                  "MQCFUNC_MQOPEN\0";
static char* kpszMQCFUNC_MQPUT =                   "MQCFUNC_MQPUT\0";
static char* kpszMQCFUNC_MQPUT1 =                  "MQCFUNC_MQPUT1\0";
static char* kpszMQCFUNC_NONE =                    "MQCFUNC_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQCSC_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQCSC_PFX =                       "MQCSC_\0";
static char* kpszMQCSC_START =                     "MQCSC_START\0";
static char* kpszMQCSC_STARTDATA =                 "MQCSC_STARTDATA\0";
static char* kpszMQCSC_TERMINPUT =                 "MQCSC_TERMINPUT\0";
static char* kpszMQCSC_NONE =                      "MQCSC_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* MQRFH_ Values                                                                                                    */
/*------------------------------------------------------------------------------------------------------------------*/
static char* kpszMQRFH_PFX =                       "MQRFH_\0";
static char* kpszMQRFH_STRUC_ID =                  "MQRFH_STRUC_ID\0";
static char* kpszMQRFH_VERSION_1 =                 "MQRFH_VERSION_1\0";
static char* kpszMQRFH_VERSION_2 =                 "MQRFH_VERSION_2\0";
static char* kpszMQRFH_NONE =                      "MQRFH_NONE\0";

/*------------------------------------------------------------------------------------------------------------------*/
/* Special values used by MsgTest                                                                                   */
/*------------------------------------------------------------------------------------------------------------------*/
static unsigned long klFFFFFFFF =                  0xffffffff;
static unsigned long klDEADBEEF =                  0xdeadbeef;

/*==========================================================================*/
/* FUNCTION:                                                                */
/*     ResolveCharCmqValue                                                  */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Translate a cmq header file constant to its actual value             */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB           Pointer to the current test info block               */
/*     lpBIB           Pointer to the buffer info block                     */
/*     kpszCmqValue    Pointer to string containg cmq header values         */
/*     loutputDataLen  Length of the output data field                      */
/*     bCmqValues      Field can contain CmqValues                          */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     TRUE or FALSE on whether buffer was set to a CmqValue                */
/*==========================================================================*/
long
ResolveCharCmqValue(TestInfoBlk* lpTIB, BuffInfoBlk* lpBIB,
                    const char* const kpszCmqValue,
                    long lOutputDataLen,
                    long bCmqValues)
{
    char* lpszTrimmedCmqValue;
    char  lpszWorkBuff[WORK_BUFF_LEN + 4];

    /* Initialise the buffer including a buffer changed detection value */
    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
    memcpy(lpszWorkBuff, &klDEADBEEF, sizeof(long));

    /* If field does not accept CmqValues return FALSE */
    if(FALSE == bCmqValues)
    {
        return FALSE;
    }

    lpszTrimmedCmqValue = TrimString(kpszCmqValue);
    /* Determine how to call TranslateToValue */
    if(0 == memcmp(kpszMQMD_PFX, lpszTrimmedCmqValue, strlen(kpszMQMD_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQMD);
    }
    else if(0 == memcmp(kpszMQFMT_PFX, lpszTrimmedCmqValue, strlen(kpszMQFMT_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQFMT);
    }
    else if(0 == memcmp(kpszMQMI_PFX, lpszTrimmedCmqValue, strlen(kpszMQMI_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQMI);
    }
    else if(0 == memcmp(kpszMQCI_PFX, lpszTrimmedCmqValue, strlen(kpszMQCI_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCI);
    }
    else if(0 == memcmp(kpszMQGI_PFX, lpszTrimmedCmqValue, strlen(kpszMQGI_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQGI);
    }
    else if(0 == memcmp(kpszMQACT_PFX, lpszTrimmedCmqValue, strlen(kpszMQACT_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQACT);
    }
    else if(0 == memcmp(kpszMQRFH_PFX, lpszTrimmedCmqValue, strlen(kpszMQRFH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQRFH);
    }
    else if(0 == memcmp(kpszMQIIH_PFX, lpszTrimmedCmqValue, strlen(kpszMQIIH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQIIH);
    }
    else if(0 == memcmp(kpszMQIAUT_PFX, lpszTrimmedCmqValue, strlen(kpszMQIAUT_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQIAUT);
    }
    else if(0 == memcmp(kpszMQITII_PFX, lpszTrimmedCmqValue, strlen(kpszMQITII_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQITII);
    }
    else if(0 == memcmp(kpszMQITS_PFX, lpszTrimmedCmqValue, strlen(kpszMQITS_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQITS);
    }
    else if(0 == memcmp(kpszMQICM_PFX, lpszTrimmedCmqValue, strlen(kpszMQICM_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQICM);
    }
    else if(0 == memcmp(kpszMQISS_PFX, lpszTrimmedCmqValue, strlen(kpszMQISS_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQISS);
    }
    else if(0 == memcmp(kpszMQCIH_PFX, lpszTrimmedCmqValue, strlen(kpszMQCIH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCIH);
    }
    else if(0 == memcmp(kpszMQCFAC_PFX, lpszTrimmedCmqValue, strlen(kpszMQCFAC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCFAC);
    }
    else if(0 == memcmp(kpszMQCFUNC_PFX, lpszTrimmedCmqValue, strlen(kpszMQCFUNC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCFUNC);
    }
    else if(0 == memcmp(kpszMQCSC_PFX, lpszTrimmedCmqValue, strlen(kpszMQCSC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCSC);
    }
    else
    {
        FreeIfNotNull((void**)&lpszTrimmedCmqValue);
        return FALSE;
    }

    /* If the work buffer remains unchanged return FALSE */
    if(0 == memcmp(lpszWorkBuff, &klDEADBEEF, sizeof(long)))
    {
        FreeIfNotNull((void**)&lpszTrimmedCmqValue);
        return FALSE;
    }

    /* Copy the data from the work buffer */
    memcpy(lpBIB->lpszBuff + lpBIB->lDataLen, lpszWorkBuff, lOutputDataLen);

    FreeIfNotNull((void**)&lpszTrimmedCmqValue);
    return TRUE;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     ResolveHexCmqValue                                                   */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Translate a cmq header file constant to it actual value              */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB           Pointer to the current test info block               */
/*     lpBIB           Pointer to the buffer info block                     */
/*     kpszCmqValue    Pointer to string containg cmq header values         */
/*     loutputDataLen  Length of the output data field                      */
/*     bCmqValues      Field can contain CmqValues                          */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     TRUE or FALSE on whether buffer was set to a CmqValue                */
/*==========================================================================*/
long
ResolveHexCmqValue(TestInfoBlk* lpTIB, BuffInfoBlk* lpBIB,
                    const char* const kpszCmqValue,
                    long lOutputDataLen,
                    long bCmqValues)
{
    char* lpszTrimmedCmqValue;
    char  lpszWorkBuff[WORK_BUFF_LEN + 4];

    /* Initialise the buffer including a buffer changed detection value */
    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
    memcpy(lpszWorkBuff, &klDEADBEEF, sizeof(long));

    /* If field does not accept CmqValues return FALSE */
    if(FALSE == bCmqValues)
    {
        return FALSE;
    }

    lpszTrimmedCmqValue = TrimString(kpszCmqValue);
    /* Determine how to call TranslateToValue */
    if(0 == memcmp(kpszMQRFH_PFX, lpszTrimmedCmqValue, strlen(kpszMQRFH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQRFH);
    }
    else if(0 == memcmp(kpszMQIIH_PFX, lpszTrimmedCmqValue, strlen(kpszMQIIH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQIIH);
    }
    else if(0 == memcmp(kpszMQCIH_PFX, lpszTrimmedCmqValue, strlen(kpszMQCIH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCIH);
    }
    else if(0 == memcmp(kpszMQCUOWC_PFX, lpszTrimmedCmqValue, strlen(kpszMQCUOWC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCUOWC);
    }
    else if(0 == memcmp(kpszMQCADSD_PFX, lpszTrimmedCmqValue, strlen(kpszMQCADSD_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCADSD);
    }
    else if(0 == memcmp(kpszMQCCT_PFX, lpszTrimmedCmqValue, strlen(kpszMQCCT_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCCT);
    }
    else if(0 == memcmp(kpszMQCTES_PFX, lpszTrimmedCmqValue, strlen(kpszMQCTES_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCTES);
    }
    else
    {
        FreeIfNotNull((void**)&lpszTrimmedCmqValue);
        return FALSE;
    }

    /* If the work buffer remains unchanged return FALSE */
    if(0 == memcmp(lpszWorkBuff, &klDEADBEEF, sizeof(long)))
    {
        FreeIfNotNull((void**)&lpszTrimmedCmqValue);
        return FALSE;
    }

    /* Copy the data from the work buffer */
    memcpy(lpBIB->lpszBuff + lpBIB->lDataLen, lpszWorkBuff, lOutputDataLen);

    FreeIfNotNull((void**)&lpszTrimmedCmqValue);
    return TRUE;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     ResolveIntCmqValue                                                   */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Translate a cmq header file constant to it actual value              */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB           Pointer to the current test info block               */
/*     lpBIB           Pointer to the buffer info block                     */
/*     kpszCmqValue    Pointer to string containg cmq header values         */
/*     loutputDataLen  Length of the output data field                      */
/*     bCmqValues      Field can contain CmqValues                          */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     TRUE or FALSE on whether buffer was set to a CmqValue                */
/*==========================================================================*/
long
ResolveIntCmqValue(TestInfoBlk* lpTIB, BuffInfoBlk* lpBIB,
                    const char* const kpszCmqValue,
                    long lOutputDataLen,
                    long bCmqValues)
{
    char* lpszTrimmedCmqValue;
    char  lpszWorkBuff[WORK_BUFF_LEN + 4];

    /* Initialise the buffer including a buffer changed detection value */
    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
    memcpy(lpszWorkBuff, &klDEADBEEF, sizeof(long));

    /* If field does not accept CmqValues return FALSE */
    if(FALSE == bCmqValues)
    {
        return FALSE;
    }

    lpszTrimmedCmqValue = TrimString(kpszCmqValue);
    /* Determine how to call TranslateToValue */
    if(0 == memcmp(kpszMQMD_PFX, lpszTrimmedCmqValue, strlen(kpszMQMD_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQMD);
    }
    else if(0 == memcmp(kpszMQRO_PFX, lpszTrimmedCmqValue, strlen(kpszMQRO_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQRO);
    }
    else if(0 == memcmp(kpszMQMT_PFX, lpszTrimmedCmqValue, strlen(kpszMQMT_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQMT);
    }
    else if(0 == memcmp(kpszMQEI_PFX, lpszTrimmedCmqValue, strlen(kpszMQEI_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQEI);
    }
    else if(0 == memcmp(kpszMQFB_PFX, lpszTrimmedCmqValue, strlen(kpszMQFB_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQFB);
    }
    else if(0 == memcmp(kpszMQENC_PFX, lpszTrimmedCmqValue, strlen(kpszMQENC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQENC);
    }
    else if(0 == memcmp(kpszMQCCSI_PFX, lpszTrimmedCmqValue, strlen(kpszMQCCSI_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCCSI);
    }
    else if(0 == memcmp(kpszMQPRI_PFX, lpszTrimmedCmqValue, strlen(kpszMQPRI_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQPRI);
    }
    else if(0 == memcmp(kpszMQPER_PFX, lpszTrimmedCmqValue, strlen(kpszMQPER_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQPER);
    }
    else if(0 == memcmp(kpszMQAT_PFX, lpszTrimmedCmqValue, strlen(kpszMQAT_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQAT);
    }
    else if(0 == memcmp(kpszMQMF_PFX, lpszTrimmedCmqValue, strlen(kpszMQMF_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQMF);
    }
    else if(0 == memcmp(kpszMQOL_PFX, lpszTrimmedCmqValue, strlen(kpszMQOL_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQOL);
    }
    else if(0 == memcmp(kpszMQRFH_PFX, lpszTrimmedCmqValue, strlen(kpszMQRFH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQRFH);
    }
    else if(0 == memcmp(kpszMQIIH_PFX, lpszTrimmedCmqValue, strlen(kpszMQIIH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQIIH);
    }
    else if(0 == memcmp(kpszMQCIH_PFX, lpszTrimmedCmqValue, strlen(kpszMQCIH_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCIH);
    }
    else if(0 == memcmp(kpszMQCRC_PFX, lpszTrimmedCmqValue, strlen(kpszMQCRC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCRC);
    }
    else if(0 == memcmp(kpszMQCC_PFX, lpszTrimmedCmqValue, strlen(kpszMQCC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCC);
    }
    else if(0 == memcmp(kpszMQRC_PFX, lpszTrimmedCmqValue, strlen(kpszMQRC_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQRC);
    }
    else if(0 == memcmp(kpszMQCGWI_PFX, lpszTrimmedCmqValue, strlen(kpszMQCGWI_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCGWI);
    }
    else if(0 == memcmp(kpszMQCLT_PFX, lpszTrimmedCmqValue, strlen(kpszMQCLT_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCLT);
    }
    else if(0 == memcmp(kpszMQCODL_PFX, lpszTrimmedCmqValue, strlen(kpszMQCODL_PFX)))
    {
        TranslateToValue(lpTIB, lpszWorkBuff, NULL, lpszTrimmedCmqValue, Q_MQCODL);
    }
    else
    {
        FreeIfNotNull((void**)&lpszTrimmedCmqValue);
        return FALSE;
    }

    /* If the work buffer remains unchanged return FALSE */
    if(0 == memcmp(lpszWorkBuff, &klDEADBEEF, sizeof(long)))
    {
        FreeIfNotNull((void**)&lpszTrimmedCmqValue);
        return FALSE;
    }

    /* Copy the data from the work buffer */
    memcpy(lpBIB->lpszBuff + lpBIB->lDataLen, lpszWorkBuff, lOutputDataLen);

    FreeIfNotNull((void**)&lpszTrimmedCmqValue);
    return TRUE;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     TranslateToValue                                                     */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Translate a cmq header file constant to it actual value              */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB           Pointer to the current test info block               */
/*     vpResult        Pointer to the result location                       */
/*     vpInitialValue  Pointer to the initial value                         */
/*     kpszCmqValue    Pointer to string containg cmq header values         */
/*     eCmqValueType   Type of value we are trying to translate             */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
TranslateToValue(TestInfoBlk* lpTIB, void* vpResult, void* vpInitialValue,
                 const char* const kpszCmqValue,
                 enum eCmqValueTypeEnum eCmqValueType)
{
    char* lpszTrimmedCmqValue;
    char* lpszStartToken;
    char* lpszEndToken;
    char* lpszMaxPos;
    long* lplLongResult;
    long  bGotToken;
    long  lCopyLen;
    long  lCompareLen;
    long  lWorkCopyLen;
    char  lpszWorkBuff[WORK_BUFF_LEN + 4];

    /* Initialise pointers */
    lpszTrimmedCmqValue = TrimString(kpszCmqValue);
    lpszStartToken = lpszTrimmedCmqValue;
    lpszEndToken = lpszTrimmedCmqValue;
    lpszMaxPos = lpszStartToken + StrlenNull(lpszTrimmedCmqValue);

    /* Now depending on the requested value type see if we have a match for */
    /* any of our supported MQ tokens from the cmq header files             */
    switch(eCmqValueType)
    {
    case Q_MQGMO:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQGMO\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQGMO_WAIT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_WAIT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_WAIT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_NO_WAIT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_NO_WAIT, lCompareLen)))
                    {
                        /* Interpreted by MsgTest to mean turn off */
                        /* the MQGMO_WAIT bit                      */
                        TurnOffBits(lplLongResult, MQGMO_WAIT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_SET_SIGNAL)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_SET_SIGNAL, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_SET_SIGNAL);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_FAIL_IF_QUIESCING)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_FAIL_IF_QUIESCING, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_FAIL_IF_QUIESCING);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_SYNCPOINT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_SYNCPOINT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_SYNCPOINT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_SYNCPOINT_IF_PERSISTENT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_SYNCPOINT_IF_PERSISTENT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_SYNCPOINT_IF_PERSISTENT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_NO_SYNCPOINT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_NO_SYNCPOINT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_NO_SYNCPOINT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_MARK_SKIP_BACKOUT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_MARK_SKIP_BACKOUT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_MARK_SKIP_BACKOUT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_BROWSE_FIRST)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_BROWSE_FIRST, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_BROWSE_FIRST);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_BROWSE_NEXT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_BROWSE_NEXT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_BROWSE_NEXT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_BROWSE_MSG_UNDER_CURSOR)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_BROWSE_MSG_UNDER_CURSOR, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_BROWSE_MSG_UNDER_CURSOR);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_MSG_UNDER_CURSOR)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_MSG_UNDER_CURSOR, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_MSG_UNDER_CURSOR);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_LOCK)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_LOCK, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_LOCK);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_UNLOCK)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_UNLOCK, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_UNLOCK);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_ACCEPT_TRUNCATED_MSG)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_ACCEPT_TRUNCATED_MSG, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_ACCEPT_TRUNCATED_MSG);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_CONVERT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_CONVERT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_CONVERT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_LOGICAL_ORDER)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_LOGICAL_ORDER, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_LOGICAL_ORDER);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_COMPLETE_MSG)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_COMPLETE_MSG, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_COMPLETE_MSG);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_ALL_MSGS_AVAILABLE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_ALL_MSGS_AVAILABLE, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_ALL_MSGS_AVAILABLE);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_ALL_SEGMENTS_AVAILABLE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_ALL_SEGMENTS_AVAILABLE, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQGMO_ALL_SEGMENTS_AVAILABLE);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQGMO_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQGMO_NONE, lCompareLen)))
                    {
                        *lplLongResult = MQGMO_NONE;
                    }
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQGMO\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQGMO\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQPMO:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQPMO\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQPMO_SYNCPOINT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_SYNCPOINT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_SYNCPOINT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_NO_SYNCPOINT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_NO_SYNCPOINT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_NO_SYNCPOINT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_NEW_MSG_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_NEW_MSG_ID, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_NEW_MSG_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_NEW_CORREL_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_NEW_CORREL_ID, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_NEW_CORREL_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_LOGICAL_ORDER)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_LOGICAL_ORDER, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_LOGICAL_ORDER);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_NO_CONTEXT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_NO_CONTEXT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_NO_CONTEXT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_DEFAULT_CONTEXT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_DEFAULT_CONTEXT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_DEFAULT_CONTEXT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_PASS_IDENTITY_CONTEXT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_PASS_IDENTITY_CONTEXT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_PASS_IDENTITY_CONTEXT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_PASS_ALL_CONTEXT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_PASS_ALL_CONTEXT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_PASS_ALL_CONTEXT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_SET_IDENTITY_CONTEXT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_SET_IDENTITY_CONTEXT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_SET_IDENTITY_CONTEXT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_SET_ALL_CONTEXT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_SET_ALL_CONTEXT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_SET_ALL_CONTEXT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_ALTERNATE_USER_AUTHORITY)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_ALTERNATE_USER_AUTHORITY, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_ALTERNATE_USER_AUTHORITY);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_FAIL_IF_QUIESCING)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_FAIL_IF_QUIESCING, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQPMO_FAIL_IF_QUIESCING);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQPMO_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQPMO_NONE, lCompareLen)))
                    {
                        *lplLongResult = MQPMO_NONE;
                    }
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQPMO\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQPMO\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQMO:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQMO\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 9);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQMO_MATCH_MSG_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMO_MATCH_MSG_ID, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMO_MATCH_MSG_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMO_MATCH_CORREL_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMO_MATCH_CORREL_ID, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMO_MATCH_CORREL_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMO_MATCH_GROUP_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMO_MATCH_GROUP_ID, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMO_MATCH_GROUP_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMO_MATCH_MSG_SEQ_NUMBER)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMO_MATCH_MSG_SEQ_NUMBER, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMO_MATCH_MSG_SEQ_NUMBER);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMO_MATCH_OFFSET)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMO_MATCH_OFFSET, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMO_MATCH_OFFSET);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMO_MATCH_MSG_TOKEN)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMO_MATCH_MSG_TOKEN, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMO_MATCH_MSG_TOKEN);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMO_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMO_NONE, lCompareLen)))
                    {
                        *lplLongResult = MQMO_NONE;
                    }
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMO\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMO\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQRO:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQRO\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 8);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQRO_EXCEPTION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_EXCEPTION, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_EXCEPTION);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_EXCEPTION_WITH_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_EXCEPTION_WITH_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_EXCEPTION_WITH_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_EXCEPTION_WITH_FULL_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_EXCEPTION_WITH_FULL_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_EXCEPTION_WITH_FULL_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_EXPIRATION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_EXPIRATION, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_EXPIRATION);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_EXPIRATION_WITH_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_EXPIRATION_WITH_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_EXPIRATION_WITH_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_EXPIRATION_WITH_FULL_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_EXPIRATION_WITH_FULL_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_EXPIRATION_WITH_FULL_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_COA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_COA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_COA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_COA_WITH_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_COA_WITH_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_COA_WITH_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_COA_WITH_FULL_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_COA_WITH_FULL_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_COA_WITH_FULL_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_COD)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_COD, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_COD);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_COD_WITH_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_COD_WITH_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_COD_WITH_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_COD_WITH_FULL_DATA)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_COD_WITH_FULL_DATA, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_COD_WITH_FULL_DATA);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_PAN)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_PAN, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_PAN);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_NAN)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_NAN, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_NAN);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_NEW_MSG_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_NEW_MSG_ID, lCompareLen)))
                    {
                        /* Interpreted by MsgTest to mean turn off */
                        /* the MQRO_PASS_MSG_ID bit                */
                        TurnOffBits(lplLongResult, MQRO_PASS_MSG_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_PASS_MSG_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_PASS_MSG_ID, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_PASS_MSG_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_COPY_MSG_ID_TO_CORREL_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_COPY_MSG_ID_TO_CORREL_ID, lCompareLen)))
                    {
                        /* Interpreted by MsgTest to mean turn off */
                        /* the MQRO_PASS_MSG_ID and MQRO_PASS_CORREL_ID bits */
                        TurnOffBits(lplLongResult, (MQRO_PASS_MSG_ID | MQRO_PASS_CORREL_ID));
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_PASS_CORREL_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_PASS_CORREL_ID, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_PASS_CORREL_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_DEAD_LETTER_Q)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_DEAD_LETTER_Q, lCompareLen)))
                    {
                        /* Interpreted by MsgTest to mean turn off */
                        /* the MQRO_DISCARD_MSG bit                */
                        TurnOffBits(lplLongResult, MQRO_PASS_MSG_ID);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_DISCARD_MSG)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_DISCARD_MSG, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQRO_DISCARD_MSG);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRO_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRO_NONE, lCompareLen)))
                    {
                        /* Reset all the flags */
                        *lplLongResult = MQRO_NONE;
                    }
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQRO\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQRO\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQMT:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQMT\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQMT_REQUEST)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMT_REQUEST, lCompareLen)))
                {
                    *lplLongResult = MQMT_REQUEST;
                }
                else if((lCompareLen == StrlenNull(kpszMQMT_REPLY)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMT_REPLY, lCompareLen)))
                {
                    *lplLongResult = MQMT_REPLY;
                }
                else if((lCompareLen == StrlenNull(kpszMQMT_REPORT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMT_REPORT, lCompareLen)))
                {
                    *lplLongResult = MQMT_REPORT;
                }
                else if((lCompareLen == StrlenNull(kpszMQMT_DATAGRAM)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMT_DATAGRAM, lCompareLen)))
                {
                    *lplLongResult = MQMT_DATAGRAM;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMT\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMT\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQMF:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQMF\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 9);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQMF_SEGMENTATION_INHIBITED)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMF_SEGMENTATION_INHIBITED, lCompareLen)))
                    {
                        /* Interpreted by MsgTest to mean turn off */
                        /* the MQMF_SEGMENTATION_ALLOWED bit       */
                        TurnOffBits(lplLongResult, MQMF_SEGMENTATION_ALLOWED);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMF_SEGMENTATION_ALLOWED)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMF_SEGMENTATION_ALLOWED, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMF_SEGMENTATION_ALLOWED);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMF_MSG_IN_GROUP)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMF_MSG_IN_GROUP, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMF_MSG_IN_GROUP);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMF_LAST_MSG_IN_GROUP)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMF_LAST_MSG_IN_GROUP, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMF_LAST_MSG_IN_GROUP);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMF_SEGMENT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMF_SEGMENT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMF_SEGMENT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMF_LAST_SEGMENT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMF_LAST_SEGMENT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQMF_LAST_SEGMENT);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQMF_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQMF_NONE, lCompareLen)))
                    {
                        *lplLongResult = MQMF_NONE;
                    }
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMF\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMF\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQFMT:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_FORMAT_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 9))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQFMT_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_NONE, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_ADMIN)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_ADMIN, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_ADMIN, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_CHANNEL_COMPLETED)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_CHANNEL_COMPLETED, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_CHANNEL_COMPLETED, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_CICS)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_CICS, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_CICS, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_COMMAND_1)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_COMMAND_1, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_COMMAND_1, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_COMMAND_2)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_COMMAND_2, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_COMMAND_2, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_DEAD_LETTER_HEADER)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_DEAD_LETTER_HEADER, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_DEAD_LETTER_HEADER, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_DIST_HEADER)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_DIST_HEADER, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_DIST_HEADER, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_EVENT)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_EVENT, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_EVENT, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_IMS)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_IMS, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_IMS, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_IMS_VAR_STRING)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_IMS_VAR_STRING, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_IMS_VAR_STRING, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_MD_EXTENSION)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_MD_EXTENSION, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_MD_EXTENSION, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_PCF)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_PCF, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_PCF, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_REF_MSG_HEADER)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_REF_MSG_HEADER, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_REF_MSG_HEADER, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_RF_HEADER)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_RF_HEADER, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_RF_HEADER, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_RF_HEADER_2)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_RF_HEADER_2, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_RF_HEADER_2, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_STRING)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_STRING, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_STRING, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_TRIGGER)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_TRIGGER, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_TRIGGER, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_WORK_INFO_HEADER)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_WORK_INFO_HEADER, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_WORK_INFO_HEADER, MQ_FORMAT_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQFMT_XMIT_Q_HEADER)) &&
               (0 == memcmp(lpszStartToken, kpszMQFMT_XMIT_Q_HEADER, lCompareLen)))
            {
                memcpy(vpResult, MQFMT_XMIT_Q_HEADER, MQ_FORMAT_LENGTH);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_FORMAT_LENGTH < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQFMT\0", "Using first 8 characters\0");
                    lCopyLen = MQ_FORMAT_LENGTH;
                }
                /* Make sure shorter format strings are padded with blanks */
                memset(vpResult, ' ', MQ_FORMAT_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_FORMAT_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_FORMAT_LENGTH;
            }
            /* Make sure shorter format strings are padded with blanks */
            memset(vpResult, ' ', MQ_FORMAT_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQMI:
    case Q_MQCI:
    case Q_MQGI:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_MSG_ID_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 9))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQMI_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQMI_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQMI_NONE, MQ_MSG_ID_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCI_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQCI_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQCI_NONE, MQ_CORREL_ID_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQGI_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQGI_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQGI_NONE, MQ_GROUP_ID_LENGTH);
            }
            else
            {
                if(0 == memcmp(lpszStartToken, "MQM\0", 3))
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    switch(eCmqValueType)
                    {
                    case Q_MQMI:
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMI\0", "Using data as is\0");
                        break;
                    case Q_MQCI:
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCI\0", "Using data as is\0");
                        break;
                    case Q_MQGI:
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQGI\0", "Using data as is\0");
                        break;
                    }
                }
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_MSG_ID_LENGTH < lCopyLen)
                {
                    lCopyLen = MQ_MSG_ID_LENGTH;
                }
                /* Make sure shorter format strings are padded with nulls */
                memset(vpResult, 0x00, MQ_MSG_ID_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_MSG_ID_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_MSG_ID_LENGTH;
            }
            /* Make sure shorter format strings are padded with blanks */
            memset(vpResult, 0x00, MQ_MSG_ID_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQACT:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_ACCOUNTING_TOKEN_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQACT_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQACT_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQACT_NONE, MQ_ACCOUNTING_TOKEN_LENGTH);
            }
            else
            {
                if(0 == memcmp(lpszStartToken, "MQM\0", 3))
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    switch(eCmqValueType)
                    {
                    case Q_MQACT:
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQACT\0", "Using data as is\0");
                        break;
                    }
                }
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_ACCOUNTING_TOKEN_LENGTH < lCopyLen)
                {
                    lCopyLen = MQ_ACCOUNTING_TOKEN_LENGTH;
                }
                /* Make sure shorter format strings are padded with nulls */
                memset(vpResult, 0x00, MQ_ACCOUNTING_TOKEN_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_ACCOUNTING_TOKEN_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_ACCOUNTING_TOKEN_LENGTH;
            }
            /* Make sure shorter format strings are padded with blanks */
            memset(vpResult, 0x00, MQ_ACCOUNTING_TOKEN_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQAT:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQAT\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 8);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQAT_UNKNOWN)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_UNKNOWN, lCompareLen)))
                {
                    *lplLongResult = MQAT_UNKNOWN;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_NO_CONTEXT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_NO_CONTEXT, lCompareLen)))
                {
                    *lplLongResult = MQAT_NO_CONTEXT;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_CICS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_CICS, lCompareLen)))
                {
                    *lplLongResult = MQAT_CICS;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_MVS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_MVS, lCompareLen)))
                {
                    *lplLongResult = MQAT_MVS;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_OS390)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_OS390, lCompareLen)))
                {
                    *lplLongResult = MQAT_OS390;
                }
#ifdef MQAT_ZOS
                else if((lCompareLen == StrlenNull(kpszMQAT_ZOS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_ZOS, lCompareLen)))
                {
                    *lplLongResult = MQAT_ZOS;
                }
#endif
                else if((lCompareLen == StrlenNull(kpszMQAT_IMS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_IMS, lCompareLen)))
                {
                    *lplLongResult = MQAT_IMS;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_OS2)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_OS2, lCompareLen)))
                {
                    *lplLongResult = MQAT_OS2;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_DOS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_DOS, lCompareLen)))
                {
                    *lplLongResult = MQAT_DOS;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_AIX)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_AIX, lCompareLen)))
                {
                    *lplLongResult = MQAT_AIX;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_UNIX)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_UNIX, lCompareLen)))
                {
                    *lplLongResult = MQAT_UNIX;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_QMGR)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_QMGR, lCompareLen)))
                {
                    *lplLongResult = MQAT_QMGR;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_OS400)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_OS400, lCompareLen)))
                {
                    *lplLongResult = MQAT_OS400;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_WINDOWS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_WINDOWS, lCompareLen)))
                {
                    *lplLongResult = MQAT_WINDOWS;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_CICS_VSE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_CICS_VSE, lCompareLen)))
                {
                    *lplLongResult = MQAT_CICS_VSE;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_WINDOWS_NT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_WINDOWS_NT, lCompareLen)))
                {
                    *lplLongResult = MQAT_WINDOWS_NT;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_VMS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_VMS, lCompareLen)))
                {
                    *lplLongResult = MQAT_VMS;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_GUARDIAN)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_GUARDIAN, lCompareLen)))
                {
                    *lplLongResult = MQAT_GUARDIAN;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_NSK)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_NSK, lCompareLen)))
                {
                    *lplLongResult = MQAT_NSK;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_VOS)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_VOS, lCompareLen)))
                {
                    *lplLongResult = MQAT_VOS;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_IMS_BRIDGE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_IMS_BRIDGE, lCompareLen)))
                {
                    *lplLongResult = MQAT_IMS_BRIDGE;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_XCF)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_XCF, lCompareLen)))
                {
                    *lplLongResult = MQAT_XCF;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_CICS_BRIDGE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_CICS_BRIDGE, lCompareLen)))
                {
                    *lplLongResult = MQAT_CICS_BRIDGE;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_NOTES_AGENT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_NOTES_AGENT, lCompareLen)))
                {
                    *lplLongResult = MQAT_NOTES_AGENT;
                }
#ifdef MQAT_USER
                else if((lCompareLen == StrlenNull(kpszMQAT_USER)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_USER, lCompareLen)))
                {
                    *lplLongResult = MQAT_USER;
                }
#endif
                else if((lCompareLen == StrlenNull(kpszMQAT_BROKER)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_BROKER, lCompareLen)))
                {
                    *lplLongResult = MQAT_BROKER;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_JAVA)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_JAVA, lCompareLen)))
                {
                    *lplLongResult = MQAT_JAVA;
                }
                else if((lCompareLen == StrlenNull(kpszMQAT_DQM)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_DQM, lCompareLen)))
                {
                    *lplLongResult = MQAT_DQM;
                }
#ifdef MQAT_CHANNEL_INITIATOR
                else if((lCompareLen == StrlenNull(kpszMQAT_CHANNEL_INITIATOR)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_CHANNEL_INITIATOR, lCompareLen)))
                {
                    *lplLongResult = MQAT_CHANNEL_INITIATOR;
                }
#endif
                else if((lCompareLen == StrlenNull(kpszMQAT_DEFAULT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQAT_DEFAULT, lCompareLen)))
                {
                    *lplLongResult = MQAT_DEFAULT;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQAT\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQAT\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQMD:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQMD\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 13);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQMD_STRUC_ID)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMD_STRUC_ID, lCompareLen)))
                {
                    memcpy(lplLongResult, MQMD_STRUC_ID, sizeof(long));
                }
                else if((lCompareLen == StrlenNull(kpszMQMD_VERSION_1)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMD_VERSION_1, lCompareLen)))
                {
                    *lplLongResult = MQMD_VERSION_1;
                }
                else if((lCompareLen == StrlenNull(kpszMQMD_VERSION_2)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMD_VERSION_2, lCompareLen)))
                {
                    *lplLongResult = MQMD_VERSION_2;
                }
                else if((lCompareLen == StrlenNull(kpszMQMD_CURRENT_VERSION)) &&
                   (0 == memcmp(lpszStartToken, kpszMQMD_CURRENT_VERSION, lCompareLen)))
                {
                    *lplLongResult = MQMD_CURRENT_VERSION;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMD\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQMD\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQFB:    
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQFB\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 9);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQFB_NONE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQFB_NONE, lCompareLen)))
                {
                    *lplLongResult = MQFB_NONE;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQFB\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQFB\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQEI:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQEI\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 14);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQEI_UNLIMITED)) &&
                   (0 == memcmp(lpszStartToken, kpszMQEI_UNLIMITED, lCompareLen)))
                {
                    *lplLongResult = MQEI_UNLIMITED;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQEI\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQEI\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQPRI:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQPRI\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 23);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQPRI_PRIORITY_AS_Q_DEF)) &&
                   (0 == memcmp(lpszStartToken, kpszMQPRI_PRIORITY_AS_Q_DEF, lCompareLen)))
                {
                    *lplLongResult = MQPRI_PRIORITY_AS_Q_DEF;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQPRI\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQPRI\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQPER:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQPER\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 16);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQPER_NOT_PERSISTENT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQPER_NOT_PERSISTENT, lCompareLen)))
                {
                    *lplLongResult = MQPER_NOT_PERSISTENT;               
                }
                else if((lCompareLen == StrlenNull(kpszMQPER_PERSISTENT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQPER_PERSISTENT, lCompareLen)))
                {
                    *lplLongResult = MQPER_PERSISTENT;               
                }
                else if((lCompareLen == StrlenNull(kpszMQPER_PERSISTENCE_AS_Q_DEF)) &&
                   (0 == memcmp(lpszStartToken, kpszMQPER_PERSISTENCE_AS_Q_DEF, lCompareLen)))
                {
                    *lplLongResult = MQPER_PERSISTENCE_AS_Q_DEF;             
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQPER\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQPER\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQOL:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQOL\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 14);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQOL_UNDEFINED)) &&
                   (0 == memcmp(lpszStartToken, kpszMQOL_UNDEFINED, lCompareLen)))
                {
                    *lplLongResult = MQOL_UNDEFINED;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQOL\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQOL\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQENC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQENC\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 12);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQENC_NATIVE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQENC_NATIVE, lCompareLen)))
                {
                    *lplLongResult = MQENC_NATIVE;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQENC\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQENC\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCCSI:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCCSI\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 12);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCCSI_UNDEFINED)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCCSI_UNDEFINED, lCompareLen)))
                {
                    *lplLongResult = MQCCSI_UNDEFINED;
                }
                else if((lCompareLen == StrlenNull(kpszMQCCSI_DEFAULT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCCSI_DEFAULT, lCompareLen)))
                {
                    *lplLongResult = MQCCSI_DEFAULT;
                }
                else if((lCompareLen == StrlenNull(kpszMQCCSI_Q_MGR)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCCSI_Q_MGR, lCompareLen)))
                {
                    *lplLongResult = MQCCSI_Q_MGR;
                }
                else if((lCompareLen == StrlenNull(kpszMQCCSI_INHERIT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCCSI_INHERIT, lCompareLen)))
                {
                    *lplLongResult = MQCCSI_INHERIT;
                }
                else if((lCompareLen == StrlenNull(kpszMQCCSI_EMBEDDED)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCCSI_EMBEDDED, lCompareLen)))
                {
                    *lplLongResult = MQCCSI_EMBEDDED;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCCSI\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCCSI\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQIIH:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQIIH\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQIIH_STRUC_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_STRUC_ID, lCompareLen)))
                    {
                        memcpy(lplLongResult, MQIIH_STRUC_ID, 4);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQIIH_VERSION_1)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_VERSION_1, lCompareLen)))
                    {
                        *lplLongResult = MQIIH_VERSION_1;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQIIH_CURRENT_VERSION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_CURRENT_VERSION, lCompareLen)))
                    {
                        *lplLongResult = MQIIH_CURRENT_VERSION;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQIIH_LENGTH_1)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_LENGTH_1, lCompareLen)))
                    {
                        *lplLongResult = MQIIH_LENGTH_1;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQIIH_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_NONE, lCompareLen)))
                    {
                        *lplLongResult = MQIIH_NONE;
                    }
#ifdef MQIIH_PASS_EXPIRATION
                    else if((lCompareLen == StrlenNull(kpszMQIIH_PASS_EXPIRATION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_PASS_EXPIRATION, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQIIH_PASS_EXPIRATION);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQIIH_UNLIMITED_EXPIRATION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_UNLIMITED_EXPIRATION, lCompareLen)))
                    {
                        TurnOffBits(lplLongResult, MQIIH_PASS_EXPIRATION);
                    }
#endif
#ifdef MQIIH_REPLY_FORMAT_NONE
                    else if((lCompareLen == StrlenNull(kpszMQIIH_REPLY_FORMAT_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQIIH_REPLY_FORMAT_NONE, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQIIH_REPLY_FORMAT_NONE);
                    }
#endif
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQIIH\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQIIH\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQIAUT:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_AUTHENTICATOR_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 11))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQIAUT_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQIAUT_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQIAUT_NONE, MQ_AUTHENTICATOR_LENGTH);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_AUTHENTICATOR_LENGTH < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQIAUT\0", "Using first 8 characters\0");
                    lCopyLen = MQ_AUTHENTICATOR_LENGTH;
                }
                /* Make sure shorter authentication strings are padded with nulls */
                memset(vpResult, 0x00, MQ_AUTHENTICATOR_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_AUTHENTICATOR_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_AUTHENTICATOR_LENGTH;
            }
            /* Make sure shorter authentication strings are padded with nulls */
            memset(vpResult, 0x00, MQ_AUTHENTICATOR_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQITII:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_TRAN_INSTANCE_ID_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 11))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQITII_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQITII_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQITII_NONE, MQ_TRAN_INSTANCE_ID_LENGTH);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_TRAN_INSTANCE_ID_LENGTH < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQITII\0", "Using first 8 characters\0");
                    lCopyLen = MQ_TRAN_INSTANCE_ID_LENGTH;
                }
                /* Make sure shorter authentication strings are padded with nulls */
                memset(vpResult, 0x00, MQ_TRAN_INSTANCE_ID_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_TRAN_INSTANCE_ID_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_TRAN_INSTANCE_ID_LENGTH;
            }
            /* Make sure shorter authentication strings are padded with nulls */
            memset(vpResult, 0x00, MQ_TRAN_INSTANCE_ID_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQITS:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, 1);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 17))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQITS_IN_CONVERSATION)) &&
               (0 == memcmp(lpszStartToken, kpszMQITS_IN_CONVERSATION, lCompareLen)))
            {
                memcpy(vpResult, &kpszMQITS_IN_CONVERSATION_VALUE, 1);
            }
            else if((lCompareLen == StrlenNull(kpszMQITS_NOT_IN_CONVERSATION)) &&
               (0 == memcmp(lpszStartToken, kpszMQITS_NOT_IN_CONVERSATION, lCompareLen)))
            {
                memcpy(vpResult, &kpszMQITS_NOT_IN_CONVERSATION_VALUE, 1);
            }
            else if((lCompareLen == StrlenNull(kpszMQITS_ARCHITECTED)) &&
               (0 == memcmp(lpszStartToken, kpszMQITS_ARCHITECTED, lCompareLen)))
            {
                memcpy(vpResult, &kpszMQITS_ARCHITECTED_VALUE, 1);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(1 < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQITS\0", "Using first 8 characters\0");
                    lCopyLen = 1;
                }
                /* Make sure shorter strings are padded with blanks */
                memset(vpResult, ' ', 1);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(1 < lCopyLen)
            {
                lCopyLen = 1;
            }
            /* Make sure shorter strings are padded with blanks */
            memset(vpResult, ' ', 1);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQICM:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, 1);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 22))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQICM_COMMIT_THEN_SEND)) &&
               (0 == memcmp(lpszStartToken, kpszMQICM_COMMIT_THEN_SEND, lCompareLen)))
            {
                memcpy(vpResult, &kpszMQICM_COMMIT_THEN_SEND_VALUE, 1);
            }
            else if((lCompareLen == StrlenNull(kpszMQICM_SEND_THEN_COMMIT)) &&
               (0 == memcmp(lpszStartToken, kpszMQICM_SEND_THEN_COMMIT, lCompareLen)))
            {
                memcpy(vpResult, &kpszMQICM_SEND_THEN_COMMIT_VALUE, 1);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(1 < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQICM\0", "Using first 8 characters\0");
                    lCopyLen = 1;
                }
                /* Make sure shorter strings are padded with blanks */
                memset(vpResult, ' ', 1);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(1 < lCopyLen)
            {
                lCopyLen = 1;
            }
            /* Make sure shorter strings are padded with blanks */
            memset(vpResult, ' ', 1);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQISS:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, 1);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQISS_CHECK)) &&
               (0 == memcmp(lpszStartToken, kpszMQISS_CHECK, lCompareLen)))
            {
                memcpy(vpResult, &kpszMQISS_CHECK_VALUE, 1);
            }
            else if((lCompareLen == StrlenNull(kpszMQISS_FULL)) &&
               (0 == memcmp(lpszStartToken, kpszMQISS_FULL, lCompareLen)))
            {
                memcpy(vpResult, &kpszMQISS_FULL_VALUE, 1);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(1 < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQISS\0", "Using first 8 characters\0");
                    lCopyLen = 1;
                }
                /* Make sure shorter strings are padded with blanks */
                memset(vpResult, ' ', 1);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(1 < lCopyLen)
            {
                lCopyLen = 1;
            }
            /* Make sure shorter strings are padded with blanks */
            memset(vpResult, ' ', 1);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQCIH:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCIH\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQCIH_STRUC_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_STRUC_ID, lCompareLen)))
                    {
                        memcpy(lplLongResult, MQCIH_STRUC_ID, 4);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_VERSION_1)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_VERSION_1, lCompareLen)))
                    {
                        *lplLongResult = MQCIH_VERSION_1;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_VERSION_2)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_VERSION_2, lCompareLen)))
                    {
                        *lplLongResult = MQCIH_VERSION_2;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_CURRENT_VERSION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_CURRENT_VERSION, lCompareLen)))
                    {
                        *lplLongResult = MQCIH_CURRENT_VERSION;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_LENGTH_1)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_LENGTH_1, lCompareLen)))
                    {
                        *lplLongResult = MQCIH_LENGTH_1;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_LENGTH_2)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_LENGTH_2, lCompareLen)))
                    {
                        *lplLongResult = MQCIH_LENGTH_2;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_CURRENT_LENGTH)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_CURRENT_LENGTH, lCompareLen)))
                    {
                        *lplLongResult = MQCIH_CURRENT_LENGTH;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_NONE, lCompareLen)))
                    {
                        *lplLongResult = MQCIH_NONE;
                    }
#ifdef MQCIH_PASS_EXPIRATION
                    else if((lCompareLen == StrlenNull(kpszMQCIH_PASS_EXPIRATION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_PASS_EXPIRATION, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQCIH_PASS_EXPIRATION);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_UNLIMITED_EXPIRATION)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_UNLIMITED_EXPIRATION, lCompareLen)))
                    {
                        TurnOffBits(lplLongResult, MQCIH_PASS_EXPIRATION);
                    }
#endif
#ifdef MQCIH_REPLY_WITHOUT_NULLS
                    else if((lCompareLen == StrlenNull(kpszMQCIH_REPLY_WITHOUT_NULLS)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_REPLY_WITHOUT_NULLS, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQCIH_REPLY_WITHOUT_NULLS);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_REPLY_WITH_NULLS)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_REPLY_WITH_NULLS, lCompareLen)))
                    {
                        TurnOffBits(lplLongResult, MQCIH_REPLY_WITHOUT_NULLS);
                    }
#endif
#ifdef MQCIH_SYNC_ON_RETURN
                    else if((lCompareLen == StrlenNull(kpszMQCIH_SYNC_ON_RETURN)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_SYNC_ON_RETURN, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQCIH_SYNC_ON_RETURN);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCIH_NO_SYNC_ON_RETURN)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCIH_NO_SYNC_ON_RETURN, lCompareLen)))
                    {
                        TurnOffBits(lplLongResult, MQCIH_SYNC_ON_RETURN);
                    }
#endif
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCIH\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCIH\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQCRC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCRC\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 8);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCRC_OK)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_OK, lCompareLen)))
                {
                    *lplLongResult = MQCRC_OK;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_CICS_EXEC_ERROR)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_CICS_EXEC_ERROR, lCompareLen)))
                {
                    *lplLongResult = MQCRC_CICS_EXEC_ERROR;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_MQ_API_ERROR)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_MQ_API_ERROR, lCompareLen)))
                {
                    *lplLongResult = MQCRC_MQ_API_ERROR;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_BRIDGE_ERROR)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_BRIDGE_ERROR, lCompareLen)))
                {
                    *lplLongResult = MQCRC_BRIDGE_ERROR;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_BRIDGE_ABEND)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_BRIDGE_ABEND, lCompareLen)))
                {
                    *lplLongResult = MQCRC_BRIDGE_ABEND;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_APPLICATION_ABEND)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_APPLICATION_ABEND, lCompareLen)))
                {
                    *lplLongResult = MQCRC_APPLICATION_ABEND;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_SECURITY_ERROR)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_SECURITY_ERROR, lCompareLen)))
                {
                    *lplLongResult = MQCRC_SECURITY_ERROR;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_PROGRAM_NOT_AVAILABLE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_PROGRAM_NOT_AVAILABLE, lCompareLen)))
                {
                    *lplLongResult = MQCRC_PROGRAM_NOT_AVAILABLE;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_BRIDGE_TIMEOUT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_BRIDGE_TIMEOUT, lCompareLen)))
                {
                    *lplLongResult = MQCRC_BRIDGE_TIMEOUT;
                }
                else if((lCompareLen == StrlenNull(kpszMQCRC_TRANSID_NOT_AVAILABLE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCRC_TRANSID_NOT_AVAILABLE, lCompareLen)))
                {
                    *lplLongResult = MQCRC_TRANSID_NOT_AVAILABLE;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCRC\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCRC\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCC\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 7);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCC_OK)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCC_OK, lCompareLen)))
                {
                    *lplLongResult = MQCC_OK;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCC\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCC\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQRC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQRC\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 9);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQRC_NONE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQRC_NONE, lCompareLen)))
                {
                    *lplLongResult = MQRC_NONE;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQRC\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQRC\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCUOWC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCUOWC\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 12);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCUOWC_ONLY)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCUOWC_ONLY, lCompareLen)))
                {
                    *lplLongResult = MQCUOWC_ONLY;
                }
                else if((lCompareLen == StrlenNull(kpszMQCUOWC_CONTINUE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCUOWC_CONTINUE, lCompareLen)))
                {
                    *lplLongResult = MQCUOWC_CONTINUE;
                }
                else if((lCompareLen == StrlenNull(kpszMQCUOWC_FIRST)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCUOWC_FIRST, lCompareLen)))
                {
                    *lplLongResult = MQCUOWC_FIRST;
                }
                else if((lCompareLen == StrlenNull(kpszMQCUOWC_MIDDLE)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCUOWC_MIDDLE, lCompareLen)))
                {
                    *lplLongResult = MQCUOWC_MIDDLE;
                }
                else if((lCompareLen == StrlenNull(kpszMQCUOWC_LAST)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCUOWC_LAST, lCompareLen)))
                {
                    *lplLongResult = MQCUOWC_LAST;
                }
                else if((lCompareLen == StrlenNull(kpszMQCUOWC_COMMIT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCUOWC_COMMIT, lCompareLen)))
                {
                    *lplLongResult = MQCUOWC_COMMIT;
                }
                else if((lCompareLen == StrlenNull(kpszMQCUOWC_BACKOUT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCUOWC_BACKOUT, lCompareLen)))
                {
                    *lplLongResult = MQCUOWC_BACKOUT;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCUOWC\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCUOWC\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCGWI:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCGWI\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 14);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCGWI_DEFAULT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCGWI_DEFAULT, lCompareLen)))
                {
                    *lplLongResult = MQCGWI_DEFAULT;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCGWI\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCGWI\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCLT:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCLT\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 13);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCLT_PROGRAM)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCLT_PROGRAM, lCompareLen)))
                {
                    *lplLongResult = MQCLT_PROGRAM;
                }
                else if((lCompareLen == StrlenNull(kpszMQCLT_TRANSACTION)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCLT_TRANSACTION, lCompareLen)))
                {
                    *lplLongResult = MQCLT_TRANSACTION;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCLT\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCLT\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCODL:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCODL\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 13);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCODL_AS_INPUT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCODL_AS_INPUT, lCompareLen)))
                {
                    *lplLongResult = MQCODL_AS_INPUT;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCODL\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCODL\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCADSD:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCADSD\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 8);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQCADSD_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCADSD_NONE, lCompareLen)))
                    {
                        /* Reset all the flags */
                        *lplLongResult = MQCADSD_NONE;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCADSD_SEND)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCADSD_SEND, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQCADSD_SEND);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCADSD_RECV)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCADSD_RECV, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQCADSD_RECV);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQCADSD_MSGFORMAT)) &&
                       (0 == memcmp(lpszStartToken, kpszMQCADSD_MSGFORMAT, lCompareLen)))
                    {
                        TurnOnBits(lplLongResult, MQCADSD_MSGFORMAT);
                    }
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCADSD\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCADSD\0", "Value ignored\0");
                }
            }
        }
        break;
    case Q_MQCCT:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCCT\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 8);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCCT_YES)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCCT_YES, lCompareLen)))
                {
                    *lplLongResult = MQCCT_YES;
                }
                else if((lCompareLen == StrlenNull(kpszMQCCT_NO)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCCT_NO, lCompareLen)))
                {
                    *lplLongResult = MQCCT_NO;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCCT\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCCT\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCTES:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQCTES\0");
        }
        else
        {
            lplLongResult = vpResult;
            bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 13);
            if(TRUE == bGotToken)
            {
                lCompareLen = lpszEndToken - lpszStartToken;
                if((lCompareLen == StrlenNull(kpszMQCTES_NOSYNC)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCTES_NOSYNC, lCompareLen)))
                {
                    *lplLongResult = MQCTES_NOSYNC;
                }
                else if((lCompareLen == StrlenNull(kpszMQCTES_COMMIT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCTES_COMMIT, lCompareLen)))
                {
                    *lplLongResult = MQCTES_COMMIT;
                }
                else if((lCompareLen == StrlenNull(kpszMQCTES_BACKOUT)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCTES_BACKOUT, lCompareLen)))
                {
                    *lplLongResult = MQCTES_BACKOUT;
                }
                else if((lCompareLen == StrlenNull(kpszMQCTES_ENDTASK)) &&
                   (0 == memcmp(lpszStartToken, kpszMQCTES_ENDTASK, lCompareLen)))
                {
                    *lplLongResult = MQCTES_ENDTASK;
                }
                else
                {
                    lWorkCopyLen = lCompareLen;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCTES\0", "Value ignored\0");
                }
                lpszStartToken = lpszEndToken;
            }
            else
            {
                lWorkCopyLen = lpszEndToken - lpszStartToken;
                if(WORK_BUFF_LEN < lWorkCopyLen)
                {
                    lWorkCopyLen = WORK_BUFF_LEN;
                }
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCTES\0", "Value ignored\0");
            }
        }
        break;
    case Q_MQCFAC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_FACILITY_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 11))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQCFAC_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFAC_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQCFAC_NONE, MQ_FACILITY_LENGTH);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_FACILITY_LENGTH < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCFAC\0", "Using first 8 characters\0");
                    lCopyLen = MQ_FACILITY_LENGTH;
                }
                /* Make sure shorter format strings are padded with blanks */
                memset(vpResult, ' ', MQ_FACILITY_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_FACILITY_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_FACILITY_LENGTH;
            }
            /* Make sure shorter format strings are padded with blanks */
            memset(vpResult, ' ', MQ_FACILITY_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQCFUNC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_FUNCTION_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 12))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQCFUNC_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFUNC_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQCFUNC_NONE, MQ_FUNCTION_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCFUNC_MQCONN)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFUNC_MQCONN, lCompareLen)))
            {
                memcpy(vpResult, MQCFUNC_MQCONN, MQ_FUNCTION_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCFUNC_MQGET)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFUNC_MQGET, lCompareLen)))
            {
                memcpy(vpResult, MQCFUNC_MQGET, MQ_FUNCTION_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCFUNC_MQINQ)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFUNC_MQINQ, lCompareLen)))
            {
                memcpy(vpResult, MQCFUNC_MQINQ, MQ_FUNCTION_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCFUNC_MQOPEN)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFUNC_MQOPEN, lCompareLen)))
            {
                memcpy(vpResult, MQCFUNC_MQOPEN, MQ_FUNCTION_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCFUNC_MQPUT)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFUNC_MQPUT, lCompareLen)))
            {
                memcpy(vpResult, MQCFUNC_MQPUT, MQ_FUNCTION_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCFUNC_MQPUT1)) &&
               (0 == memcmp(lpszStartToken, kpszMQCFUNC_MQPUT1, lCompareLen)))
            {
                memcpy(vpResult, MQCFUNC_MQPUT1, MQ_FUNCTION_LENGTH);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_FUNCTION_LENGTH < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCFUNC\0", "Using first 8 characters\0");
                    lCopyLen = MQ_FUNCTION_LENGTH;
                }
                /* Make sure shorter format strings are padded with blanks */
                memset(vpResult, ' ', MQ_FUNCTION_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_FUNCTION_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_FUNCTION_LENGTH;
            }
            /* Make sure shorter format strings are padded with blanks */
            memset(vpResult, ' ', MQ_FUNCTION_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQCSC:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, MQ_START_CODE_LENGTH);
        }
        if(TRUE == ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10))
        {
            lCompareLen = lpszEndToken - lpszStartToken;
            if((lCompareLen == StrlenNull(kpszMQCSC_NONE)) &&
               (0 == memcmp(lpszStartToken, kpszMQCSC_NONE, lCompareLen)))
            {
                memcpy(vpResult, MQCSC_NONE, MQ_START_CODE_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCSC_START)) &&
               (0 == memcmp(lpszStartToken, kpszMQCSC_START, lCompareLen)))
            {
                memcpy(vpResult, MQCSC_START, MQ_START_CODE_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCSC_STARTDATA)) &&
               (0 == memcmp(lpszStartToken, kpszMQCSC_STARTDATA, lCompareLen)))
            {
                memcpy(vpResult, MQCSC_STARTDATA, MQ_START_CODE_LENGTH);
            }
            else if((lCompareLen == StrlenNull(kpszMQCSC_TERMINPUT)) &&
               (0 == memcmp(lpszStartToken, kpszMQCSC_TERMINPUT, lCompareLen)))
            {
                memcpy(vpResult, MQCSC_TERMINPUT, MQ_START_CODE_LENGTH);
            }
            else
            {
                lCopyLen = StrlenNull(kpszCmqValue);
                if(MQ_START_CODE_LENGTH < lCopyLen)
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQCSC\0", "Using first 8 characters\0");
                    lCopyLen = MQ_START_CODE_LENGTH;
                }
                /* Make sure shorter format strings are padded with blanks */
                memset(vpResult, ' ', MQ_START_CODE_LENGTH);
                memcpy(vpResult, kpszCmqValue, lCopyLen);
            }
        }
        else
        {
            lCopyLen = StrlenNull(kpszCmqValue);
            if(MQ_START_CODE_LENGTH < lCopyLen)
            {
                lCopyLen = MQ_START_CODE_LENGTH;
            }
            /* Make sure shorter format strings are padded with blanks */
            memset(vpResult, ' ', MQ_START_CODE_LENGTH);
            memcpy(vpResult, kpszCmqValue, lCopyLen);
        }
        break;
    case Q_MQRFH:
        if(NULL != vpInitialValue)
        {
            memcpy(vpResult, vpInitialValue, sizeof(MQLONG));
        }
        if(TRUE == IsNumeric(kpszCmqValue))
        {
            lplLongResult = vpResult;
            *lplLongResult = ConvNum(lpTIB, kpszCmqValue, "MQRFH\0");
        }
        else
        {
            bGotToken = TRUE;
            while((lpszEndToken < lpszMaxPos) &&
                  (TRUE == bGotToken))
            {
                lplLongResult = vpResult;
                bGotToken = ExtractMQToken(&lpszStartToken, &lpszEndToken, lpszMaxPos, 10);
                if(TRUE == bGotToken)
                {
                    lCompareLen = lpszEndToken - lpszStartToken;
                    if((lCompareLen == StrlenNull(kpszMQRFH_STRUC_ID)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRFH_STRUC_ID, lCompareLen)))
                    {
                        memcpy(lplLongResult, MQRFH_STRUC_ID, 4);
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRFH_VERSION_1)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRFH_VERSION_1, lCompareLen)))
                    {
                        *lplLongResult = MQRFH_VERSION_1;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRFH_VERSION_2)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRFH_VERSION_2, lCompareLen)))
                    {
                        *lplLongResult = MQRFH_VERSION_2;
                    }
                    else if((lCompareLen == StrlenNull(kpszMQRFH_NONE)) &&
                       (0 == memcmp(lpszStartToken, kpszMQRFH_NONE, lCompareLen)))
                    {
                        *lplLongResult = MQRFH_NONE;
                    }
                    else
                    {
                        lWorkCopyLen = lCompareLen;
                        if(WORK_BUFF_LEN < lWorkCopyLen)
                        {
                            lWorkCopyLen = WORK_BUFF_LEN;
                        }
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                        LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQRFH\0", "Value ignored\0");
                    }
                    lpszStartToken = lpszEndToken;
                }
                else
                {
                    lWorkCopyLen = lpszEndToken - lpszStartToken;
                    if(WORK_BUFF_LEN < lWorkCopyLen)
                    {
                        lWorkCopyLen = WORK_BUFF_LEN;
                    }
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    memcpy(lpszWorkBuff, lpszStartToken, lWorkCopyLen);
                    LogMsg(199, lpTIB->lTestNum, lpszWorkBuff, "MQRFH\0", "Value ignored\0");
                }
            }
        }
        break;
    }

    /* Free up the trimmed string we have been working with */
    FreeIfNotNull((void**)&lpszTrimmedCmqValue);
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     ExtractMQToken                                                       */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Locate and extract the next MQxx_/MQxxx_ token. Note this routine    */
/*     relies on CloneString and TrimValue behaviour that ensures the       */
/*     buffer containing the data is at least 8 bytes larger than required  */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lplpszStartToken Pointer to a pointer to the search start position   */
/*     lplpszEndToken   Pointer to a pointer to the end position            */
/*     lMinLen          Minimum token length                                */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     TRUE or FALSE depending on whether or a possible token was found     */
/*==========================================================================*/
long
ExtractMQToken(char** lplpszStartToken, char** lplpszEndToken, 
               char* lpszMaxPos, long lMinLen)
{
    long  bFoundMQ;
    char* lpszCurrChar;

    /* If the token string is too short to represent any possible token */
    /* set both pointers to the end of the string                       */
    if((lpszMaxPos - *lplpszStartToken) < lMinLen)
    {
        *lplpszStartToken = lpszMaxPos;
        *lplpszEndToken = lpszMaxPos;
        return FALSE;
    }

    /* Locate the MQ prefix  if possible */
    bFoundMQ = FALSE;
    lpszCurrChar = *lplpszStartToken;
    while(lpszCurrChar < lpszMaxPos)
    {
        if(0 == memcmp(lpszCurrChar, "MQ", 2))
        {
            bFoundMQ = TRUE;
            break;
        }
        lpszCurrChar++;
    }

    /* Couldn't find anything so set both pointers to the end of the string */
    if(FALSE == bFoundMQ)
    {
        *lplpszStartToken = lpszMaxPos;
        *lplpszEndToken = lpszMaxPos;
        return FALSE;
    }

    /* Found the start now find the end */
    *lplpszStartToken = lpszCurrChar;
    while(lpszCurrChar < lpszMaxPos)
    {
        if((isspace(*lpszCurrChar)) ||
           ('|' == *lpszCurrChar) ||
           ('+' == *lpszCurrChar))
        {
            break;
        }
        lpszCurrChar++;
    }
    *lplpszEndToken = lpszCurrChar;
    return TRUE;
}


void
TurnOnBits(long* lplLongResult, long lOrWith)
{
    /* If the value is set to the special initialiser DEADBEED then assign */
    /* the value to the result otherwise perform the OR operation          */
    if(0 == memcmp(lplLongResult, &klDEADBEEF, sizeof(long)))
    {
        *lplLongResult = lOrWith;
    }
    else
    {
        *lplLongResult |= lOrWith;
    }
}

void
TurnOffBits(long* lplLongResult, long lOrWith)
{
    /* If the value is set to the special initialiser DEADBEED then assign */
    /* zero to the result otherwise turn the requested bits off            */
    if(0 == memcmp(lplLongResult, &klDEADBEEF, sizeof(long)))
    {
        *lplLongResult = 0;
    }
    else
    {
        *lplLongResult &= (lOrWith ^ klFFFFFFFF);
    }
}
