/*==========================================================================*/
/* MsgTestMsg contains the message processing routines.                     */
/*==========================================================================*/
/* (C) Copyright Tim Armstrong 2003, 2004, 2005, 2006, 2007, 2008           */
/*==========================================================================*/
/* Includes                                                                 */
/*==========================================================================*/
#ifndef __TJAINC_MSGTEST_H
#include "MsgTest.h"
#endif /* __TJAINC_MSGTEST_H */

/*==========================================================================*/
/* Static variables                                                         */
/*==========================================================================*/
/* Message format string array */
static char* kpszMsgs[] = {
"Message base\0\n",
#ifdef __MSGTEST_S
"**** MsgTestS V1.3.0 Started at %s.  **** Compiled on %s at %s ****\n",
"**** MsgTestS V1.3.0 Finished at %s. ****\n",
#else
"**** MsgTest V1.3.0 Started at %s.  **** Compiled on %s at %s ****\n",
"**** MsgTest V1.3.0 Finished at %s. ****\n",
#endif
"E003 Call to malloc() to allocate %d bytes for the %s failed.\n"
"         ++++ Line=%d File=\"%s\"\n",
"E004 Fatal logic error \"%s\". Current element=\"%s\"\n"
"         ++++ Line=%d in File=\"%s\".\n",
"E005 Call to fopen() for %s=\"%s\" failed errno=%d.\n",
"E006 Call to fseek() SEEK_END for File=\"%s\" failed.\n",
"E007 Call to ftell() for File=\"%s\" failed errno=%d.\n",
"E008 Call to malloc() to allocate %d bytes for the %s buffer failed.\n",
"E009 Call to fseek() SEEK_SET for File=\"%s\" failed.\n",
"E010 LogMsg error=%d msg=\"%s\"\n",
"E011 Call to fread() for File=\"%s\" failed. Error=%d\n",
"I012 Successfully loaded File=\"%s\". Size=%d/%d bytes.\n",
"E013 Unknown element=",
"E014 EXPAT parser error=\"%s\".\n",
"E015 Error during parsing.\n",
"E016 Exceeded maximum logical tag depth.\n"
                        "     Element=",
"E017 Exceeded minimum logical tag depth.\n",
"E018 %s=\"%s\" exceeds maximum length %d for an attribute.\n",
"I019 Successfully parsed ScriptFile=\"%s\".\n",
"E020 Use of <%s> as the root element of a %s is invalid.\n",
"E021 Use of <%s> as a second level element of a %s is invalid.\n",
"E022 Use of <%s> within element %s is invalid.\n",
"E023 Name= attribute missing. Element=",
"E024 Non-numeric value \"%s\" for element=\"%s\".\n",
"E025 Duplicate definition in <Defaults> for <%s Name=\"%s\">\n",
"E026 Error creating a VarInfoBlk for <%s Name=\"%s\">\n",
"I027 Logging suppressed TestLog.File=NONE specified.\n",
"I028 MsgTest TestLog.File=\"%s\" opened.\n",
"E029 ReportMsg error=%d msg=\"%s\"\n",
"I030 MsgTest TestReport.File=\"%s\" opened.\n",
"E031 Fatal logic error. Unexpected CommandType=%d.\n",
"E032 A failure occured during processing. Check the log file.\n",
"E033 Error creating a VarInfoBlk for program parameter=%s.\n",
"I034 Test Num=%03d Test=%s. Initialised.\n",
"I035 Test Num=%03d Test=%s. Assigned to the active list.\n",
"I036 Test Num=%03d Test=%s. Completed successfully.\n",
"E037 Fatal error whilst processing tests. Processing terminated.\n",
"I038 Test Num=%03d   Command=%s completed successfully. ExecutionTime=%0.6lf.\n",
"E039 Connection name %s(%s) too long.\n",
#ifdef __MSGTEST_S
"I040 MQCONN server connection to QMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E041 MQCONN server connection to QMgr=\"%s\" failed, CC=%d, RC=%d.\n",
#else
"I040 MQCONNX client connection to QMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E041 MQCONNX client connection to QMgr=\"%s\" failed, CC=%d, RC=%d.\n",
#endif
"I042 MQDISC from ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E043 MQDISC from ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I044 Test Num=%03d   Command=%s%s. Initialise.\n",
"I045 Test Num=%03d   Command=%s%s. Run.\n",
"E046 Test Num=%03d     Variable Name=\"%s\" not defined. Trying to resolve=%s.\n",
"E047 Test Num=%03d     Variable Name=\"%s\" value is too long.\n",
"E048 Test Num=%03d     Unpaired variable delimiter(%%) in string\"%s\".\n",
"I049 %s variable values.\n",
"E050 Test Num=%03d Name=%s failed.\n",
"E051 Test Num=%03d   Command=%s failed. ExecutionTime=%0.6lf.\n",
"E052 Test Num=%03d     Unable to locate/allocate buffer=\"%s\".\n",
"E053 Call to fwrite() for File=\"%s\" failed. Error=%d\n",
"I054 Test Num=%03d     MQOPEN of TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E055 Test Num=%03d     MQOPEN of TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I056 Test Num=%03d MQCLOSE of TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E057 Test Num=%03d MQCLOSE of TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"E058 Program invocation parameter %s not defined.\n",
"E059 Program invocation parameter %s value is too long.\n",
"E060 Unpaired variable delimiter(%%) in string\"%s\".\n",
"I061 Test Num=%03d     Value resolution \"%s\" to formatted string \"%s\".\n",
"I062 Test results Total=%d Successful=%d Failed=%d Incomplete=%d.\n",
"I063 Total concurrency wait time=%d milliseconds.\n",
"E064 Processing terminated <OnError>%s</OnError> specified.\n",
"E065 Test Num=%03d     EXPAT parser error=\"%s\".\n",
"E066 Test Num=%03d     Error during parsing.\n",
"I067 Test Num=%03d     %s data parsed. File=\"%s\".\n",
"E068 Test Num=%03d     %s=\"%s\" exceeds maximum length %d for a name.\n",
"E069 Test Num=%03d     %s logic error.\n",
"I070 Queue manager connection bypassed. QMgr=NONE specified.\n",
"E071 Test Num=%03d     <MQRFH2> and <MQMD> are the only supported control blocks.\n",
"E072 Test Num=%03d     Exceeded minimum logical tag depth.\n",
"E073 Test Num=%03d     No RFH2 information available.\n",
"E074 Test Num=%03d     RFH2File unmatched folder data=\"%.32s\".\n",
"I075 Test load phase completed. Test execution phase started at %s.\n",
"E076 Test Num=%03d     No MQMD information available.\n",
"E077 Unable to find VIB for Var=\"%s\".\n",
"E078 <For> Name=, From=, To= or Incr= attribute missing. Element=",
"E079 Test Num=%03d     Unable to locate RFH2 variable=\"%s\".\n",
"E080 Test Num=%03d     Variable=\"%s\" is not of type V_RFH2.\n",
"E081 Test Num=%03d     Unable to locate MQMD variable=\"%s\".\n",
"E082 Test Num=%03d     Variable=\"%s\" is not of type V_MQMD.\n",
"E083 %s=\"%s\" invalid attribute.\n",
"E084 Test Num=%03d     Unexpected attribute in MQMDFile or RFH2File Attr=\"%s\".\n",
"E085 Test Num=%03d     Subscript Name=\"%s\" value is too long.\n",
"E086 Test Num=%03d     Unpaired subscript delimiter [] in string\"%s\".\n",
"I087 Test Num=%03d     Subscript resolution \"%s\" to formatted string \"%s\".\n",
"E088 Test Num=%03d     Dotted name used but variable \"%s\" was not an MQMD.\n",
"E089 Test Num=%03d     \"%s\" is not a supported dotted name element of an MQMD.\n",
"E090 Test Num=%03d     Unable to extract a folder name from folder data \"%s\".\n",
"E091 Unable to extract a folder name from folder data \"%s\".\n",
"E092 Fatal error attempting to clone a null FIB.\n",
"I093 Interval statistics.\n",
"E094 <IntervalStart Name=\"%s\"> already defined.\n",
"E095 <IntervalEnd Name=\"%s\"> already defined.\n",
"E096 Interval=\"%s\" the %s command was not defined.\n",
"I097 Statistics for interval=\"%s\".\n",
"I098     No valid intervals were observed\n",
"I099     Full InterQuartile Deviation:\n",
"I100     Semi InterQuartile Deviation:\n",
"I101         Total=%lf ValidIntervalCount=%d\n",
"I102         Average=%lf Median=%lf\n",
"I103         Min=%lf Max=%lf StdDev=%lf\n",
"I104     IntervalStart only count=%d\n",
"I105     IntervalEnd only count=%d\n",
"I106     IntervalEnd before IntervalStart count=%d\n",
"I107 ==========================================================================\n",
"I108     No intervals were defined\n",
"I109     No interval records were obtained\n",
"W110 MQGET conversion error CC=%d RC=%d Format=\"%s\" ControlBlock=\"%s\" CCSID=%d Encoding=0x%08x.\n",
"W111 Format=\"%s\" in ControlBlock=\"%s\" contains nulls.\n",
"E112 It is illegal to specify both <IntervalInMsgId/> and <IntervalInCorrelId/> in a %s command.\n",
"I113 Test Num=%03d    For/ForEver loop Name=\"%s\" counter wrapped to zero.\n",
"E114 Too many %s reason codes. Maximum number=%d.\n",
"E115 <RandomNum> Name=, From= or To= attribute missing. Element=",
"E116 Test Num=%03d     <RandomNum> Name=\"%s\" From=%d To=%d. From value must be less that the To value.\n",
"I117 Test Num=%03d     %s CC=%d RC=%d suppressed. Condition code and reason code reset to zero.\n",
"I118 Test Num=%03d     %s CC=%d RC=%d matched <BreakOnRC> condition. %s%s\n",
"I119 Test Num=%03d     %s CC=%d RC=%d matched <ContinueOnRC> condition. %s%s\n",
"E120 Maximum concurrency value when <GmoWait> used in <GetMsg> is 1.\n",
"I121 Writing of interval records to file suppressed TestInterval.FilePrefix=NONE specified.\n",
"I122 MsgTest TestInterval.File=\"%s\" opened.\n",
"W123 Test Num=%03d     MQOPEN of TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" successful for MQOO_OUTPUT only, CC=%d, RC=%d\n",
"E124 Call to fprintf() when writing the interval record for Interval=\"%s\" failed. Error=%d\n",
"E125 <MessageRate> From=, To= or Mode= attribute missing. Element=",
"E126 <MessageRate> Unkown Mode=\"%s\". Only BURST, PACED, RANDOM and INCREMENTAL are valid.\n",
"E127 Maximum concurrency value when <MessageRate> used in <PutMsg> is 1.\n",
"I128 For a total of %d seconds message rates were achieved=%d times and missed=%d times.\n",
"I129 Message rate target=%d actual=%d.\n",
"I130 Message rate executed %d SleepMillis(1) calls to wait out the second.\n",
"E131 Test Num=%03d     <For Name=\"%s\" From=\"%s\" To=\"%s\" Incr=\"%s\"> a control value is not numeric.\n",
"I132 Test Num=%03d     For this second Rate=%d selected for <MessageRate From=\"%d\" To=\"%d\">.\n",
"I133 Test Num=%03d     <MessageRate From=\"%d\" To=\"%d\" Incr=\"%d\" MODE=\"INCREMENTAL\"> completed. %s%s\n",
"E134 Test Num=%03d     <Overlay Pos=\"%s\" Len=\"%s\"> a control value is not numeric.\n",
"I135 Message set data parsed. File=\"%s\".\n",
"I136 Deprecated.\n",
"E137 Load of MsgSet File=\"%s\" failed.\n",
"E138 Parse of MsgSet File=\"%s\" failed.\n",
"E139 Unknown element=\"%s\"\n",
"E140 Exceeded maximum logical tag depth. Element=\"%s\"\n",
"E141 <Element Name=\"%s\"...> must be defined inside a <SegDef> or <MsgDef>.\n",
"E142 Duplicate <Element Name=\"%s\"...> in <%s Type=\"%s\"...>.\n",
"E143 Duplicate <SegDef Type=\"%s\"...>.\n",
"E144 <Segment Type=\"%s\"...> must be defined inside a <MsgDef> or <SegDef>.\n",
"E145 Duplicate <Segment Type=\"%s\"...> in <%s Type=\"%s\"...>.\n",
"E146 Duplicate <MsgDef Type=\"%s\"...>.\n",
"E147 Unable to find <SegDef Type=\"%s\"...> for <Segment Type=\"%s\"...> of <MsgDef Type=\"%s\"...>.\n",
"E148 Unable to find <SegDef Type=\"%s\"...> for <Segment Type=\"%s\"...>.\n",
"E149 Unable to find a <MsgDef> of Type=\"%s\" for message number=%d.\n",
"E150 Unable to find a <Segment> of Type=\"%s\" in <MsgDef Type=\"%s\"...> for message number=%d.\n",
"E151 Unable to find an <Element> or <Segment> of Type=\"%s\" for message number=%d of Type=\"%s\".\n",
"E152 Unknown ParserName=\"%s\" for File=\"%s\".\n",
"E153 Fatal error during initialisation. Routine=%s.\n",
"E154 <Browse Mode=\"AUTO\"/> of <GetMsg> can only be used inside a <For...>, <ForEver...> or <ForEach> loop.\n",
"E155 Unknown type in definition <Element Name=\"%s\" Type=\"%s\"...>\n",
"I156 Successfully loaded File=\"%s\". Size=%d bytes.\n",
"I157 Logging suppressed TestUserLog.File=NONE specified.\n",
"I158 MsgTest TestUserLog.File=\"%s\" opened.\n",
"E159 <StdIn> input can only be assigned to a <Num>, <Double> or <Str> variable.\n",
"I160 User Log Entry   %s\n",
"E161 Test Num=%03d     Command=<%s...> variable Name=\"%s\" not defined.\n",
"I162 Test Num=%03d TotalGetFile=%d SuccessfulGetFile=%d FailedGetFile=%d.\n",
"I163 TotalGetFile=%d SuccessfulGetFile=%d FailedGetFile=%d.\n",
"I164 Test Num=%03d TotalPutFile=%d SuccessfulPutFile=%d FailedPutFile=%d.\n",
"I165 TotalPutFile=%d SuccessfulPutFile=%d FailedPutFile=%d.\n",
"I166 Test Num=%03d TotalGetMsg=%d SuccessfulGetMsg=%d FailedGetMsg=%d.\n",
"I167 TotalGetMsg=%d SuccessfulGetMsg=%d FailedGetMsg=%d.\n",
"I168 Test Num=%03d TotalPutMsg=%d SuccessfulPutMsg=%d FailedPutMsg=%d.\n",
"I169 TotalPutMsg=%d SuccessfulPutMsg=%d FailedPutMsg=%d.\n",
"I170 Test Num=%03d TotalCompare=%d SuccessfulCompare=%d FailedCompare=%d.\n",
"I171 TotalCompare=%d SuccessfulCompare=%d FailedCompare=%d.\n",
"E172 Test Num=%03d     <Extract Name=\"%s\" Pos=\"%s\" Len=\"%s\"> a control value is not numeric.\n",
"E173 Test Num=%03d     <Extract Name=\"%s\" Pos=\"%s\" Len=\"%s\"> request exceeds buffer=\"%s\" length of %d bytes.\n",
"E174 Test Num=%03d     <Extract Name=\"%s\" Pos=\"%s\" Len=\"%s\"> length value exceeds maximum work area length of %d bytes.\n",
"E175 Test Num=%03d     <Extract Name=\"%s\" Pos=\"%s\" Len=\"%s\"> extracted data \"%s\" is not numeric.\n",
"I176 Test Num=%03d     <Extract Name=\"%s\" Pos=\"%s\" Len=\"%s\"> %s.\n",
"E177 Fatal error attempting to clone a null LEB.\n",
"E178 Use of <%s> as a sub-element of an %s is invalid.\n",
"E179 <For> invalid use of List= attribute. Element=",
"E180 <ForEver> invalid use of From=, To=, Incr= or List= attributes. Element=",
"E181 <ForEach> invalid use of From=, To= or Incr= attributes. Element=",
"E182 Test Num=%03d     <ForEach Name=\"%s\"...> unable to find the requested List variable \"%s\".\n",
"E183 Test Num=%03d     <ForEach Name=\"%s\"...> requested variable \"%s\" is not a List variable.\n",
"E184 Test Num=%03d     Unable to locate DataVar variable=\"%s\".\n",
"E185 Combinations of <Interval>, <IntervalMillis> and <Time> in the same <WaitOnTime> command are illegal.\n",
"E186 Test Num=%03d     <Substring Name=\"%s\" From=\"%s\" Pos=\"%s\" Len=\"%s\"> a control value is not numeric.\n",
"E187 Test Num=%03d     <Substring Name=\"%s\" From=\"%s\" Pos=\"%s\" Len=\"%s\"> request exceeds From=\"%s\" length of %d bytes.\n",
"E188 Test Num=%03d     <Substring Name=\"%s\" From=\"%s\" Pos=\"%s\" Len=\"%s\"> length value exceeds maximum work area length of %d bytes.\n",
"E189 Test Num=%03d     <Substring Name=\"%s\" From=\"%s\" Pos=\"%s\" Len=\"%s\"> Substringed data \"%s\" is not numeric.\n",
"I190 Test Num=%03d     <Substring Name=\"%s\" From=\"%s\" Pos=\"%s\" Len=\"%s\"> %s.\n",
"E191 The scripts <Finally> clause must be declared at the end of the script. No commands are permitted after the ending </Finally> tag.\n",
"E192 The scripts <Finally> clause cannot be defined inside a <For..> loop, however it may contain one.\n",
"E193 A connection with Name=\"%s\" already exists.\n",
"E194 Unable to find a Connection definition with Name=\"%s\".\n",
"E195 It is illegal to specify both <SetIdentityContext/> and <SetAllContext/> in a <PutMsg> command.\n",
"I196 MQBACK from ConnQMgr=\"%s\" successful, CC=%d, RC=%d\n",
"E197 MQBACK from ConnQMgr=\"%s\" failed, CC=%d, RC=%d\n",
"E198 Test Num=%03d     Non-numeric value \"%s\" for \"%s\".\n",
"W199 Test Num=%03d     Unable to resolve value \"%s\" for \"%s\". %s.\n",
"E200 Cannot use <PmoOptions> with PMO option flags <SetIdentityContext/>, <SetAllContext/> and <Syncpoint>.\n",
"E201 Cannot use <GmoOptions> with GMO option flag <Syncpoint>.\n",
"E202 <Group Mode=\"AUTO\"/> of <PutMsg> can only be used inside a <For...> or <ForEach> loop.\n",
"E203 <Group Mode=\"AUTO\"/> of <PutMsg> cannot be used inside a <ForEver...> loop.\n",
"E204 Non-numeric value in definition <Element Name=\"%s\" Type=\"%s\"...>\n",
"E205 Non-Numeric value in definition <Segment Name=\"%s\" Type=\"%s\"...>\n",
"E206 Cannot define a <SegDef> inside a <MsgDef>\n",
"E207 Cannot define a <MsgDef> inside a <SegDef>\n",
"E208 Cannot define a <SegDef> inside a <SegDef>\n",
"E209 Cannot define a <MsgDef> inside a <MsgDef>\n",
"E210 Unable to find <Element Type=\"%s\"...> for <MsgDef Type=\"%s\"...>.\n",
"I211 MQOPEN of queue manager object for QMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E212 MQOPEN of queue manager object for QMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I213 MQINQ of queue manager object for QMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E214 MQINQ of queue manager object for QMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I215 ConnQMgr=\"%s\" has a CodedCharSetId=%d.\n",
"I216 MQCLOSE of queue manager object for ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E217 MQCLOSE of queue manager object for ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
#ifdef WIN32
"I218 GetLocaleInfo()=\"%s\" was used to determine a default value for LocalCodedCharSetId=\"%d\".\n",
"E219 Unable to determine a default value for LocalCodedCharSetId using GetLocaleInfo.\n",
#else
"I218 nl_langinfo()=\"%s\" was used to determine a default value for LocalCodedCharSetId=\"%d\".\n",
"E219 Unable to determine a default value for LocalCodedCharSetId using nl_langinfo.\n",
#endif /* WIN32 */
"I220 <Control> section value LocalCodedCharSetId=\"%d\" will be used.\n",
"E221 <Control> section value LocalCodedCharSetId=\"%s\" is not numeric.\n",
"I222 The default value MQENC_NATIVE was used for LocalEncoding=\"0x%04x\".\n",
"I223 <Control> section value LocalEncoding=\"0x%04x\" will be used.\n",
"E224 <Control> section value LocalEncoding=\"%s\" is not numeric.\n",
"E225 Unknown output format type for <Segment Type=\"%s\" Format=\"%s\"...>.\n",
"I226 Test Num=%03d     Command <Select MsgSetName=\"%s\" MsgNum=\"%s\">.\n",
"E227 Test Num=%03d     Unable to find MsgSetName=\"%s\".\n",
"I228 Test Num=%03d     <Select MsgSetName=\"%s\" MsgNum=\"%d\"> was successful. CC=%d, RC=%d.\n",
"E229 %s %s exceeds the MaxOccurs=\"%d\" count.\n",
"E230 Can only specify \"Left\" or \"Right\" for the Justify attribute for <Element Name=\"%s\"... Justify=\"%s\"...>.\n",
"E231 Unknown output format type for <SegDef Type=\"%s\" Format=\"%s\"...>.\n",
"E232 The value of %s defined as <Element Name=\"%s\" Type=\"%s\"...> has an implicit or explicit length of zero.\n",
"E233 Test Num=%03d     The data length %d, of the value of %s, exceeds the maxmimum permissible length of %d bytes.\n",
"E234 Unable to resize buffer=\"%s\" to %d bytes.\n",
"I235 Resized buffer=\"%s\" from %d bytes to %d bytes.\n",
"E236 Test Num=%03d     Invalid hexadecimal value or packed decimal value \"%s\" for \"%s\".\n",
"E237 CmqValues=\"Yes\" specified for <Element Name=\"%s\"...> a field with a derived length i.e. no Len=\"\" value has been set.\n",
"I238 Reporting suppressed TestReport.File=NONE specified.\n",
"E239 For an SSL connection the SSL options KeyRepository and SSLCipherSpec must be specified.\n",
"W240 MQCONNX to QMgr=\"%s\" successful, CC=%d, RC=%d. However the SSL environment has already been initialised.\n",
"E241 Unable to locate KeyRepository=\"%s\". With an extension of either .kdb(MQ_V6) or .sto(MQ_V5).\n",
"I242 MQOPEN of queue %s object for ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E243 MQOPEN of queue %s object for ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I244 MQINQ of queue %s object for ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E245 MQINQ of queue %s object for ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I246 ConnQMgr=\"%s\" queue %s has a MaximumMessageLength=%d.\n",
"I247 MQCLOSE of queue %s object for ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E248 MQCLOSE of queue %s object for ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I249 Test Num=%03d     MQOPEN of TargQ=\"%s\" TargQMgr=\"%s\" DynamicQ=\"%s\" ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E250 Test Num=%03d     MQOPEN of TargQ=\"%s\" TargQMgr=\"%s\" DynamicQ=\"%s\" ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I251 Test Num=%03d MQCLOSE of TargQ=\"%s\" TargQMgr=\"%s\" DynamicQ=\"%s\" ConnQMgr=\"%s\" successful, CC=%d, RC=%d.\n",
"E252 Test Num=%03d MQCLOSE of TargQ=\"%s\" TargQMgr=\"%s\" DynamicQ=\"%s\" ConnQMgr=\"%s\" failed, CC=%d, RC=%d.\n",
"I253 Test Num=%03d     Removed %s of %d bytes.\n",
"E254 <ElseIf> or <Else> used without a preceding <If> statement.\n",
"I255 Test Num=%03d     %s Cond=\"%s\" evaluated as %s.\n",
"E256 Cannot locate a recognizable predicate in Cond=\"%s\".\n",
"E257 Supported predicates are .EQ. .NE. .LT. .GT. .LE. .GE.\n",
"I258 Test Num=%03d   Command=%s%s. A prior condition has evaluated to TRUE resuming execution at </IF>.\n",
"I259 Test Num=%03d     %s. %s%s\n",
#ifdef __MSGTEST_S
"I260 MQCONN server connection to the default queue manager successful, CC=%d, RC=%d.\n",
"E261 MQCONN server connection to the default queue manager failed, CC=%d, RC=%d.\n",
#else
"I260 MQCONN client connection to the default queue manager successful, CC=%d, RC=%d.\n",
"E261 MQCONN client connection to the default queue manager failed, CC=%d, RC=%d.\n",
#endif
"I262 MQOPEN of queue manager object for the default queue manager successful, CC=%d, RC=%d.\n",
"E263 MQOPEN of queue manager object for the default queue manager failed, CC=%d, RC=%d.\n",
"I264 MQINQ of queue manager object for the default queue manager successful, CC=%d, RC=%d.\n",
"E265 MQINQ of queue manager object for the default queue manager failed, CC=%d, RC=%d.\n",
"I266 Test Num=%03d     <Length Name=\"%s\" Of=\"%s\"> is %d bytes. Type=%s.\n",
"E267 Test Num=%03d     <Position Name=\"%s\" Of=\"%s\" In=\"%s\" From=\"%s\"> From offset is not numeric or is less than 1.\n",
"I268 Test Num=%03d     <Position Name=\"%s\" Of=\"%s\" In=\"%s\" From=\"%s\"> is %d. Type=%s.\n",
"E269 Test Num=%03d     Variable Name=\"%s\" has not been declared or initialised yet.\n",
#ifdef __MSGTEST_S
"W270 MQCONN server connection to QMgr=\"%s\" previously established, CC=%d, RC=%d,  commit processing could be compromised.\n",
#else
"W270 MQCONNX client connection to QMgr=\"%s\" previously established, CC=%d, RC=%d,  commit processing could be compromised.\n",
#endif
"E271 Can only use either the <File> and optinal <Mask> combination or <RegEx> in a <Compare>.\n",
};

/* Special message format strings */
static char* kpszExtraLine = "I+++   %s.\n";
static char* kpszTestExtraLine = "I+++ Test Num=%03d     %s.\n";
static char* kpszExtraLineErr = "E+++   %s.\n";
static char* kpszTestExtraLineErr = "E+++ Test Num=%03d     %s.\n";
static char* kpszTestExtraLinePcf = "I+++ Test Num=%03d     %s\n";
static char* kpszEllipEnd = "...\"";
static char* kpszEnd = "\"";
static char* kpszDot = ".";


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     LogMsg                                                               */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Format the message and write it to the log file if available         */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lMsgNum    Message number                                            */
/*     ...        Variable argument list                                    */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
LogMsg(long lMsgNum, ...)
{
    long            lFPrintfResult;
    char            lpszMsgLogBuff[LOG_BUFF_LEN + 4];
    char*           lpszMsgLogBuffCurr;
    time_t          oTimeT;
    struct tm*      poTimeTm ;
    ControlInfoBlk* lpCIB;

    /* Declare the optional arguments list pointer and initialise it */
    va_list  pOptionalArgs;
    va_start(pOptionalArgs, lMsgNum);

    /* Initialise the control info block pointer */
    lpCIB = kpMCB->lpCIB;

    /* If we dont have a log file then we cannot write to it. This */
    /* can occur before the log file has been successfully opened  */
    /* or if logging has been suppressed with <File>NONE</File>    */
    if(0 == lpCIB->lpTestLogFile)
    {
        /* Display serious errors, "E" prefixed messages on the console  */
        if(0 == memcmp(GetMsgPtr(lMsgNum), "E", 1))
        {
            vprintf(GetMsgPtr(lMsgNum), pOptionalArgs);
        }
        /* Must tell 'C' we have finished using the optional arguments */
        va_end(pOptionalArgs);
        return;
    }

    /* Set up the buffer initialising it with the current time */
    /* Use strftime to format the time value into our buffer   */
    memset(lpszMsgLogBuff, 0x00, LOG_BUFF_LEN + 4);
    time(&oTimeT);
    poTimeTm = localtime(&oTimeT);
    strftime(lpszMsgLogBuff, LOG_BUFF_LEN, "%H:%M:%S ", poTimeTm );
    lpszMsgLogBuffCurr = lpszMsgLogBuff + strlen(lpszMsgLogBuff);

    /* Use vsprintf to format the message in the buffer        */
    vsprintf(lpszMsgLogBuffCurr, GetMsgPtr(lMsgNum), pOptionalArgs);

    /* Must tell 'C' we have finished using the optional arguments */
    va_end(pOptionalArgs);

    /* Now write the formatted message into the actual log file */
    fprintf(lpCIB->lpTestLogFile, "%s", lpszMsgLogBuff);

    /* Check to see if an error occured */
    lFPrintfResult = ferror(lpCIB->lpTestLogFile);
    if(0 != lFPrintfResult)
    {
        printf(kpszMsgs[10], lFPrintfResult, GetMsgPtr(lMsgNum));
    }

    /* Make sure the file buffer is flushed before returning */
    fflush(lpCIB->lpTestLogFile);
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     ReportMsg                                                            */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Format the message and write it to the report file if available      */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lMsgNum    Message number                                            */
/*     ...        Variable argument list                                    */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
ReportMsg(long lMsgNum, ...)
{
    long            lFPrintfResult;
    char            lpszReportMsgBuff[REPORT_BUFF_LEN + 4];
    char*           lpszReportMsgBuffCurr;
    time_t          oTimeT;
    struct tm*      poTimeTm ;
    ControlInfoBlk* lpCIB;

    /* Declare the optional arguments list pointer and initialise it */
    va_list  pOptionalArgs;
    va_start(pOptionalArgs, lMsgNum);

    /* Get the ControlInfoBlk pointer */
    lpCIB = kpMCB->lpCIB;

    /* If we dont have a report file then we can't write to it. This */
    /* can occur before the log file has been successfully opened or */
    /* if reporting has been suppressed with <File>NONE</File>       */
    if(0 == lpCIB->lpTestReportFile)
    {
        vprintf(GetMsgPtr(lMsgNum), pOptionalArgs);
        /* Must tell 'C' we have finished using the optional arguments */
        va_end(pOptionalArgs);
        return;
    }

    /* Set up the buffer initialising it with the current time */
    /* Use strftime to format the time value into our buffer   */
    memset(lpszReportMsgBuff, 0x00, REPORT_BUFF_LEN + 4);
    time(&oTimeT);
    poTimeTm = localtime(&oTimeT);
    strftime(lpszReportMsgBuff, REPORT_BUFF_LEN, "%H:%M:%S ", poTimeTm );
    lpszReportMsgBuffCurr = lpszReportMsgBuff + strlen(lpszReportMsgBuff);

    /* Use vsprintf to format the message in the buffer        */
    vsprintf(lpszReportMsgBuffCurr, GetMsgPtr(lMsgNum), pOptionalArgs);

    /* Must tell 'C' we have finished using the optional arguments */
    va_end(pOptionalArgs);

    /* Now write the formatted message into the actual report file */
    fprintf(lpCIB->lpTestReportFile, "%s", lpszReportMsgBuff);

    /* Check to see if an error occured */
    lFPrintfResult = ferror(lpCIB->lpTestReportFile);
    if(0 != lFPrintfResult)
    {
        printf(kpszMsgs[29], lFPrintfResult, GetMsgPtr(lMsgNum));
    }

    /* Make sure the file buffer is flushed before returning */
    fflush(lpCIB->lpTestReportFile);
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     UserLogMsg                                                           */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Format the message and write it to the user log file if available.   */
/*     Currently only used to write header and trailer messages #1 and #2   */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lMsgNum    Message number                                            */
/*     ...        Variable argument list                                    */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
UserLogMsg(long lMsgNum, ...)
{
    long            lFPrintfResult;
    char            lpszMsgLogBuff[LOG_BUFF_LEN + 4];
    char*           lpszMsgLogBuffCurr;
    time_t          oTimeT;
    struct tm*      poTimeTm ;
    ControlInfoBlk* lpCIB;

    /* Declare the optional arguments list pointer and initialise it */
    va_list  pOptionalArgs;
    va_start(pOptionalArgs, lMsgNum);

    /* Initialise the control info block pointer */
    lpCIB = kpMCB->lpCIB;

    /* If we dont have a log file then we cannot write to it. This */
    /* can occur before the log file has been successfully opened  */
    /* or if logging has been suppressed with <File>NONE</File>    */
    if(0 == lpCIB->lpTestUserLogFile)
    {
        /* Display serious errors, "E" prefixed messages on the console  */
        if(0 == memcmp(GetMsgPtr(lMsgNum), "E", 1))
        {
            vprintf(GetMsgPtr(lMsgNum), pOptionalArgs);
        }
        /* Must tell 'C' we have finished using the optional arguments */
        va_end(pOptionalArgs);
        return;
    }

    /* Set up the buffer initialising it with the current time */
    /* Use strftime to format the time value into our buffer   */
    memset(lpszMsgLogBuff, 0x00, LOG_BUFF_LEN + 4);
    time(&oTimeT);
    poTimeTm = localtime(&oTimeT);
    strftime(lpszMsgLogBuff, LOG_BUFF_LEN, "%H:%M:%S ", poTimeTm );
    lpszMsgLogBuffCurr = lpszMsgLogBuff + strlen(lpszMsgLogBuff);

    /* Use vsprintf to format the message in the buffer        */
    vsprintf(lpszMsgLogBuffCurr, GetMsgPtr(lMsgNum), pOptionalArgs);

    /* Must tell 'C' we have finished using the optional arguments */
    va_end(pOptionalArgs);

    /* Now write the formatted message into the actual log file */
    fprintf(lpCIB->lpTestUserLogFile, "%s", lpszMsgLogBuff);

    /* Check to see if an error occured */
    lFPrintfResult = ferror(lpCIB->lpTestUserLogFile);
    if(0 != lFPrintfResult)
    {
        printf(kpszMsgs[10], lFPrintfResult, GetMsgPtr(lMsgNum));
    }

    /* Make sure the file buffer is flushed before returning */
    fflush(lpCIB->lpTestUserLogFile);
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     ConsoleMsg                                                           */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Format the message and write it to system console                    */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lMsgNum    Message number                                            */
/*     ...        Variable argument list                                    */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
ConsoleMsg(long lMsgNum, ...)
{
    /* Declare the optional arguments list pointer and initialise it */
    va_list  pOptionalArgs;
    va_start(pOptionalArgs, lMsgNum);

    vprintf(GetMsgPtr(lMsgNum), pOptionalArgs);
    /* Must tell 'C' we have finished using the optional arguments */
    va_end(pOptionalArgs);
}

/*==========================================================================*/
/* FUNCTION:                                                                */
/*     GetMsgPtr                                                            */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Get a pointer to the messages' format string                         */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lMsgNum    Message number                                            */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     Pointer to the messages format string                                */
/*==========================================================================*/
char*
GetMsgPtr(long lMsgNum)
{
    /* Calculate the offset for the messages format string pointer   */
    /* handling any special cases as non default behaviour           */
    switch(lMsgNum)
    {
    case EXTRA_LINE:
        return kpszExtraLine;
        break;
    case TEST_EXTRA_LINE:
        return kpszTestExtraLine;
        break;
    case EXTRA_LINE_ERR:
        return kpszExtraLineErr;
        break;
    case TEST_EXTRA_LINE_ERR:
        return kpszTestExtraLineErr;
        break;
    case TEST_EXTRA_LINE_PCF:
        return kpszTestExtraLinePcf;
        break;
    default:
        return kpszMsgs[lMsgNum];
    }
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     DisplayData                                                          */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Display data using "." for unprintable characters                    */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     kpszPrefix    Prefix for data display string
/*     lpszPrintBuff Pointer to the print buffer                            */
/*     lPrintBuffLen Length of the print buffer                             */
/*     lpszData      Pointer to the data                                    */
/*     lDataLen      Length of the data                                     */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
DisplayData(const char* const kpszPrefix, char* lpszPrintBuff,
            long lPrintBuffLen, char* lpszData, long lDataLen)
{
    char* lpszPrintCurr = lpszPrintBuff;
    char* lpszDataCurr = lpszData;
    long  lPrintDataLen = lDataLen;
    long  lMaxPrintLen = lPrintBuffLen - strlen(kpszPrefix) - strlen(kpszEllipEnd);
    long  lIdx;

    /* Make sure what we want to print can fit in the buffer */
    if(lPrintDataLen > lMaxPrintLen)
    {
        lPrintDataLen = lMaxPrintLen;
    }

    /* Maximum of 48 characters */
    if(48 < lPrintDataLen)
    {
        lPrintDataLen = 48;
    }

    /* Clear the print buffer */
    memset(lpszPrintCurr, 0x00, lPrintBuffLen);

    /* Start with the prefix */
    sprintf(lpszPrintCurr, kpszPrefix);
    lpszPrintCurr += strlen(kpszPrefix);

    /* Print up to 48 bytes of data substituting "." for unprintable chars */
    for(lIdx = 0; lIdx < lPrintDataLen; lIdx++)
    {
        if((isgraph(*lpszDataCurr)) ||
           (' ' == *lpszDataCurr))
        {
            sprintf(lpszPrintCurr, "%c", *lpszDataCurr);
        }
        else
        {
            sprintf(lpszPrintCurr, "%c", *kpszDot);
        }
        lpszPrintCurr++;
        lpszDataCurr++;
    }

    /* Now close the quoted string */
    if(48 < lDataLen)
    {
        sprintf(lpszPrintCurr, kpszEllipEnd);
    }
    else
    {
        sprintf(lpszPrintCurr, kpszEnd);
    }
}
