/*==========================================================================*/
/* MsgTestScript.c contains the script file parsing routines.               */
/*==========================================================================*/
/* (C) Copyright Tim Armstrong 2003, 2004, 2005, 2006, 2007, 2008           */
/*==========================================================================*/
/* The EXPAT copyright information is repeated below                        */
/*==========================================================================*/

/*==========================================================================*/
/* EXPAT Copyright information                                              */
/*==========================================================================*/
/*
Copyright (c) 1998, 1999, 2000 Thai Open Source Software Center Ltd
                               and Clark Cooper
Copyright (c) 2001, 2002 Expat maintainers.

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
/*==========================================================================*/
/* End of EXPAT Copyright information                                       */
/*==========================================================================*/

/*==========================================================================*/
/* Includes                                                                 */
/*==========================================================================*/
#ifndef __TJAINC_MSGTEST_H
#include "MsgTest.h"
#endif /* __TJAINC_MSGTEST_H */

#ifndef __TJAINC_MSGTESTSTATICAV_H
#include "MsgTestStaticAV.h"
#endif /* __TJAINC_MSGTESTSTATICAV_H */

#ifndef __TJAINC_MSGTESTSTATICMD_H
#include "MsgTestStaticMD.h"
#endif /* __TJAINC_MSGTESTSTATICMD_H */

/*==========================================================================*/
/* Static variables                                                         */
/*==========================================================================*/
/* Constants */
static char* kpszEmptyString = "\0";

/* Element names */
static char* kpszMSGTEST =                  "MsgTest\0";
static char* kpszCONTROL =                  "Control\0";
static char* kpszDEFAULTS =                 "Defaults\0";
static char* kpszDEFCONN =                  "DefConn\0";
static char* kpszTEST =                     "Test\0";
static char* kpszCONNECTION =               "Connection\0";
static char* kpszQMGR =                     "QMgr\0";
static char* kpszCHANNEL =                  "Channel\0";
static char* kpszHOST =                     "Host\0";
static char* kpszPORT =                     "Port\0";
static char* kpszKEYSTORE =                 "KeyStore\0";
static char* kpszENCRYPTALG =               "EncryptAlg\0";
static char* kpszCOMMONNAME =               "CommonName\0";
static char* kpszKEYREPOSITORY =            "KeyRepository\0";
static char* kpszSSLCIPHERSPEC =            "SSLCipherSpec\0";
static char* kpszSSLPEERNAME =              "SSLPeerName\0";
static char* kpszMAXMSGLENGTH =             "MaxMsgLength\0";
static char* kpszTESTLOG =                  "TestLog\0";
static char* kpszTESTREPORT =               "TestReport\0";
static char* kpszTESTUSERLOG =              "TestUserLog\0";
static char* kpszTESTINTERVAL =             "TestInterval\0";
static char* kpszTESTMSGSET =               "TestMsgSet\0";
static char* kpszTESTMAXWAIT =              "TestMaxWait\0";
static char* kpszNEXTLOGMSGINTERVAL =       "NextLogMsgInterval\0";
static char* kpszCONCURRENCY =              "Concurrency\0";
static char* kpszCONCURRENCYWAIT =          "ConcurrencyWait\0";
static char* kpszONERROR =                  "OnError\0";
static char* kpszCONVTABLEDIR =             "ConvTableDir\0";
static char* kpszLOCALENCODING =            "LocalEncoding\0";
static char* kpszLOCALCODEDCHARSETID =      "LocalCodedCharSetId\0";
static char* kpszNUM =                      "Num\0";
static char* kpszDOUBLE =                   "Double\0";
static char* kpszSTR =                      "Str\0";
static char* kpszRANDOMNUM =                "RandomNum\0";
static char* kpszLIST =                     "List\0";
static char* kpszRFH2 =                     "RFH2\0";
static char* kpszGETFILE =                  "GetFile\0";
static char* kpszPUTFILE =                  "PutFile\0";
static char* kpszINLINEDATA =               "InlineData\0";
static char* kpszOVERLAY =                  "Overlay\0";
static char* kpszEXTRACT =                  "Extract\0";
static char* kpszSUBSTRING =                "Substring\0";
static char* kpszGETMSG =                   "GetMsg\0";
static char* kpszPUTMSG =                   "PutMsg\0";
static char* kpszSELECT =                   "Select\0";
static char* kpszWAITONMSGDEPTH =           "WaitOnMsgDepth\0";
static char* kpszWAITONTIME =               "WaitOnTime\0";
static char* kpszCOMPARE =                  "Compare\0";
static char* kpszCOMMIT =                   "Commit\0";
static char* kpszBACKOUT =                  "Backout\0";
static char* kpszSYSTEM =                   "System\0";
static char* kpszMQSCCOMMAND =              "MqscCommand\0";
static char* kpszFOR =                      "For\0";
static char* kpszFOREVER =                  "ForEver\0";
static char* kpszFOREACH =                  "ForEach\0";
static char* kpszIF =                       "If\0";
static char* kpszELSEIF =                   "ElseIf\0";
static char* kpszELSE =                     "Else\0";
static char* kpszCONTINUE =                 "Continue\0";
static char* kpszBREAK =                    "Break\0";
static char* kpszEXITTEST =                 "ExitTest\0";
static char* kpszFAILTEST =                 "FailTest\0";
static char* kpszFINALLY =                  "Finally\0";
static char* kpszBUFFER =                   "Buffer\0";
static char* kpszFILE =                     "File\0";
static char* kpszFILEPREFIX =               "FilePrefix\0";
static char* kpszLISTFILE =                 "ListFile\0";
static char* kpszREGEX =                    "Regex\0";
static char* kpszMQMDFILE =                 "MQMDFile\0";
static char* kpszRFH2FILE =                 "RFH2File\0";
static char* kpszDIR =                      "Dir\0";
static char* kpszCMDMAXWAIT =               "CmdMaxWait\0";
static char* kpszGMOOPTIONS =               "GmoOptions\0";
static char* kpszPMOOPTIONS =               "PmoOptions\0";
static char* kpszGMOMATCHOPTIONS =          "GmoMatchOptions\0";
static char* kpszGMOWAIT =                  "GmoWait\0";
static char* kpszDATA =                     "Data\0";
static char* kpszDATAVAR =                  "DataVar\0";
static char* kpszQ =                        "Q\0";
static char* kpszMQSCREPLYDYNAMICQ =        "MqscReplyDynamicQ\0";
static char* kpszDEPTH =                    "Depth\0";
static char* kpszINTERVAL =                 "Interval\0";
static char* kpszINTERVALMILLIS =           "IntervalMillis\0";
static char* kpszTIME =                     "Time\0";
static char* kpszRFH2COMP =                 "RFH2Comp\0";
static char* kpszMASK =                     "Mask\0";
static char* kpszCOMMAND =                  "Command\0";
static char* kpszIGNORERC =                 "IgnoreRC\0";
static char* kpszMQRFH2 =                   "MQRFH2\0";
static char* kpszFOLDER =                   "Folder\0";
static char* kpszLISTELEMENT =              "ListElement\0";
static char* kpszNAME =                     "Name\0";
static char* kpszFROM =                     "From\0";
static char* kpszTO =                       "To\0";
static char* kpszINCR =                     "Incr\0";
static char* kpszCOND =                     "Cond\0";
static char* kpszMODE =                     "Mode\0";
static char* kpszR1 =                       "R1\0";
static char* kpszR2 =                       "R2\0";
static char* kpszMSGSETNAME =               "MsgSetName\0";
static char* kpszMSGNUM =                   "MsgNum\0";
static char* kpszNUMFMT =                   "%d\0";
static char* kpszDOUBLEFMT =                "%lf\0";
static char* kpszSTRFMT =                   "%s\0";
static char* kpszZERO =                     "0\0";
static char* kpszDIRVAR =                   "%Dir%\0";
static char* kpszINTERVALSTART =            "IntervalStart\0";
static char* kpszINTERVALEND =              "IntervalEnd\0";
static char* kpszINTERVALINMSGID =          "IntervalInMsgId\0";
static char* kpszINTERVALINCORRELID =       "IntervalInCorrelId\0";
static char* kpszSYNCPOINT =                "Syncpoint\0";
static char* kpszSETIDENTITYCONTEXT =       "SetIdentityContext\0";
static char* kpszSETALLCONTEXT =            "SetAllContext\0";
static char* kpszREMOVEDLH =                "RemoveDLH\0";
static char* kpszREMOVEXQH =                "RemoveXQH\0";
static char* kpszMESSAGERATE =              "MessageRate\0";
static char* kpszCONVERT =                  "Convert\0";
static char* kpszCLEAR =                    "Clear\0";
static char* kpszONE =                      "1\0";
static char* kpszCONTINUEONRC =             "ContinueOnRC\0";
static char* kpszBREAKONRC =                "BreakOnRC\0";
static char* kpszSUPPRESSRC =               "SuppressRC\0";
static char* kpszPARSERNAME =               "ParserName\0";
static char* kpszBURST =                    "BURST\0";
static char* kpszPACED =                    "PACED\0";
static char* kpszRANDOM =                   "RANDOM\0";
static char* kpszINCREMENTAL =              "INCREMENTAL\0";
static char* kpszPOS =                      "Pos\0";
static char* kpszLEN =                      "Len\0";
static char* kpszSCRIPT =                   "script\0";
static char* kpszBROWSE =                   "Browse\0";
static char* kpszGROUP =                    "Group\0";
static char* kpszFIRST =                    "FIRST\0";
static char* kpszNEXT =                     "NEXT\0";
static char* kpszLAST =                     "LAST\0";
static char* kpszAUTO =                     "AUTO\0";
static char* kpszAPPEND =                   "Append\0";
static char* kpszSTDIN =                    "StdIn\0";
static char* kpszSTDOUT =                   "StdOut\0";
static char* kpszUSERLOG =                  "UserLog\0";
static char* kpszLOGANDCONTINUE =           "LogAndContinue\0";
static char* kpszADD =                      "Add\0";
static char* kpszSUBTRACT =                 "Subtract\0";
static char* kpszMULTIPLY =                 "Multiply\0";
static char* kpszDIVIDE =                   "Divide\0";
static char* kpszEVAL =                     "Eval\0";
static char* kpszLENGTH =                   "Length\0";
static char* kpszPOSITION =                 "Position\0";
static char* kpszOF =                       "Of\0";
static char* kpszIN =                       "In\0";
static char* kpszDELIMITER =                "Delimiter\0";
static char* kpszFILEEXTENSION =            "FileExtension\0";
static char* kpszREM =                      "Rem\0";
static char* kpszEQUALTO =                  ".EQ.\0";
static char* kpszNOTEQUALTO =               ".NE.\0";
static char* kpszGREATER =                  ".GT.\0";
static char* kpszLESS =                     ".LT.\0";
static char* kpszGREATEREQUAL =             ".GE.\0";
static char* kpszLESSEQUAL =                ".LE.\0";
static char* kpszSPACE =                    " \0";

static char* kpszPN_MSGSET =                "MSGSET\0";

static char* kpszSYSMQSCREPLYQ =             "SYSTEM.MQSC.REPLY.QUEUE\0";

static char* kpszIIR =                       "iir\0";


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     ParseScriptFile                                                      */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Parse the script file using the EXPAT(c) parser.                     */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     N/A                                                                  */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
ParseScriptFile()
{
    /* Create the parser */
    XML_Parser oParser = XML_ParserCreate(NULL);

    /* Give the parser the main control block pointer for its callback functions */
    XML_SetUserData(oParser, kpMCB);
    
    /* Provide the addresses of our various callback functions */
    XML_SetElementHandler(oParser, PSFParseStartElement, PSFParseEndElement);
    XML_SetCharacterDataHandler(oParser, PSFParseCharData);
    XML_SetCommentHandler(oParser, PSFComments);
    
    /* Call the parser */
    if(XML_STATUS_ERROR == XML_Parse(oParser, kpMCB->lpszScriptBuff,
                                     kpMCB->lScriptXmlLen, 1))
    {
        /* EXPAT identified a problem during parsing */
        ConsoleMsg(14, XML_ErrorString(XML_GetErrorCode(oParser)));
        return FAILURE;
    }

    /* Done with the parser so let it know */
    XML_ParserFree(oParser);

    /* Finished with the script buffer so free it */
    FreeIfNotNull((void**)&kpMCB->lpszScriptBuff);

    if(FAILURE == kpMCB->lProcessing)
    {
        /* MsgTest identified a problem during parsing */
        ConsoleMsg(15);
        return FAILURE;
    }

    /* So far so good. Tell the world */
    ConsoleMsg(19, kpMCB->lpszScriptFileName);
    return SUCCESS;
}

/*--------------------------------------------------------------------------*/
static void XMLCALL
PSFParseStartElement(void* vpUserData, const char* kpszElementName, const char** kpkpAtts)
{
    MainCtrlBlk*      kpMCB;
    enum eElementEnum eElementIs;
    char              lpszElementNameBuff[NAME_BUFF_LEN + 4];
    CommandCtrlBlk*   lpCCB;
    IntervalInfoBlk*  lpIIB;
    ConnectionDefBlk* lpCDB;
    long              lIdx;

    /* Get the main control block pointer */
    kpMCB = vpUserData;

    /* Already FAILED? Don't do anything else */
    if(FAILURE == kpMCB->lProcessing)
    {
        return;
    }

    /* New element so reset the ParseCharData buffer pointer */
    ClearPCDB();

    /* Check element name length */
    if(NAME_BUFF_LEN < StrlenNull(kpszElementName))
    {
        ConsoleMsg(18, "Element", kpszElementName, NAME_BUFF_LEN);
        kpMCB->lProcessing = FAILURE;
        return;
    }

    /* Copy the element name to our local buffer */
    memset(lpszElementNameBuff, 0x00, NAME_BUFF_LEN + 4);
    strncpy(lpszElementNameBuff, kpszElementName, NAME_BUFF_LEN);

    /* Copy the element name to an element name buffer */
    memset(kpMCB->lplpszElementName[kpMCB->lScriptParseDepth], 0x00, NAME_BUFF_LEN + 4);
    strncpy(kpMCB->lplpszElementName[kpMCB->lScriptParseDepth], kpszElementName, NAME_BUFF_LEN);

    /* Which element type are we processing for */
    eElementIs = PSFGetElementType(lpszElementNameBuff);
    if(E_UNKNOWN == eElementIs)
    {
        PSFDisplayParseError(13);
        kpMCB->lProcessing = FAILURE;
        return;
    }

    /* Now we know which element type it is */
    kpMCB->eElementType[kpMCB->lScriptParseDepth] = eElementIs;

    /* For elements that have attributes or who's sub-elements */
    /* have attributes clear the attribute buffers             */
    switch(eElementIs)
    {
    case E_CONNECTION:
    case E_TESTMSGSET:
    case E_TEST:
    case E_NUM:
    case E_DOUBLE:
    case E_STR:
    case E_RANDOMNUM:
    case E_LIST:
    case E_MQMD:
    case E_RFH2:
    case E_GETFILE:
    case E_PUTFILE:
    case E_GETMSG:
    case E_PUTMSG:
    case E_COMPARE:
    case E_MQSCCOMMAND:
    case E_FOR:
    case E_FOREVER:
    case E_FOREACH:
    case E_IF:
    case E_ELSEIF:
    case E_ADD:
    case E_SUBTRACT:
    case E_MULTIPLY:
    case E_DIVIDE:
    case E_EVAL:
    case E_LENGTH:
    case E_POSITION:
        ClearAttrs();
    }

    /* For elements that use the Reason Code counters and arrays */
    /* reset the counters and arrays                             */
    switch(eElementIs)
    {
    case E_GETMSG:
    case E_PUTMSG:
        ClearRC();
    }

    /* The <MsgTest> element itself can have attributes like a schema so ignore them */
    /* for anything else check that its one of the attributes we are expecting       */
    switch(eElementIs)
    {
    case E_MSGTEST:
        break;
    default:
        /* Process attribute pairs */
        lIdx = 0;
        while(kpkpAtts[lIdx])
        {
            /* Check element attr length */
            if(ATTR_BUFF_LEN < StrlenNull(kpkpAtts[lIdx + 1]))
            {
                ConsoleMsg(18, kpkpAtts[lIdx], kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
                kpMCB->lProcessing = FAILURE;
                return;
            }

            if(0 == memcmp(kpszNAME, kpkpAtts[lIdx], strlen(kpszNAME) + 1))
            {
                /* Copy the Name attr to the current Name attr buffer */
                strncpy(kpMCB->lpszCurrNameAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszFORMAT, kpkpAtts[lIdx], strlen(kpszFORMAT) + 1))
            {
                /* Copy the Format attr to the current Format attr buffer */
                strncpy(kpMCB->lpszCurrFormatAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
                ConvertEscapeSequences(kpMCB->lpszCurrFormatAttr);
            }
            else if(0 == memcmp(kpszMQMD, kpkpAtts[lIdx], strlen(kpszMQMD) + 1))
            {
                /* Copy the MQMD attr to the current MQMD attr buffer */
                strncpy(kpMCB->lpszCurrMQMDAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszRFH2, kpkpAtts[lIdx], strlen(kpszRFH2) + 1))
            {
                /* Copy the RFH2 attr to the current RFH2 attr buffer */
                strncpy(kpMCB->lpszCurrRFH2Attr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszR1, kpkpAtts[lIdx], strlen(kpszR1) + 1))
            {
                /* Copy the R1 attr to the current R1 attr buffer */
                strncpy(kpMCB->lpszCurrR1Attr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszR2, kpkpAtts[lIdx], strlen(kpszR2) + 1))
            {
                /* Copy the R2 attr to the current R2 attr buffer */
                strncpy(kpMCB->lpszCurrR2Attr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszMSGSETNAME, kpkpAtts[lIdx], strlen(kpszMSGSETNAME) + 1))
            {
                /* Copy the MsgSetName attr to the current MsgSetName attr buffer */
                strncpy(kpMCB->lpszCurrMsgSetNameAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszMSGNUM, kpkpAtts[lIdx], strlen(kpszMSGNUM) + 1))
            {
                /* Copy the MsgNum attr to the current MsgNum attr buffer */
                strncpy(kpMCB->lpszCurrMsgNumAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszFROM, kpkpAtts[lIdx], strlen(kpszFROM) + 1))
            {
                /* Copy the From attr to the current From attr buffer */
                strncpy(kpMCB->lpszCurrFromAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszTO, kpkpAtts[lIdx], strlen(kpszTO) + 1))
            {
                /* Copy the To attr to the current To attr buffer */
                strncpy(kpMCB->lpszCurrToAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszINCR, kpkpAtts[lIdx], strlen(kpszINCR) + 1))
            {
                /* Copy the Incr attr to the current Incr attr buffer */
                strncpy(kpMCB->lpszCurrIncrAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszCOND, kpkpAtts[lIdx], strlen(kpszCOND) + 1))
            {
                /* Copy the Cond attr to the current Cond attr buffer */
                strncpy(kpMCB->lpszCurrCondAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszMODE, kpkpAtts[lIdx], strlen(kpszMODE) + 1))
            {
                /* Copy the Mode attr to the current Mode attr buffer */
                strncpy(kpMCB->lpszCurrModeAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszINTERVAL, kpkpAtts[lIdx], strlen(kpszINTERVAL) + 1))
            {
                /* Copy the Interval attr to the current Interval attr buffer */
                strncpy(kpMCB->lpszCurrIntervalAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszPOS, kpkpAtts[lIdx], strlen(kpszPOS) + 1))
            {
                /* Copy the Pos attr to the current Pos attr buffer */
                strncpy(kpMCB->lpszCurrPosAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszLEN, kpkpAtts[lIdx], strlen(kpszLEN) + 1))
            {
                /* Copy the Len attr to the current Len attr buffer */
                strncpy(kpMCB->lpszCurrLenAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszLIST, kpkpAtts[lIdx], strlen(kpszLIST) + 1))
            {
                /* Copy the List attr to the current List attr buffer */
                strncpy(kpMCB->lpszCurrListAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszDATAVAR, kpkpAtts[lIdx], strlen(kpszDATAVAR) + 1))
            {
                /* Copy the DataVar attr to the current DataVar attr buffer */
                strncpy(kpMCB->lpszCurrDataVarAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszCONNECTION, kpkpAtts[lIdx], strlen(kpszCONNECTION) + 1))
            {
                /* Copy the Connection attr to the current Connection attr buffer */
                strncpy(kpMCB->lpszCurrConnectionAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszOF, kpkpAtts[lIdx], strlen(kpszOF) + 1))
            {
                /* Copy the Of attr to the current Of attr buffer */
                strncpy(kpMCB->lpszCurrOfAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszIN, kpkpAtts[lIdx], strlen(kpszIN) + 1))
            {
                /* Copy the In attr to the current In attr buffer */
                strncpy(kpMCB->lpszCurrInAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszDELIMITER, kpkpAtts[lIdx], strlen(kpszDELIMITER) + 1))
            {
                /* Copy the Delimiter attr to the current Delimiter attr buffer */
                strncpy(kpMCB->lpszCurrDelimiterAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszFILEEXTENSION, kpkpAtts[lIdx], strlen(kpszFILEEXTENSION) + 1))
            {
                /* Copy the FileExtension attr to the current FileExtension attr buffer */
                strncpy(kpMCB->lpszCurrFileExtensionAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else if(0 == memcmp(kpszREM, kpkpAtts[lIdx], strlen(kpszREM) + 1))
            {
                /* Copy the Rem attr to the current Rem attr buffer */
                strncpy(kpMCB->lpszCurrRemAttr, kpkpAtts[lIdx + 1], ATTR_BUFF_LEN);
            }
            else
            {
                ConsoleMsg(83, kpkpAtts[lIdx], kpkpAtts[lIdx + 1]);
                kpMCB->lProcessing = FAILURE;
                return;
            }

            /* Point to the next pair of attributes */
            lIdx += 2;
        }
        break;
    }

    /* Handle different initialisation requirements for the various elements */
    switch(eElementIs)
    {
    case E_TEST:
        /* A Test must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* Create and initialise a test information block */
        CreateTestInfoBlk();
        break;
    case E_CONNECTION:
        /* The default name for a connection is "DefConn" */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            strncpy(kpMCB->lpszCurrNameAttr, kpszDEFCONN, StrlenNull(kpszDEFCONN));
        }
        /* See if the connection already exists. If it does then its an */
        /* error otherwise create a new connection definiton block      */
        lpCDB = FindConnectionDefBlk(kpMCB->lpCDBHead, kpMCB->lpszCurrNameAttr);
        if(NULL == lpCDB)
        {
            lpCDB = CreateConnectionDefBlk(kpMCB->lpszCurrNameAttr);
            if(! lpCDB)
            {
                kpMCB->lProcessing = FAILURE;
                return;
            }
            AddToTailOfList((LinkedListBlk**)&kpMCB->lpCDBHead,
                            (LinkedListBlk**)&kpMCB->lpCDBTail,
                            (LinkedListBlk*)lpCDB);
        }
        else
        {
            ConsoleMsg(193);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        kpMCB->lpCIB->lpCurrCDB = lpCDB;
        break;
    case E_NUM:
    case E_DOUBLE:
    case E_STR:
    case E_LIST:
    case E_MQMD:
    case E_RFH2:
        /* Variables must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        break;
    case E_RANDOMNUM:
        /* A random number must have a name and from and to values */
        if((0 == StrlenNull(kpMCB->lpszCurrNameAttr)) ||
           (0 == StrlenNull(kpMCB->lpszCurrFromAttr)) ||
           (0 == StrlenNull(kpMCB->lpszCurrToAttr)))
        {
            PSFDisplayParseError(115);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        break;
    case E_ADD:
    case E_SUBTRACT:
    case E_MULTIPLY:
    case E_DIVIDE:
    case E_EVAL:
        /* Variables must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        break;
    case E_FOR:
        /* A for loop has a number of required attributes */
        if((0 == StrlenNull(kpMCB->lpszCurrNameAttr)) ||
           (0 == StrlenNull(kpMCB->lpszCurrFromAttr)) ||
           (0 == StrlenNull(kpMCB->lpszCurrToAttr)) ||
           (0 == StrlenNull(kpMCB->lpszCurrIncrAttr)))
        {
            PSFDisplayParseError(78);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* And List="" is not one of them */
        if(0 < StrlenNull(kpMCB->lpszCurrListAttr))
        {
            PSFDisplayParseError(179);
            kpMCB->lProcessing = FAILURE;
            return;
        }

        /* A for loop statement generates two control blocks a ForStart */
        /* and a ForEnd. Create the ForStart command block          */
        kpMCB->eForType = F_FOR;
        lpCCB = (CommandCtrlBlk*)CreateForStartBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;
    case E_FOREVER:
        /* A forever loop must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* And nothing else */
        if((0 < StrlenNull(kpMCB->lpszCurrFromAttr)) ||
           (0 < StrlenNull(kpMCB->lpszCurrToAttr)) ||
           (0 < StrlenNull(kpMCB->lpszCurrIncrAttr)) ||
           (0 < StrlenNull(kpMCB->lpszCurrListAttr)))
        {
            PSFDisplayParseError(180);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* Set the attributes of a <ForEver> loop */
        strncpy(kpMCB->lpszCurrFromAttr, kpszONE, 1);
        strncpy(kpMCB->lpszCurrToAttr, kpszONE, 1);
        strncpy(kpMCB->lpszCurrIncrAttr, kpszONE, 1);
        /* A for loop statement generates two control blocks a ForStart */
        /* and a ForEnd. Create the ForStart command block          */
        kpMCB->eForType = F_FOREVER;
        lpCCB = (CommandCtrlBlk*)CreateForStartBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;
    case E_FOREACH:
        /* A foreach loop must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* And only a list attribute */
        if((0 < StrlenNull(kpMCB->lpszCurrFromAttr)) ||
           (0 < StrlenNull(kpMCB->lpszCurrToAttr)) ||
           (0 < StrlenNull(kpMCB->lpszCurrIncrAttr)))
        {
            PSFDisplayParseError(181);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* A for loop statement generates two control blocks a ForStart */
        /* and a ForEnd. Create the ForStart command block          */
        kpMCB->eForType = F_FOREACH;
        lpCCB = (CommandCtrlBlk*)CreateForStartBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;
    case E_IF:
        /* An if requires a conditon attribute */
        if(0 == StrlenNull(kpMCB->lpszCurrCondAttr))
        {
            PSFDisplayParseError(78);
            kpMCB->lProcessing = FAILURE;
            return;
        }

        /* An if statement generates two control blocks an IfStart */
        /* and an IfEnd. Create the IfStart command block          */
        lpCCB = (CommandCtrlBlk*)CreateIfStartBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;
    case E_FINALLY:
        /* <Finally> must be a level two statement at the end of the script */
        if(2 < kpMCB->lScriptParseDepth)
        {
            ConsoleMsg(192);
            kpMCB->lProcessing = FAILURE;
        }
        /* A finally statement generates two control blocks a FinallyStart */
        /* and a FinallyEnd. Create the FinallyStart command block         */
        lpCCB = (CommandCtrlBlk*)CreateFinallyStartBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;
    case E_INTERVALSTART:
        /* An IntervalStart must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* Add the IntervalStart command to the command control block chain */
        lpCCB = (CommandCtrlBlk*)CreateIntervalStartBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;
    case E_INTERVALEND:
        /* An IntervalEnd must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* Add the IntervalEnd command to the command control block chain */
        lpCCB = (CommandCtrlBlk*)CreateIntervalEndBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;
    case E_INTERVALINMSGID:
        /* An IntervalInMsgId must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* See if the interval already exists */
        lpIIB = FindIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
        if(! lpIIB)
        {
            /* If not create one */
            lpIIB = CreateIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
            if(! lpIIB)
            {
                kpMCB->lProcessing = FAILURE;
                return;
            }
            AddToTailOfList((LinkedListBlk**)&kpMCB->lpIIBHead,
                            (LinkedListBlk**)&kpMCB->lpIIBTail,
                            (LinkedListBlk*)lpIIB);
        }
        kpMCB->lpCSE->lpIIB = lpIIB;
        break;
    case E_INTERVALINCORRELID:
        /* An IntervalInCorrelId must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* See if the interval already exists */
        lpIIB = FindIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
        if(! lpIIB)
        {
            /* If not create one */
            lpIIB = CreateIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
            if(! lpIIB)
            {
                kpMCB->lProcessing = FAILURE;
                return;
            }
            AddToTailOfList((LinkedListBlk**)&kpMCB->lpIIBHead,
                            (LinkedListBlk**)&kpMCB->lpIIBTail,
                            (LinkedListBlk*)lpIIB);
        }
        kpMCB->lpCSE->lpIIB = lpIIB;
        break;
    case E_MESSAGERATE:
        /* A message rate has a number of required attributes */
        if((0 == StrlenNull(kpMCB->lpszCurrFromAttr)) ||
           (0 == StrlenNull(kpMCB->lpszCurrToAttr)) ||
           (0 == StrlenNull(kpMCB->lpszCurrModeAttr)))
        {
            PSFDisplayParseError(125);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* ???TA check incr and interval if incremental */
        kpMCB->lpCSE->lpMRB = CreateMessageRateBlk();
        break;
    case E_STDIN:
        /* A StdIn element must have a name */
        if(0 == StrlenNull(kpMCB->lpszCurrNameAttr))
        {
            PSFDisplayParseError(23);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        /* Add the StdIn command to the command control block chain */
        lpCCB = (CommandCtrlBlk*)CreateStdInBlk();
        if(! lpCCB)
        {
            kpMCB->lProcessing = FAILURE;
            return;
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBHead,
                        (LinkedListBlk**)&kpMCB->lpTIBReadyTail->lpCCBTail,
                        (LinkedListBlk*)lpCCB);
        break;

    /* These elements can have command sub element elements */
    /* so clear the command sub element data pointers.      */
    case E_TESTLOG:
    case E_TESTREPORT:
    case E_TESTUSERLOG:
    case E_TESTINTERVAL:
    case E_TESTMSGSET:
    case E_GETFILE:
    case E_PUTFILE:
    case E_INLINEDATA:
    case E_OVERLAY:
    case E_EXTRACT:
    case E_SUBSTRING:
    case E_GETMSG:
    case E_PUTMSG:
    case E_SELECT:
    case E_WAITONMSGDEPTH:
    case E_WAITONTIME:
    case E_COMMIT:
    case E_BACKOUT:
    case E_COMPARE:
    case E_SYSTEM:
    case E_MQSCCOMMAND:
        ClearCIB();
        ClearCSE();
        break;
    }

    /* Set main control level block flags for script statistics, connection required and MqscCommand */
    switch(eElementIs)
    {
    case E_GETFILE:
        kpMCB->bScriptHasGetFile = TRUE;
        break;
    case E_PUTFILE:
        kpMCB->bScriptHasPutFile = TRUE;
        break;
    case E_GETMSG:
        kpMCB->bScriptHasGetMsg = TRUE;
        kpMCB->bConnectionRequired = TRUE;
        break;
    case E_PUTMSG:
        kpMCB->bScriptHasPutMsg = TRUE;
        kpMCB->bConnectionRequired = TRUE;
        break;
    case E_COMPARE:
        kpMCB->bScriptHasCompare = TRUE;
        break;
    case E_COMMIT:
        kpMCB->bConnectionRequired = TRUE;
        break;
    case E_BACKOUT:
        kpMCB->bConnectionRequired = TRUE;
        break;
    case E_MQSCCOMMAND:
        kpMCB->bConnectionRequired = TRUE;
        kpMCB->bScriptHasMqscCommand = TRUE;
        break;
    }

    /* Nearly every non container element uses the ParseCharData */
    /* buffer so reset it for them */
    ClearPCDB();

    /* Increment the parse element depth */
    kpMCB->lScriptParseDepth++;
    
    /* Check we haven't exceeded the maximum logical tag depth  */
    if(MAX_SCRIPT_PARSE_DEPTH < kpMCB->lScriptParseDepth)
    {
        kpMCB->lScriptParseDepth = MAX_SCRIPT_PARSE_DEPTH;
        PSFDisplayParseError(16);
        kpMCB->lProcessing = FAILURE;
        return;
    }
}

/*--------------------------------------------------------------------------*/
static void XMLCALL
PSFParseEndElement(void* vpUserData, const char* kpszElementName)
{
    MainCtrlBlk*      kpMCB;
    ControlInfoBlk*   lpCIB;
    DefaultsInfoBlk*  lpDIB;
    CommandCtrlBlk*   lpCCB;
    TestInfoBlk*      lpTIB;
    VarInfoBlk*       lpVIB;
    enum eElementEnum eElementIs;
    char              lpszElementNameBuff[NAME_BUFF_LEN + 4];
    char              lpszFmtBuff[RESOLVE_BUFF_LEN + 4];
    char              lpszWorkBuff[WORK_BUFF_LEN + 4];
    long              lNewNum;
    long              lCheckNum;
    double            dNewDouble;

    /* Get the main control block pointer */
    kpMCB = vpUserData;

    /* Already FAILED? Don't do anything else */
    if(FAILURE == kpMCB->lProcessing)
    {
        return;
    }

    /* Copy the element name to our local buffer */
    memset(lpszElementNameBuff, 0x00, NAME_BUFF_LEN + 4);
    strncpy(lpszElementNameBuff, kpszElementName, NAME_BUFF_LEN);

    /* Decrement the parse element depth */
    kpMCB->lScriptParseDepth--;
    if(0 > kpMCB->lScriptParseDepth)
    {
        kpMCB->lScriptParseDepth = 0;
        ConsoleMsg(17);
        kpMCB->lProcessing = FAILURE;
        return;
    }

    /* Which element type are we processing for */
    eElementIs = PSFGetElementType(lpszElementNameBuff);
    if(E_UNKNOWN == eElementIs)
    {
        PSFDisplayParseError(13);
        kpMCB->lProcessing = FAILURE;
        return;
    }

    /* Element processing varies depending on parse depth */
    switch(kpMCB->lScriptParseDepth)
    {
    /* At parse depth 0 <MsgTest> is the only valid element */
    /* and it only needs to exist                           */
    case 0:
        switch(eElementIs)
        {
        case E_MSGTEST:
            break;
        default:
            ConsoleMsg(20, lpszElementNameBuff, kpszSCRIPT);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        break;
    /* At parse depth 1 <Control>, <Defaults>, and <Test>  */
    /* are the only valid elements and only need to exist  */
    case 1:
        switch(eElementIs)
        {
        case E_CONTROL:
        case E_DEFAULTS:
        case E_TEST:
            break;
        default:
            ConsoleMsg(21, lpszElementNameBuff, kpszSCRIPT);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        break;
    /* At parse depth 2 all sorts of elements are valid    */
    /* their validity and use being determined by their    */
    /* parse depth 1 context                               */
    case 2:
        switch(kpMCB->eElementType[1])
        {
        /* Control info block related processing           */
        case E_CONTROL:
            lpCIB = kpMCB->lpCIB;
            switch(eElementIs)
            {
            case E_CONNECTION:
                SetCDBToCIBValues(lpCIB->lpCurrCDB);
                break;
            case E_QMGR:
                lpCIB->lpszConnQMgrName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_CHANNEL:
                lpCIB->lpszConnChannelName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_HOST:
                lpCIB->lpszConnHostName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_PORT:
                lpCIB->lpszConnPortNum = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_KEYREPOSITORY:
                lpCIB->lpszConnKeyRepository = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_SSLCIPHERSPEC:
                lpCIB->lpszConnSSLCipherSpec = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_SSLPEERNAME:
                lpCIB->lpszConnSSLPeerName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_MAXMSGLENGTH:
                lpCIB->lpszConnMaxMsgLength = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_TESTLOG:
                lpCIB->lpszTestLogFileName = CloneString(kpMCB->lpCSE->lpszFileName);
                lpCIB->lpszTestLogDir = CloneString(kpMCB->lpCSE->lpszDir);
                lpCIB->bTestLogAppend = kpMCB->lpCSE->bAppend;
                break;
            case E_TESTREPORT:
                lpCIB->lpszTestReportFileName = CloneString(kpMCB->lpCSE->lpszFileName);
                lpCIB->lpszTestReportDir = CloneString(kpMCB->lpCSE->lpszDir);
                lpCIB->bTestReportAppend = kpMCB->lpCSE->bAppend;
                break;
            case E_TESTUSERLOG:
                lpCIB->lpszTestUserLogFileName = CloneString(kpMCB->lpCSE->lpszFileName);
                lpCIB->lpszTestUserLogDir = CloneString(kpMCB->lpCSE->lpszDir);
                lpCIB->bTestUserLogAppend = kpMCB->lpCSE->bAppend;
                break;
            case E_TESTINTERVAL:
                lpCIB->lpszTestIntervalFilePrefix = CloneString(lpCIB->lpszFilePrefix);
                if(0 < StrlenNull(kpMCB->lpszCurrDelimiterAttr))
                {
                    if(0 == memcmp(kpMCB->lpszCurrDelimiterAttr, "0x", 2))
                    {
                        memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                        HexToBuff(lpszWorkBuff, kpMCB->lpszCurrDelimiterAttr + 2, WORK_BUFF_LEN);
                        lpCIB->lpszTestIntervalDelimiter = CloneString(lpszWorkBuff);
                    }
                    else
                    {
                        lpCIB->lpszTestIntervalDelimiter = CloneString(kpMCB->lpszCurrDelimiterAttr);
                    }
                }
                else
                {
                    lpCIB->lpszTestIntervalDelimiter = CloneString(kpszSPACE);
                }
                if(0 < StrlenNull(kpMCB->lpszCurrFileExtensionAttr))
                {
                    lpCIB->lpszTestIntervalFileExtension = CloneString(kpMCB->lpszCurrFileExtensionAttr);
                }
                else
                {
                    lpCIB->lpszTestIntervalFileExtension = CloneString(kpszIIR);
                }
                lpCIB->lpszTestIntervalDir = CloneString(kpMCB->lpCSE->lpszDir);
                lpCIB->bTestIntervalAppend = kpMCB->lpCSE->bAppend;
                break;
            case E_TESTMSGSET:
                CreateAndAddMsgSetFileLoadBlk();
                break;
            case E_TESTMAXWAIT:
                lpCIB->lTestMaxWait = ConvNum(NULL, kpMCB->lpszParseCharDataBuff,
                                              "Control.TestMaxWait");
                break;
            case E_NEXTLOGMSGINTERVAL:
                lpCIB->lNextLogMsgInterval = ConvNum(NULL, kpMCB->lpszParseCharDataBuff,
                                                     "Control.NextLogMsgInterval");
                break;
            case E_CONCURRENCY:
                lpCIB->lConcurrency = ConvNum(NULL, kpMCB->lpszParseCharDataBuff,
                                              "Control.Concurrency");
                break;
            case E_CONCURRENCYWAIT:
                lpCIB->lConcurrencyWait = ConvNum(NULL, kpMCB->lpszParseCharDataBuff,
                                                  "Control.ConcurrencyWait");
                break;
            case E_ONERROR:
                lpCIB->lpszOnError = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_CONVTABLEDIR:
                lpCIB->lpszConvTableDir = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_LOCALENCODING:
                lpCIB->lpszLocalEncoding = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_LOCALCODEDCHARSETID:
                lpCIB->lpszLocalCodedCharSetId = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            default:
                ConsoleMsg(22, lpszElementNameBuff, "<Control>");
                kpMCB->lProcessing = FAILURE;
                return;
            }
            break;
        /* Defaults info block related processing */
        case E_DEFAULTS:
            lpDIB = kpMCB->lpDIB;
            switch(eElementIs)
            {
            case E_GETFILE:
                lpDIB->lpGFB = CreateGetFileBlk();
                break;
            case E_PUTFILE:
                lpDIB->lpPFB = CreatePutFileBlk();
                break;
            case E_INLINEDATA:
                lpDIB->lpIDB = CreateInlineDataBlk();
                break;
            case E_OVERLAY:
                lpDIB->lpOVB = CreateOverlayBlk();
                break;
            case E_EXTRACT:
                lpDIB->lpEXB = CreateExtractBlk();
                break;
            case E_SUBSTRING:
                lpDIB->lpSSB = CreateSubstringBlk();
                break;
            case E_GETMSG:
                lpDIB->lpGMB = CreateGetMsgBlk();
                break;
            case E_PUTMSG:
                lpDIB->lpPMB = CreatePutMsgBlk();
                break;
            case E_SELECT:
                lpDIB->lpSLB = CreateSelectBlk();
                break;
            case E_WAITONMSGDEPTH:
                lpDIB->lpWDB = CreateWaitDepthBlk();
                break;
            case E_WAITONTIME:
                lpDIB->lpWTB = CreateWaitTimeBlk();
                break;
            case E_COMPARE:
                lpDIB->lpCMB = CreateCompareBlk();
                break;
            case E_COMMIT:
                lpDIB->lpCOB = CreateCommitBlk();
                break;
            case E_BACKOUT:
                lpDIB->lpBOB = CreateBackoutBlk();
                break;
            case E_SYSTEM:
                lpDIB->lpSYB = CreateSystemBlk();
                break;
            /* E_MQSCCOMMAND has no default */
            /* E_FOR has no default         */
            /* E_IF has no default          */
            /* E_ELSEIF has no default      */
            case E_NUM:
                /* See if a variable info block with this name already exists */
                lpVIB = FindVarInfoBlk(lpDIB->lpVIBHead,
                                       kpMCB->lpszCurrNameAttr);
                if(lpVIB)
                {
                    /* Yes its a duplicate. Stop processing */
                    ConsoleMsg(25, kpszNUM, kpMCB->lpszCurrNameAttr);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                else
                {
                    /* If not create it and add it to the defaults var list */
                    lpVIB = CreateVarInfoBlk(kpMCB->lpszCurrNameAttr);
                    if(lpVIB)
                    {
                        lpVIB->eVarType = V_NUM;
                        if(0 == StrlenNull(kpMCB->lpszCurrFormatAttr))
                        {
                            lpVIB->lpszVarFormat = CloneString(kpszNUMFMT);
                        }
                        else
                        {
                            lpVIB->lpszVarFormat = CloneString(kpMCB->lpszCurrFormatAttr);
                        }
                        /* Convert it to a numeric value */
                        lNewNum = ConvNum(NULL, kpMCB->lpszParseCharDataBuff, lpVIB->lpszVarName);
                        if(FAILURE == kpMCB->lProcessing)
                        {
                            return;
                        }
                        /* Format the new value */
                        sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lNewNum);
                        /* Copy the new value to the VIB */
                        lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
                        /* Add the VIB to the defaults var list */
                        AddToTailOfList((LinkedListBlk**)&lpDIB->lpVIBHead,
                                        (LinkedListBlk**)&lpDIB->lpVIBTail,
                                        (LinkedListBlk*)lpVIB);
                    }
                    else
                    {
                        ConsoleMsg(26, kpszNUM, kpMCB->lpszCurrNameAttr);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                }
                break;
            case E_DOUBLE:
                /* See if a variable info block with this name already exists */
                lpVIB = FindVarInfoBlk(lpDIB->lpVIBHead,
                                       kpMCB->lpszCurrNameAttr);
                if(lpVIB)
                {
                    /* Yes its a duplicate. Stop processing */
                    ConsoleMsg(25, kpszDOUBLE, kpMCB->lpszCurrNameAttr);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                else
                {
                    /* If not create it and add it to the defaults var list */
                    lpVIB = CreateVarInfoBlk(kpMCB->lpszCurrNameAttr);
                    if(lpVIB)
                    {
                        lpVIB->eVarType = V_DOUBLE;
                        if(0 == StrlenNull(kpMCB->lpszCurrFormatAttr))
                        {
                            lpVIB->lpszVarFormat = CloneString(kpszDOUBLEFMT);
                        }
                        else
                        {
                            lpVIB->lpszVarFormat = CloneString(kpMCB->lpszCurrFormatAttr);
                        }
                        /* Convert it to a numeric value */
                        dNewDouble = ConvDouble(NULL, kpMCB->lpszParseCharDataBuff, lpVIB->lpszVarName);
                        if(FAILURE == kpMCB->lProcessing)
                        {
                            return;
                        }
                        /* Format the new value */
                        sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, dNewDouble);
                        /* Copy the new value to the VIB */
                        lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
                        /* Add the VIB to the defaults var list */
                        AddToTailOfList((LinkedListBlk**)&lpDIB->lpVIBHead,
                                        (LinkedListBlk**)&lpDIB->lpVIBTail,
                                        (LinkedListBlk*)lpVIB);
                    }
                    else
                    {
                        ConsoleMsg(26, kpszDOUBLE, kpMCB->lpszCurrNameAttr);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                }
                break;
            case E_STR:
                /* See if a variable info block with this name already exists */
                lpVIB = FindVarInfoBlk(lpDIB->lpVIBHead,
                                       kpMCB->lpszCurrNameAttr);
                if(lpVIB)
                {
                    /* Yes its a duplicate. Stop processing */
                    ConsoleMsg(25, kpszSTR, kpMCB->lpszCurrNameAttr);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                else
                {
                    /* If not create it and add it to the defaults var list */
                    lpVIB = CreateVarInfoBlk(kpMCB->lpszCurrNameAttr);
                    if(lpVIB)
                    {
                        lpVIB->eVarType = V_STR;
                        if(0 == StrlenNull(kpMCB->lpszCurrFormatAttr))
                        {
                            lpVIB->lpszVarFormat = CloneString(kpszSTRFMT);
                        }
                        else
                        {
                            lpVIB->lpszVarFormat = CloneString(kpMCB->lpszCurrFormatAttr);
                        }
                        lpVIB->lpszCurrStrValue = CloneString(kpMCB->lpszParseCharDataBuff);
                        AddToTailOfList((LinkedListBlk**)&lpDIB->lpVIBHead,
                                        (LinkedListBlk**)&lpDIB->lpVIBTail,
                                        (LinkedListBlk*)lpVIB);
                    }
                    else
                    {
                        ConsoleMsg(26, kpszSTR, kpMCB->lpszCurrNameAttr);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                }
                break;
            case E_RANDOMNUM:
                /* See if a variable info block with this name already exists */
                lpVIB = FindVarInfoBlk(lpDIB->lpVIBHead,
                                       kpMCB->lpszCurrNameAttr);
                if(lpVIB)
                {
                    /* Yes its a duplicate. Stop processing */
                    ConsoleMsg(25, kpszNUM, kpMCB->lpszCurrNameAttr);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                else
                {
                    lCheckNum = ConvNum(NULL, kpMCB->lpszCurrFromAttr, kpMCB->lpszCurrNameAttr);
                    if(FAILURE == kpMCB->lProcessing)
                    {
                        return;
                    }
                    lCheckNum = ConvNum(NULL, kpMCB->lpszCurrToAttr, kpMCB->lpszCurrNameAttr);
                    if(FAILURE == kpMCB->lProcessing)
                    {
                        return;
                    }
                    /* If not create it and add it to the defaults var list */
                    lpVIB = CreateVarInfoBlk(kpMCB->lpszCurrNameAttr);
                    if(lpVIB)
                    {
                        lpVIB->eVarType = V_RANDOMNUM;
                        if(0 == StrlenNull(kpMCB->lpszCurrFormatAttr))
                        {
                            lpVIB->lpszVarFormat = CloneString(kpszNUMFMT);
                        }
                        else
                        {
                            lpVIB->lpszVarFormat = CloneString(kpMCB->lpszCurrFormatAttr);
                        }
                        /* Convert it to a numeric value */
                        lNewNum = ConvNum(NULL, kpMCB->lpszParseCharDataBuff, lpVIB->lpszVarName);
                        if(FAILURE == kpMCB->lProcessing)
                        {
                            return;
                        }
                        /* Format the new value */
                        sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lNewNum);
                        /* Copy the new value to the VIB */
                        lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
                        /* Add the VIB to the defaults var list */
                        AddToTailOfList((LinkedListBlk**)&lpDIB->lpVIBHead,
                                        (LinkedListBlk**)&lpDIB->lpVIBTail,
                                        (LinkedListBlk*)lpVIB);
                    }
                    else
                    {
                        ConsoleMsg(26, kpszNUM, kpMCB->lpszCurrNameAttr);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                }
                break;
            case E_LIST:
                /* See if a variable info block with this name already exists */
                lpVIB = FindVarInfoBlk(lpDIB->lpVIBHead,
                                       kpMCB->lpszCurrNameAttr);
                if(lpVIB)
                {
                    /* Yes its a duplicate. Stop processing */
                    ConsoleMsg(25, kpszLIST, kpMCB->lpszCurrNameAttr);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                else
                {
                    /* If not create it and add it to the defaults var list */
                    lpVIB = CreateVarInfoBlk(kpMCB->lpszCurrNameAttr);
                    if(lpVIB)
                    {
                        lpVIB->eVarType = V_LIST;
                        CloneLIB((ListInfoBlk**)&lpVIB->lpCtrlBlk, kpMCB->lpLIB);
                        ClearLIB(kpMCB->lpLIB);
                        AddToTailOfList((LinkedListBlk**)&lpDIB->lpVIBHead,
                                        (LinkedListBlk**)&lpDIB->lpVIBTail,
                                        (LinkedListBlk*)lpVIB);
                    }
                    else
                    {
                        ConsoleMsg(26, kpszLIST, kpMCB->lpszCurrNameAttr);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                }
                break;
            case E_MQMD:
                /* See if a variable info block with this name already exists */
                lpVIB = FindVarInfoBlk(lpDIB->lpVIBHead,
                                       kpMCB->lpszCurrNameAttr);
                if(lpVIB)
                {
                    /* Yes its a duplicate. Stop processing */
                    ConsoleMsg(25, kpszMQMD, kpMCB->lpszCurrNameAttr);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                else
                {
                    /* If not create it and add it to the defaults var list */
                    lpVIB = CreateVarInfoBlk(kpMCB->lpszCurrNameAttr);
                    if(lpVIB)
                    {
                        lpVIB->eVarType = V_MQMD;
                        CloneMIB((MQMDInfoBlk**)&lpVIB->lpCtrlBlk, kpMCB->lpMIB);
                        ClearMIB(kpMCB->lpMIB);
                        AddToTailOfList((LinkedListBlk**)&lpDIB->lpVIBHead,
                                        (LinkedListBlk**)&lpDIB->lpVIBTail,
                                        (LinkedListBlk*)lpVIB);
                    }
                    else
                    {
                        ConsoleMsg(26, kpszMQMD, kpMCB->lpszCurrNameAttr);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                }
                break;
            case E_RFH2:
                /* See if a variable info block with this name already exists */
                lpVIB = FindVarInfoBlk(lpDIB->lpVIBHead,
                                       kpMCB->lpszCurrNameAttr);
                if(lpVIB)
                {
                    /* Yes its a duplicate. Stop processing */
                    ConsoleMsg(25, kpszRFH2, kpMCB->lpszCurrNameAttr);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                else
                {
                    /* If not create it and add it to the defaults var list */
                    lpVIB = CreateVarInfoBlk(kpMCB->lpszCurrNameAttr);
                    if(lpVIB)
                    {
                        lpVIB->eVarType = V_RFH2;
                        CloneRIB((RFH2InfoBlk**)&lpVIB->lpCtrlBlk, kpMCB->lpRIB);
                        ClearRIB(kpMCB->lpRIB);
                        AddToTailOfList((LinkedListBlk**)&lpDIB->lpVIBHead,
                                        (LinkedListBlk**)&lpDIB->lpVIBTail,
                                        (LinkedListBlk*)lpVIB);
                    }
                    else
                    {
                        ConsoleMsg(26, kpszRFH2, kpMCB->lpszCurrNameAttr);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                }
                break;
            /* E_ADD, E_SUBTRACT, E_MULTIPLY, E_DIVIDE and E_EVAL have no defaults */
            default:
                ConsoleMsg(22, lpszElementNameBuff, "<Defaults>");
                kpMCB->lProcessing = FAILURE;
                return;
            }
            break;
        /* Test info block related processing          */
        case E_TEST:
            lpTIB = kpMCB->lpTIBReadyTail;
            lpCCB = NULL;
            switch(eElementIs)
            {
            case E_GETFILE:
                lpCCB = (CommandCtrlBlk*)CreateGetFileBlk();
                break;
            case E_PUTFILE:
                lpCCB = (CommandCtrlBlk*)CreatePutFileBlk();
                break;
            case E_INLINEDATA:
                lpCCB = (CommandCtrlBlk*)CreateInlineDataBlk();
                break;
            case E_OVERLAY:
                lpCCB = (CommandCtrlBlk*)CreateOverlayBlk();
                break;
            case E_EXTRACT:
                lpCCB = (CommandCtrlBlk*)CreateExtractBlk();
                break;
            case E_SUBSTRING:
                lpCCB = (CommandCtrlBlk*)CreateSubstringBlk();
                break;
            case E_GETMSG:
                lpCCB = (CommandCtrlBlk*)CreateGetMsgBlk();
                break;
            case E_PUTMSG:
                lpCCB = (CommandCtrlBlk*)CreatePutMsgBlk();
                break;
            case E_SELECT:
                lpCCB = (CommandCtrlBlk*)CreateSelectBlk();
                break;
            case E_WAITONMSGDEPTH:
                lpCCB = (CommandCtrlBlk*)CreateWaitDepthBlk();
                break;
            case E_WAITONTIME:
                lpCCB = (CommandCtrlBlk*)CreateWaitTimeBlk();
                break;
            case E_COMPARE:
                lpCCB = (CommandCtrlBlk*)CreateCompareBlk();
                break;
            case E_COMMIT:
                lpCCB = (CommandCtrlBlk*)CreateCommitBlk();
                break;
            case E_BACKOUT:
                lpCCB = (CommandCtrlBlk*)CreateBackoutBlk();
                break;
            case E_SYSTEM:
                lpCCB = (CommandCtrlBlk*)CreateSystemBlk();
                break;
            case E_MQSCCOMMAND:
                lpCCB = (CommandCtrlBlk*)CreateMqscCommandBlk();
                break;
            /* A loop statement generates two control blocks a ForStart */
            /* and a ForEnd. Create the ForEnd command block. The       */
            /* ForStart block is created in PSFParseStartElement as it  */
            /* has various attributes that are only available there     */
            case E_FOR:
                lpCCB = (CommandCtrlBlk*)CreateForEndBlk();
                break;
            case E_FOREVER:
                lpCCB = (CommandCtrlBlk*)CreateForEndBlk();
                break;
            case E_FOREACH:
                lpCCB = (CommandCtrlBlk*)CreateForEndBlk();
                break;
            /* A if statement generates two control blocks a IfStart  */
            /* and a IfEnd. Create the IfEnd command block. The       */
            /* IfStart block is created in PSFParseStartElement as it */
            /* has various attributes that are only available there    */
            case E_IF:
                lpCCB = (CommandCtrlBlk*)CreateIfEndBlk();
                break;
            case E_ELSEIF:
                lpCCB = (CommandCtrlBlk*)CreateElseIfBlk();
                break;
            case E_ELSE:
                lpCCB = (CommandCtrlBlk*)CreateElseBlk();
                break;
            case E_CONTINUE:
                lpCCB = (CommandCtrlBlk*)CreateContinueBlk();
                break;
            case E_BREAK:
                lpCCB = (CommandCtrlBlk*)CreateBreakBlk();
                break;
            case E_EXITTEST:
                lpCCB = (CommandCtrlBlk*)CreateExitTestBlk();
                break;
            case E_FAILTEST:
                lpCCB = (CommandCtrlBlk*)CreateFailTestBlk();
                break;
            case E_FINALLY:
                lpCCB = (CommandCtrlBlk*)CreateFinallyEndBlk();
                break;
            case E_NUM:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_NUM);
                break;
            case E_DOUBLE:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_DOUBLE);
                break;
            case E_STR:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_STR);
                break;
            case E_RANDOMNUM:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_RANDOMNUM);
                break;
            case E_LIST:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_LIST);
                break;
            case E_MQMD:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_MQMD);
                break;
            case E_RFH2:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_RFH2);
                break;
            case E_ADD:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_ADD);
                break;
            case E_SUBTRACT:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_SUBTRACT);
                break;
            case E_MULTIPLY:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_MULTIPLY);
                break;
            case E_DIVIDE:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_DIVIDE);
                break;
            case E_EVAL:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_EVAL);
                break;
            case E_LENGTH:
                lpCCB = (CommandCtrlBlk*)CreateLengthBlk();
                break;
            case E_POSITION:
                lpCCB = (CommandCtrlBlk*)CreatePositionBlk();
                break;
            /* IntervalStart, IntervalEnd and StdIn command blocks are */
            /* created in PSFParseStartElement as the Name= attribute  */
            /* is only available there                                 */
            case E_INTERVALSTART:
            case E_INTERVALEND:
            case E_STDIN:
                return;
            case E_STDOUT:
                lpCCB = (CommandCtrlBlk*)CreateStdOutBlk();
                break;
            case E_USERLOG:
                lpCCB = (CommandCtrlBlk*)CreateUserLogBlk();
                break;
            default:
                ConsoleMsg(22, lpszElementNameBuff, "<Test>");
                kpMCB->lProcessing = FAILURE;
                return;
            }
            AddToTailOfList((LinkedListBlk**)&lpTIB->lpCCBHead,
                            (LinkedListBlk**)&lpTIB->lpCCBTail,
                            (LinkedListBlk*)lpCCB);
            break;
        default:
            ConsoleMsg(4, "Invalid parse depth 2 element", lpszElementNameBuff, __LINE__, __FILE__);
            kpMCB->lProcessing = FAILURE;
            return;
        }
        break;
    /* At parse depth 3 and beyond we are processing all sorts of  */
    /* elements. Including the test commands, command sub elements */
    /* and control block sub elements                              */
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 9:
    case 10:
    case 11:
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
        switch(kpMCB->eElementType[1])
        {
        /* Control stuff goes into the CIB */
        case E_CONTROL:
            lpCIB = kpMCB->lpCIB;
            switch(eElementIs)
            {
            case E_QMGR:
                lpCIB->lpszConnQMgrName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_CHANNEL:
                lpCIB->lpszConnChannelName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_HOST:
                lpCIB->lpszConnHostName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_PORT:
                lpCIB->lpszConnPortNum = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_KEYREPOSITORY:
                lpCIB->lpszConnKeyRepository = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_SSLCIPHERSPEC:
                lpCIB->lpszConnSSLCipherSpec = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_SSLPEERNAME:
                lpCIB->lpszConnSSLPeerName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_MAXMSGLENGTH:
                lpCIB->lpszConnMaxMsgLength = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_FILE:
                kpMCB->lpCSE->lpszFileName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_FILEPREFIX:
                lpCIB->lpszFilePrefix = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_APPEND:
                kpMCB->lpCSE->bAppend = TRUE;
                break;
            case E_DIR:
                kpMCB->lpCSE->lpszDir = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_PARSERNAME:
                lpCIB->lpszParserName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            }
            break;
        /* Defaults and Test stuff goes into the CSE */
        case E_DEFAULTS:
        case E_TEST:
            lpTIB = kpMCB->lpTIBReadyTail;
            lpCCB = NULL;
            switch(eElementIs)
            {
            /* -------- */
            /* Commands */
            /* -------- */
            case E_GETFILE:
                lpCCB = (CommandCtrlBlk*)CreateGetFileBlk();
                break;
            case E_PUTFILE:
                lpCCB = (CommandCtrlBlk*)CreatePutFileBlk();
                break;
            case E_INLINEDATA:
                lpCCB = (CommandCtrlBlk*)CreateInlineDataBlk();
                break;
            case E_OVERLAY:
                lpCCB = (CommandCtrlBlk*)CreateOverlayBlk();
                break;
            case E_EXTRACT:
                lpCCB = (CommandCtrlBlk*)CreateExtractBlk();
                break;
            case E_SUBSTRING:
                lpCCB = (CommandCtrlBlk*)CreateSubstringBlk();
                break;
            case E_GETMSG:
                lpCCB = (CommandCtrlBlk*)CreateGetMsgBlk();
                break;
            case E_PUTMSG:
                lpCCB = (CommandCtrlBlk*)CreatePutMsgBlk();
                break;
            case E_SELECT:
                lpCCB = (CommandCtrlBlk*)CreateSelectBlk();
                break;
            case E_WAITONMSGDEPTH:
                lpCCB = (CommandCtrlBlk*)CreateWaitDepthBlk();
                break;
            case E_WAITONTIME:
                lpCCB = (CommandCtrlBlk*)CreateWaitTimeBlk();
                break;
            case E_COMPARE:
                lpCCB = (CommandCtrlBlk*)CreateCompareBlk();
                break;
            case E_COMMIT:
                lpCCB = (CommandCtrlBlk*)CreateCommitBlk();
                break;
            case E_BACKOUT:
                lpCCB = (CommandCtrlBlk*)CreateBackoutBlk();
                break;
            case E_SYSTEM:
                lpCCB = (CommandCtrlBlk*)CreateSystemBlk();
                break;
            case E_MQSCCOMMAND:
                lpCCB = (CommandCtrlBlk*)CreateMqscCommandBlk();
                break;
            case E_FOR:
                lpCCB = (CommandCtrlBlk*)CreateForEndBlk();
                break;
            case E_FOREVER:
                lpCCB = (CommandCtrlBlk*)CreateForEndBlk();
                break;
            case E_FOREACH:
                lpCCB = (CommandCtrlBlk*)CreateForEndBlk();
                break;
            case E_IF:
                lpCCB = (CommandCtrlBlk*)CreateIfEndBlk();
                break;
            case E_ELSEIF:
                lpCCB = (CommandCtrlBlk*)CreateElseIfBlk();
                break;
            case E_ELSE:
                lpCCB = (CommandCtrlBlk*)CreateElseBlk();
                break;
            case E_CONTINUE:
                lpCCB = (CommandCtrlBlk*)CreateContinueBlk();
                break;
            case E_BREAK:
                lpCCB = (CommandCtrlBlk*)CreateBreakBlk();
                break;
            case E_EXITTEST:
                lpCCB = (CommandCtrlBlk*)CreateExitTestBlk();
                break;
            case E_FAILTEST:
                lpCCB = (CommandCtrlBlk*)CreateFailTestBlk();
                break;
            case E_FINALLY:
                lpCCB = (CommandCtrlBlk*)CreateFinallyEndBlk();
                break;
            case E_NUM:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_NUM);
                break;
            case E_DOUBLE:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_DOUBLE);
                break;
            case E_STR:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_STR);
                break;
            case E_RANDOMNUM:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_RANDOMNUM);
                break;
            case E_LIST:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_LIST);
                break;
            case E_MQMD:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_MQMD);
                break;
            case E_RFH2:
                lpCCB = (CommandCtrlBlk*)CreateVarBlk(V_RFH2);
                break;
            case E_ADD:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_ADD);
                break;
            case E_SUBTRACT:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_SUBTRACT);
                break;
            case E_MULTIPLY:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_MULTIPLY);
                break;
            case E_DIVIDE:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_DIVIDE);
                break;
            case E_EVAL:
                lpCCB = (CommandCtrlBlk*)CreateMathFunctionBlk(A_EVAL);
                break;
            case E_LENGTH:
                lpCCB = (CommandCtrlBlk*)CreateLengthBlk();
                break;
            case E_POSITION:
                lpCCB = (CommandCtrlBlk*)CreatePositionBlk();
                break;
            /* IntervalStart, IntervalEnd and StdIn command blocks are */
            /* created in PSFParseStartElement as the Name= attribute  */
            /* is only available there                                 */
            case E_INTERVALSTART:
            case E_INTERVALEND:
            case E_STDIN:
                return;
            case E_STDOUT:
                lpCCB = (CommandCtrlBlk*)CreateStdOutBlk();
                break;
            case E_USERLOG:
                lpCCB = (CommandCtrlBlk*)CreateUserLogBlk();
                break;
            /* -------------------- */
            /* Command sub elements */
            /* -------------------- */
            case E_BUFFER:
                kpMCB->lpCSE->lpszBuffName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_FILE:
                kpMCB->lpCSE->lpszFileName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_REGEX:
                kpMCB->lpCSE->lpszRegexFileName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_DATA:
                kpMCB->lpCSE->lpszData = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_Q:
                kpMCB->lpCSE->lpszQName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_MQSCREPLYDYNAMICQ:
                kpMCB->lpCSE->lpszMqscReplyDynamicQName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_QMGR:
                kpMCB->lpCSE->lpszQMgrName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_DEPTH:
                kpMCB->lpCSE->lpszDepth = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_INTERVAL:
                kpMCB->lpCSE->lpszInterval = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_INTERVALMILLIS:
                kpMCB->lpCSE->lpszIntervalMillis = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_TIME:
                kpMCB->lpCSE->lpszTime = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_RFH2COMP:
                kpMCB->lpCSE->lpszCompRFH2VarName1 = CloneString(kpMCB->lpszCurrR1Attr);
                kpMCB->lpCSE->lpszCompRFH2VarName2 = CloneString(kpMCB->lpszCurrR2Attr);
                break;
            case E_COMMAND:
                kpMCB->lpCSE->lpszCommand = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_MASK:
                kpMCB->lpCSE->lpszMaskFileName = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_CMDMAXWAIT:
                kpMCB->lpCSE->lpszCmdMaxWait = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_GMOOPTIONS:
                kpMCB->lpCSE->lpszGmoOptions = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_PMOOPTIONS:
                kpMCB->lpCSE->lpszPmoOptions = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_GMOMATCHOPTIONS:
                kpMCB->lpCSE->lpszGmoMatchOptions = CloneString(kpMCB->lpszParseCharDataBuff);
                break;
            case E_GMOWAIT:
                kpMCB->lpCSE->lpszGmoWait = CloneString(kpMCB->lpszParseCharDataBuff);
                kpMCB->bGmoWait = TRUE;
                break;
            case E_IGNORERC:
                kpMCB->lpCSE->bIgnoreRC = TRUE;
                break;
            case E_INTERVALINMSGID:
                kpMCB->lpCSE->bIntervalInMsgId = TRUE;
                break;
            case E_INTERVALINCORRELID:
                kpMCB->lpCSE->bIntervalInCorrelId = TRUE;
                break;
            case E_SYNCPOINT:
                kpMCB->lpCSE->bSyncpoint = TRUE;
                break;
            case E_SETIDENTITYCONTEXT:
                kpMCB->lpCSE->bSetIdentityContext = TRUE;
                break;
            case E_SETALLCONTEXT:
                kpMCB->lpCSE->bSetAllContext = TRUE;
                break;
            case E_REMOVEDLH:
                kpMCB->lpCSE->bRemoveDLH = TRUE;
                break;
            case E_REMOVEXQH:
                kpMCB->lpCSE->bRemoveXQH = TRUE;
                break;
            case E_CONVERT:
                kpMCB->lpCSE->bConvert = TRUE;
                break;
            case E_CLEAR:
                kpMCB->lpCSE->bClear = TRUE;
                break;
            case E_LOGANDCONTINUE:
                kpMCB->lpCSE->bLogAndContinue = TRUE;
                break;
            case E_CONTINUEONRC:
                kpMCB->lContinueOnRC[kpMCB->lContinueOnRCCount] = ConvNum(NULL, kpMCB->lpszParseCharDataBuff, "ContinueOnRC");
                kpMCB->lContinueOnRCCount++;
                if(MAX_REASON_CODES <= kpMCB->lContinueOnRCCount)
                {
                    LogMsg(114, "<ContinueOnRC>\0", MAX_REASON_CODES);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                break;
            case E_BREAKONRC:
                kpMCB->lBreakOnRC[kpMCB->lBreakOnRCCount] = ConvNum(NULL, kpMCB->lpszParseCharDataBuff, "BreakOnRC");
                kpMCB->lBreakOnRCCount++;
                if(MAX_REASON_CODES <= kpMCB->lBreakOnRCCount)
                {
                    LogMsg(114, "<BreakOnRC>\0", MAX_REASON_CODES);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                break;
            case E_SUPPRESSRC:
                kpMCB->lSuppressRC[kpMCB->lSuppressRCCount] = ConvNum(NULL, kpMCB->lpszParseCharDataBuff, "SuppressRC");
                kpMCB->lSuppressRCCount++;
                if(MAX_REASON_CODES <= kpMCB->lSuppressRCCount)
                {
                    LogMsg(114, "<SuppressRC>\0", MAX_REASON_CODES);
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                break;
            case E_BROWSE:
                if(0 == memcmp(kpszFIRST, kpMCB->lpszCurrModeAttr, strlen(kpszFIRST) + 1))
                {
                    kpMCB->lpCSE->eBrowseType = B_BROWSEFIRST;
                }
                if(0 == memcmp(kpszNEXT, kpMCB->lpszCurrModeAttr, strlen(kpszNEXT) + 1))
                {
                    kpMCB->lpCSE->eBrowseType = B_BROWSENEXT;
                }
                if(0 == memcmp(kpszAUTO, kpMCB->lpszCurrModeAttr, strlen(kpszAUTO) + 1))
                {
                    kpMCB->lpCSE->eBrowseType = B_BROWSEAUTO;
                }
                break;
            case E_GROUP:
                if(0 == memcmp(kpszNEXT, kpMCB->lpszCurrModeAttr, strlen(kpszNEXT) + 1))
                {
                    kpMCB->lpCSE->eGroupType = G_GROUPNEXT;
                }
                if(0 == memcmp(kpszLAST, kpMCB->lpszCurrModeAttr, strlen(kpszLAST) + 1))
                {
                    kpMCB->lpCSE->eGroupType = G_GROUPLAST;
                }
                if(0 == memcmp(kpszAUTO, kpMCB->lpszCurrModeAttr, strlen(kpszAUTO) + 1))
                {
                    kpMCB->lpCSE->eGroupType = G_GROUPAUTO;
                }
                break;
            case E_APPEND:
                kpMCB->lpCSE->bAppend = TRUE;
                break;
            /* MessageRate blocks are created in PSFParseStartElement as the */
            /* From=, To= and Mode= attribute are only available there       */
            case E_MESSAGERATE:
                kpMCB->bMessageRate = TRUE;
                kpMCB->bReportMessageRate = TRUE;
                break;
            /* -------------------------- */
            /* Control block sub elements */
            /* -------------------------- */
            case E_FOLDER:
            case E_LISTELEMENT:
            case E_FORMAT:
            case E_VERSION:
            case E_REPORT:
            case E_MSGTYPE:
            case E_EXPIRY:
            case E_FEEDBACK:
            case E_ENCODING:
            case E_CODEDCHARSETID:
            case E_PRIORITY:
            case E_PERSISTENCE:
            case E_MSGID:
            case E_CORRELID:
            case E_BACKOUTCOUNT:
            case E_REPLYTOQ:
            case E_REPLYTOQMGR:
            case E_USERIDENTIFIER:
            case E_ACCOUNTINGTOKEN:
            case E_APPLIDENTITYDATA:
            case E_PUTAPPLTYPE:
            case E_PUTAPPLNAME:
            case E_PUTDATE:
            case E_PUTTIME:
            case E_APPLORIGINDATA:
            case E_GROUPID:
            case E_MSGSEQNUMBER:
            case E_OFFSET:
            case E_MSGFLAGS:
            case E_ORIGINALLENGTH:
            case E_LISTFILE:
            case E_MQMDFILE:
            case E_RFH2FILE:
            case E_DIR:
                switch(kpMCB->eElementType[kpMCB->lScriptParseDepth - 1])
                {
                /* List */
                case E_LIST:
                    switch(eElementIs)
                    {
                    case E_LISTELEMENT:
                        /* Hold ListElement info in the MCB's linked list until it  */
                        /* can be consumed by the parse depth 2 command             */
                        AddLEB(kpMCB->lpLIB, kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_LISTFILE:
                        kpMCB->lpLIB->lpszListFileName = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_DIR:
                        kpMCB->lpLIB->lpszDir = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    default:
                        ConsoleMsg(178, lpszElementNameBuff, kpszLIST);
                        kpMCB->lProcessing = FAILURE;
                        break;
                    }
                    break;
                /* MQMD */
                case E_MQMD:
                    switch(eElementIs)
                    {
                    case E_VERSION:
                        kpMCB->lpMIB->lpszVersion = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_REPORT:
                        kpMCB->lpMIB->lpszReport = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_MSGTYPE:
                        kpMCB->lpMIB->lpszMsgType = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_EXPIRY:
                        kpMCB->lpMIB->lpszExpiry = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_FEEDBACK:
                        kpMCB->lpMIB->lpszFeedback = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_ENCODING:
                        kpMCB->lpMIB->lpszEncoding = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_CODEDCHARSETID:
                        kpMCB->lpMIB->lpszCodedCharSetId = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_FORMAT:
                        kpMCB->lpMIB->lpszFormat = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_PRIORITY:
                        kpMCB->lpMIB->lpszPriority = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_PERSISTENCE:
                        kpMCB->lpMIB->lpszPersistence = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_MSGID:
                        kpMCB->lpMIB->lpszMsgId = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_CORRELID:
                        kpMCB->lpMIB->lpszCorrelId = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_BACKOUTCOUNT:
                        kpMCB->lpMIB->lpszBackoutCount = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_REPLYTOQ:
                        kpMCB->lpMIB->lpszReplyToQ = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_REPLYTOQMGR:
                        kpMCB->lpMIB->lpszReplyToQMgr = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_USERIDENTIFIER:
                        kpMCB->lpMIB->lpszUserIdentifier = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_ACCOUNTINGTOKEN:
                        kpMCB->lpMIB->lpszAccountingToken = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_APPLIDENTITYDATA:
                        kpMCB->lpMIB->lpszApplIdentityData = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_PUTAPPLTYPE:
                        kpMCB->lpMIB->lpszPutApplType = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_PUTAPPLNAME:
                        kpMCB->lpMIB->lpszPutApplName = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_PUTDATE:
                        kpMCB->lpMIB->lpszPutDate = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_PUTTIME:
                        kpMCB->lpMIB->lpszPutTime = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_APPLORIGINDATA:
                        kpMCB->lpMIB->lpszApplOriginData = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_GROUPID:
                        kpMCB->lpMIB->lpszGroupId = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_MSGSEQNUMBER:
                        kpMCB->lpMIB->lpszMsgSeqNumber = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_OFFSET:
                        kpMCB->lpMIB->lpszOffset = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_MSGFLAGS:
                        kpMCB->lpMIB->lpszMsgFlags = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_ORIGINALLENGTH:
                        kpMCB->lpMIB->lpszOriginalLength = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_MQMDFILE:
                        kpMCB->lpMIB->lpszMQMDFileName = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_DIR:
                        kpMCB->lpMIB->lpszDir = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    default:
                        ConsoleMsg(178, lpszElementNameBuff, kpszMQMD);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                    break;
                /* RFH2 */
                case E_RFH2:
                    switch(eElementIs)
                    {
                    case E_FOLDER:
                        /* Hold Folder info in the MCB's linked list until it  */
                        /* can be consumed by the parse depth 2 command        */
                        CheckAndAddFIB(lpTIB, kpMCB->lpRIB, TRUE);
                        break;
                    case E_FORMAT:
                        kpMCB->lpRIB->lpszFormat = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_RFH2FILE:
                        kpMCB->lpRIB->lpszRFH2FileName = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_DIR:
                        kpMCB->lpRIB->lpszDir = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    default:
                        ConsoleMsg(178, lpszElementNameBuff, kpszRFH2);
                        kpMCB->lProcessing = FAILURE;
                        return;
                    }
                    break;
                default:
                    switch(eElementIs)
                    {
                    case E_MSGID:
                        kpMCB->lpCSE->lpszMsgId = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_CORRELID:
                        kpMCB->lpCSE->lpszCorrelId = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_GROUPID:
                        kpMCB->lpCSE->lpszGroupId = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_MSGSEQNUMBER:
                        kpMCB->lpCSE->lpszMsgSeqNumber = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_FORMAT:
                        kpMCB->lpCSE->lpszFormat = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_MQMDFILE:
                        kpMCB->lpCSE->lpszMQMDFileName = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_RFH2FILE:
                        kpMCB->lpCSE->lpszRFH2FileName = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    case E_DIR:
                        kpMCB->lpCSE->lpszDir = CloneString(kpMCB->lpszParseCharDataBuff);
                        break;
                    }
                    break;
                }
                break;
            default:
                ConsoleMsg(4, "Invalid element", lpszElementNameBuff, __LINE__, __FILE__);
                kpMCB->lProcessing = FAILURE;
                return;
            }
            if(lpCCB)
            {
                AddToTailOfList((LinkedListBlk**)&lpTIB->lpCCBHead,
                                (LinkedListBlk**)&lpTIB->lpCCBTail,
                                (LinkedListBlk*)lpCCB);
            }
            break;
        }
        /* Reset the ParseCharData buffer */
        ClearPCDB();
        break;
    default:
        ConsoleMsg(4, "Invalid parse depth", lpszElementNameBuff, __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return;
    }

    /* Clear the element name buffer and element type entries */
    if(0 <= kpMCB->lScriptParseDepth)
    {
        memset(kpMCB->lplpszElementName[kpMCB->lScriptParseDepth], 0x00, NAME_BUFF_LEN + 4);
        kpMCB->eElementType[kpMCB->lScriptParseDepth] = E_UNKNOWN;
    }
}

/*--------------------------------------------------------------------------*/
static void XMLCALL
PSFParseCharData(void* vpUserData, const XML_Char* kpszCD, int lLen)
{
    MainCtrlBlk*  kpMCB;
    long          lPCDBuffLen;
    char*         lpszNewBuff;
    long          lTotalDataLen;

    /* Get the main control block pointer */
    kpMCB = vpUserData;

    /* Already FAILED? Don't do anything else */
    if(FAILURE == kpMCB->lProcessing)
    {
        return;
    }

    /* Got some data so allocate and initialise an area to copy it to */
    lTotalDataLen = kpMCB->lParseCharDataLen + lLen;
    lPCDBuffLen = (((lTotalDataLen + 8) / 8) + 1) * 8;
    lpszNewBuff = malloc(lPCDBuffLen);
    if(! lpszNewBuff)
    {
        kpMCB->lParseCharDataLen = 0;
        kpMCB->lpszParseCharDataBuff = NULL;
        ConsoleMsg(3, sizeof(lPCDBuffLen), "ParseCharData", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return;
    }
    memset(lpszNewBuff, 0x00, lPCDBuffLen);

    /* If it exists copy data from any preceding buffer to the new buffer */
    if(0 < kpMCB->lParseCharDataLen)
    {
        memcpy(lpszNewBuff, kpMCB->lpszParseCharDataBuff, kpMCB->lParseCharDataLen);
        FreeIfNotNull((void**)&kpMCB->lpszParseCharDataBuff);
        memcpy(lpszNewBuff + kpMCB->lParseCharDataLen, kpszCD, lLen);
    }
    else
    {
        memcpy(lpszNewBuff, kpszCD, lLen);
    }
    kpMCB->lpszParseCharDataBuff = lpszNewBuff;
    kpMCB->lParseCharDataLen = lTotalDataLen;
}

/*--------------------------------------------------------------------------*/
static void XMLCALL
PSFComments(void* vpUserData, const XML_Char* kpszComment)
{
    /* Don't do anything with comments at the moment */

    /* Pretend to do something so dont get level 4 warnings */
    /* about unreferenced formal parameters                 */
    void*  vpUD;
    char*  kpszC;
    
    vpUD = vpUserData;
    kpszC = (char*)kpszComment;
}


/*--------------------------------------------------------------------------*/
void
PSFDisplayParseError(long lMsgNum)
{
    long lIdx;

    ConsoleMsg(lMsgNum);
    for(lIdx = 0; lIdx <= kpMCB->lScriptParseDepth; lIdx++)
    {
        printf("%s.", kpMCB->lplpszElementName[lIdx]);
    }
    printf("\n");
}

/*--------------------------------------------------------------------------*/
enum eElementEnum
PSFGetElementType(const char *kpszElementName)
{
    enum eElementEnum eElementIs;

    /* Firstly try the MQMD and RFH2 elements by calling */
    /*  the control block parsers element type routine   */
    eElementIs = PCBGetElementType(kpszElementName);
    if(E_UNKNOWN != eElementIs)
    {
        return eElementIs; /* Already identified so return now */
    }

    /* Now try the various command elements. Test is done to a length of +1 */
    /* to include the trailing null and thus avoid incorrect matches        */
    if(0 == memcmp(kpszMSGTEST, kpszElementName, strlen(kpszMSGTEST) + 1))
    {
        eElementIs = E_MSGTEST;
    }
    else if(0 == memcmp(kpszCONTROL, kpszElementName, strlen(kpszCONTROL) + 1))
    {
        eElementIs = E_CONTROL;
    }
    else if(0 == memcmp(kpszDEFAULTS, kpszElementName, strlen(kpszDEFAULTS) + 1))
    {
        eElementIs = E_DEFAULTS;
    }
    else if(0 == memcmp(kpszTEST, kpszElementName, strlen(kpszTEST) + 1))
    {
        eElementIs = E_TEST;
    }
    else if(0 == memcmp(kpszCONNECTION, kpszElementName, strlen(kpszCONNECTION) + 1))
    {
        eElementIs = E_CONNECTION;
    }
    else if(0 == memcmp(kpszQMGR, kpszElementName, strlen(kpszQMGR) + 1))
    {
        eElementIs = E_QMGR;
    }
    else if(0 == memcmp(kpszCHANNEL, kpszElementName, strlen(kpszCHANNEL) + 1))
    {
        eElementIs = E_CHANNEL;
    }
    else if(0 == memcmp(kpszHOST, kpszElementName, strlen(kpszHOST) + 1))
    {
        eElementIs = E_HOST;
    }
    else if(0 == memcmp(kpszPORT, kpszElementName, strlen(kpszPORT) + 1))
    {
        eElementIs = E_PORT;
    }
    else if(0 == memcmp(kpszKEYSTORE, kpszElementName, strlen(kpszKEYSTORE) + 1))
    {
        eElementIs = E_KEYREPOSITORY;
    }
    else if(0 == memcmp(kpszENCRYPTALG, kpszElementName, strlen(kpszENCRYPTALG) + 1))
    {
        eElementIs = E_SSLCIPHERSPEC;
    }
    else if(0 == memcmp(kpszCOMMONNAME, kpszElementName, strlen(kpszCOMMONNAME) + 1))
    {
        eElementIs = E_SSLPEERNAME;
    }
    else if(0 == memcmp(kpszKEYREPOSITORY, kpszElementName, strlen(kpszKEYREPOSITORY) + 1))
    {
        eElementIs = E_KEYREPOSITORY;
    }
    else if(0 == memcmp(kpszSSLCIPHERSPEC, kpszElementName, strlen(kpszSSLCIPHERSPEC) + 1))
    {
        eElementIs = E_SSLCIPHERSPEC;
    }
    else if(0 == memcmp(kpszSSLPEERNAME, kpszElementName, strlen(kpszSSLPEERNAME) + 1))
    {
        eElementIs = E_SSLPEERNAME;
    }
    else if(0 == memcmp(kpszMAXMSGLENGTH, kpszElementName, strlen(kpszMAXMSGLENGTH) + 1))
    {
        eElementIs = E_MAXMSGLENGTH;
    }
    else if(0 == memcmp(kpszTESTLOG, kpszElementName, strlen(kpszTESTLOG) + 1))
    {
        eElementIs = E_TESTLOG;
    }
    else if(0 == memcmp(kpszTESTREPORT, kpszElementName, strlen(kpszTESTREPORT) + 1))
    {
        eElementIs = E_TESTREPORT;
    }
    else if(0 == memcmp(kpszTESTUSERLOG, kpszElementName, strlen(kpszTESTUSERLOG) + 1))
    {
        eElementIs = E_TESTUSERLOG;
    }
    else if(0 == memcmp(kpszTESTINTERVAL, kpszElementName, strlen(kpszTESTINTERVAL) + 1))
    {
        eElementIs = E_TESTINTERVAL;
    }
    else if(0 == memcmp(kpszTESTMSGSET, kpszElementName, strlen(kpszTESTMSGSET) + 1))
    {
        eElementIs = E_TESTMSGSET;
    }
    else if(0 == memcmp(kpszTESTMAXWAIT, kpszElementName, strlen(kpszTESTMAXWAIT) + 1))
    {
        eElementIs = E_TESTMAXWAIT;
    }
    else if(0 == memcmp(kpszNEXTLOGMSGINTERVAL, kpszElementName, strlen(kpszNEXTLOGMSGINTERVAL) + 1))
    {
        eElementIs = E_NEXTLOGMSGINTERVAL;
    }
    else if(0 == memcmp(kpszCONCURRENCY, kpszElementName, strlen(kpszCONCURRENCY) + 1))
    {
        eElementIs = E_CONCURRENCY;
    }
    else if(0 == memcmp(kpszCONCURRENCYWAIT, kpszElementName, strlen(kpszCONCURRENCYWAIT) + 1))
    {
        eElementIs = E_CONCURRENCYWAIT;
    }
    else if(0 == memcmp(kpszONERROR, kpszElementName, strlen(kpszONERROR) + 1))
    {
        eElementIs = E_ONERROR;
    }
    else if(0 == memcmp(kpszCONVTABLEDIR, kpszElementName, strlen(kpszCONVTABLEDIR) + 1))
    {
        eElementIs = E_CONVTABLEDIR;
    }
    else if(0 == memcmp(kpszLOCALENCODING, kpszElementName, strlen(kpszLOCALENCODING) + 1))
    {
        eElementIs = E_LOCALENCODING;
    }
    else if(0 == memcmp(kpszLOCALCODEDCHARSETID, kpszElementName, strlen(kpszLOCALCODEDCHARSETID) + 1))
    {
        eElementIs = E_LOCALCODEDCHARSETID;
    }
    else if(0 == memcmp(kpszNUM, kpszElementName, strlen(kpszNUM) + 1))
    {
        eElementIs = E_NUM;
    }
    else if(0 == memcmp(kpszDOUBLE, kpszElementName, strlen(kpszDOUBLE) + 1))
    {
        eElementIs = E_DOUBLE;
    }
    else if(0 == memcmp(kpszSTR, kpszElementName, strlen(kpszSTR) + 1))
    {
        eElementIs = E_STR;
    }
    else if(0 == memcmp(kpszRANDOMNUM, kpszElementName, strlen(kpszRANDOMNUM) + 1))
    {
        eElementIs = E_RANDOMNUM;
    }
    else if(0 == memcmp(kpszLIST, kpszElementName, strlen(kpszLIST) + 1))
    {
        eElementIs = E_LIST;
    }
    else if(0 == memcmp(kpszGETFILE, kpszElementName, strlen(kpszGETFILE) + 1))
    {
        eElementIs = E_GETFILE;
    }
    else if(0 == memcmp(kpszPUTFILE, kpszElementName, strlen(kpszPUTFILE) + 1))
    {
        eElementIs = E_PUTFILE;
    }
    else if(0 == memcmp(kpszINLINEDATA, kpszElementName, strlen(kpszINLINEDATA) + 1))
    {
        eElementIs = E_INLINEDATA;
    }
    else if(0 == memcmp(kpszOVERLAY, kpszElementName, strlen(kpszOVERLAY) + 1))
    {
        eElementIs = E_OVERLAY;
    }
    else if(0 == memcmp(kpszEXTRACT, kpszElementName, strlen(kpszEXTRACT) + 1))
    {
        eElementIs = E_EXTRACT;
    }
    else if(0 == memcmp(kpszSUBSTRING, kpszElementName, strlen(kpszSUBSTRING) + 1))
    {
        eElementIs = E_SUBSTRING;
    }
    else if(0 == memcmp(kpszGETMSG, kpszElementName, strlen(kpszGETMSG) + 1))
    {
        eElementIs = E_GETMSG;
    }
    else if(0 == memcmp(kpszPUTMSG, kpszElementName, strlen(kpszPUTMSG) + 1))
    {
        eElementIs = E_PUTMSG;
    }
    else if(0 == memcmp(kpszSELECT, kpszElementName, strlen(kpszSELECT) + 1))
    {
        eElementIs = E_SELECT;
    }
    else if(0 == memcmp(kpszWAITONMSGDEPTH, kpszElementName, strlen(kpszWAITONMSGDEPTH) + 1))
    {
        eElementIs = E_WAITONMSGDEPTH;
    }
    else if(0 == memcmp(kpszWAITONTIME, kpszElementName, strlen(kpszWAITONTIME) + 1))
    {
        eElementIs = E_WAITONTIME;
    }
    else if(0 == memcmp(kpszCOMPARE, kpszElementName, strlen(kpszCOMPARE) + 1))
    {
        eElementIs = E_COMPARE;
    }
    else if(0 == memcmp(kpszCOMMIT, kpszElementName, strlen(kpszCOMMIT) + 1))
    {
        eElementIs = E_COMMIT;
    }
    else if(0 == memcmp(kpszBACKOUT, kpszElementName, strlen(kpszBACKOUT) + 1))
    {
        eElementIs = E_BACKOUT;
    }
    else if(0 == memcmp(kpszSYSTEM, kpszElementName, strlen(kpszSYSTEM) + 1))
    {
        eElementIs = E_SYSTEM;
    }
    else if(0 == memcmp(kpszMQSCCOMMAND, kpszElementName, strlen(kpszMQSCCOMMAND) + 1))
    {
        eElementIs = E_MQSCCOMMAND;
    }
    else if(0 == memcmp(kpszFOR, kpszElementName, strlen(kpszFOR) + 1))
    {
        eElementIs = E_FOR;
    }
    else if(0 == memcmp(kpszFOREVER, kpszElementName, strlen(kpszFOREVER) + 1))
    {
        eElementIs = E_FOREVER;
    }
    else if(0 == memcmp(kpszFOREACH, kpszElementName, strlen(kpszFOREACH) + 1))
    {
        eElementIs = E_FOREACH;
    }
    else if(0 == memcmp(kpszIF, kpszElementName, strlen(kpszIF) + 1))
    {
        eElementIs = E_IF;
    }
    else if(0 == memcmp(kpszELSEIF, kpszElementName, strlen(kpszELSEIF) + 1))
    {
        eElementIs = E_ELSEIF;
    }
    else if(0 == memcmp(kpszELSE, kpszElementName, strlen(kpszELSE) + 1))
    {
        eElementIs = E_ELSE;
    }
    else if(0 == memcmp(kpszCONTINUE, kpszElementName, strlen(kpszCONTINUE) + 1))
    {
        eElementIs = E_CONTINUE;
    }
    else if(0 == memcmp(kpszBREAK, kpszElementName, strlen(kpszBREAK) + 1))
    {
        eElementIs = E_BREAK;
    }
    else if(0 == memcmp(kpszEXITTEST, kpszElementName, strlen(kpszEXITTEST) + 1))
    {
        eElementIs = E_EXITTEST;
    }
    else if(0 == memcmp(kpszFAILTEST, kpszElementName, strlen(kpszFAILTEST) + 1))
    {
        eElementIs = E_FAILTEST;
    }
    else if(0 == memcmp(kpszFINALLY, kpszElementName, strlen(kpszFINALLY) + 1))
    {
        eElementIs = E_FINALLY;
    }
    else if(0 == memcmp(kpszBUFFER, kpszElementName, strlen(kpszBUFFER) + 1))
    {
        eElementIs = E_BUFFER;
    }
    else if(0 == memcmp(kpszFILE, kpszElementName, strlen(kpszFILE) + 1))
    {
        eElementIs = E_FILE;
    }
    else if(0 == memcmp(kpszFILEPREFIX, kpszElementName, strlen(kpszFILEPREFIX) + 1))
    {
        eElementIs = E_FILEPREFIX;
    }
    else if(0 == memcmp(kpszLISTFILE, kpszElementName, strlen(kpszLISTFILE) + 1))
    {
        eElementIs = E_LISTFILE;
    }
    else if(0 == memcmp(kpszREGEX, kpszElementName, strlen(kpszREGEX) + 1))
    {
        eElementIs = E_REGEX;
    }
    else if(0 == memcmp(kpszMQMDFILE, kpszElementName, strlen(kpszMQMDFILE) + 1))
    {
        eElementIs = E_MQMDFILE;
    }
    else if(0 == memcmp(kpszRFH2FILE, kpszElementName, strlen(kpszRFH2FILE) + 1))
    {
        eElementIs = E_RFH2FILE;
    }
    else if(0 == memcmp(kpszDIR, kpszElementName, strlen(kpszDIR) + 1))
    {
        eElementIs = E_DIR;
    }
    else if(0 == memcmp(kpszCMDMAXWAIT, kpszElementName, strlen(kpszCMDMAXWAIT) + 1))
    {
        eElementIs = E_CMDMAXWAIT;
    }
    else if(0 == memcmp(kpszGMOOPTIONS, kpszElementName, strlen(kpszGMOOPTIONS) + 1))
    {
        eElementIs = E_GMOOPTIONS;
    }
    else if(0 == memcmp(kpszPMOOPTIONS, kpszElementName, strlen(kpszPMOOPTIONS) + 1))
    {
        eElementIs = E_PMOOPTIONS;
    }
    else if(0 == memcmp(kpszGMOMATCHOPTIONS, kpszElementName, strlen(kpszGMOMATCHOPTIONS) + 1))
    {
        eElementIs = E_GMOMATCHOPTIONS;
    }
    else if(0 == memcmp(kpszGMOWAIT, kpszElementName, strlen(kpszGMOWAIT) + 1))
    {
        eElementIs = E_GMOWAIT;
    }
    else if(0 == memcmp(kpszDATA, kpszElementName, strlen(kpszDATA) + 1))
    {
        eElementIs = E_DATA;
    }
    else if(0 == memcmp(kpszQ, kpszElementName, strlen(kpszQ) + 1))
    {
        eElementIs = E_Q;
    }
    else if(0 == memcmp(kpszMQSCREPLYDYNAMICQ, kpszElementName, strlen(kpszMQSCREPLYDYNAMICQ) + 1))
    {
        eElementIs = E_MQSCREPLYDYNAMICQ;
    }
    else if(0 == memcmp(kpszDEPTH, kpszElementName, strlen(kpszDEPTH) + 1))
    {
        eElementIs = E_DEPTH;
    }
    else if(0 == memcmp(kpszINTERVAL, kpszElementName, strlen(kpszINTERVAL) + 1))
    {
        eElementIs = E_INTERVAL;
    }
    else if(0 == memcmp(kpszINTERVALMILLIS, kpszElementName, strlen(kpszINTERVALMILLIS) + 1))
    {
        eElementIs = E_INTERVALMILLIS;
    }
    else if(0 == memcmp(kpszTIME, kpszElementName, strlen(kpszTIME) + 1))
    {
        eElementIs = E_TIME;
    }
    else if(0 == memcmp(kpszRFH2COMP, kpszElementName, strlen(kpszRFH2COMP) + 1))
    {
        eElementIs = E_RFH2COMP;
    }
    else if(0 == memcmp(kpszMASK, kpszElementName, strlen(kpszMASK) + 1))
    {
        eElementIs = E_MASK;
    }
    else if(0 == memcmp(kpszCOMMAND, kpszElementName, strlen(kpszCOMMAND) + 1))
    {
        eElementIs = E_COMMAND;
    }
    else if(0 == memcmp(kpszIGNORERC, kpszElementName, strlen(kpszIGNORERC) + 1))
    {
        eElementIs = E_IGNORERC;
    }
    else if(0 == memcmp(kpszMQRFH2, kpszElementName, strlen(kpszMQRFH2) + 1))
    {
        eElementIs = E_MQRFH2;
    }
    else if(0 == memcmp(kpszFOLDER, kpszElementName, strlen(kpszFOLDER) + 1))
    {
        eElementIs = E_FOLDER;
    }
    else if(0 == memcmp(kpszLISTELEMENT, kpszElementName, strlen(kpszLISTELEMENT) + 1))
    {
        eElementIs = E_LISTELEMENT;
    }
    else if(0 == memcmp(kpszINTERVALSTART, kpszElementName, strlen(kpszINTERVALSTART) + 1))
    {
        eElementIs = E_INTERVALSTART;
    }
    else if(0 == memcmp(kpszINTERVALEND, kpszElementName, strlen(kpszINTERVALEND) + 1))
    {
        eElementIs = E_INTERVALEND;
    }
    else if(0 == memcmp(kpszINTERVALINMSGID, kpszElementName, strlen(kpszINTERVALINMSGID) + 1))
    {
        eElementIs = E_INTERVALINMSGID;
    }
    else if(0 == memcmp(kpszINTERVALINCORRELID, kpszElementName, strlen(kpszINTERVALINCORRELID) + 1))
    {
        eElementIs = E_INTERVALINCORRELID;
    }
    else if(0 == memcmp(kpszSYNCPOINT, kpszElementName, strlen(kpszSYNCPOINT) + 1))
    {
        eElementIs = E_SYNCPOINT;
    }
    else if(0 == memcmp(kpszSETIDENTITYCONTEXT, kpszElementName, strlen(kpszSETIDENTITYCONTEXT) + 1))
    {
        eElementIs = E_SETIDENTITYCONTEXT;
    }
    else if(0 == memcmp(kpszSETALLCONTEXT, kpszElementName, strlen(kpszSETALLCONTEXT) + 1))
    {
        eElementIs = E_SETALLCONTEXT;
    }
    else if(0 == memcmp(kpszREMOVEDLH, kpszElementName, strlen(kpszREMOVEDLH) + 1))
    {
        eElementIs = E_REMOVEDLH;
    }
    else if(0 == memcmp(kpszREMOVEXQH, kpszElementName, strlen(kpszREMOVEXQH) + 1))
    {
        eElementIs = E_REMOVEXQH;
    }
    else if(0 == memcmp(kpszMESSAGERATE, kpszElementName, strlen(kpszMESSAGERATE) + 1))
    {
        eElementIs = E_MESSAGERATE;
    }
    else if(0 == memcmp(kpszCONVERT, kpszElementName, strlen(kpszCONVERT) + 1))
    {
        eElementIs = E_CONVERT;
    }
    else if(0 == memcmp(kpszCLEAR, kpszElementName, strlen(kpszCLEAR) + 1))
    {
        eElementIs = E_CLEAR;
    }
    else if(0 == memcmp(kpszLOGANDCONTINUE, kpszElementName, strlen(kpszLOGANDCONTINUE) + 1))
    {
        eElementIs = E_LOGANDCONTINUE;
    }
    else if(0 == memcmp(kpszCONTINUEONRC, kpszElementName, strlen(kpszCONTINUEONRC) + 1))
    {
        eElementIs = E_CONTINUEONRC;
    }
    else if(0 == memcmp(kpszBREAKONRC, kpszElementName, strlen(kpszBREAKONRC) + 1))
    {
        eElementIs = E_BREAKONRC;
    }
    else if(0 == memcmp(kpszSUPPRESSRC, kpszElementName, strlen(kpszSUPPRESSRC) + 1))
    {
        eElementIs = E_SUPPRESSRC;
    }
    else if(0 == memcmp(kpszPARSERNAME, kpszElementName, strlen(kpszPARSERNAME) + 1))
    {
        eElementIs = E_PARSERNAME;
    }
    else if(0 == memcmp(kpszBROWSE, kpszElementName, strlen(kpszBROWSE) + 1))
    {
        eElementIs = E_BROWSE;
    }
    else if(0 == memcmp(kpszGROUP, kpszElementName, strlen(kpszGROUP) + 1))
    {
        eElementIs = E_GROUP;
    }
    else if(0 == memcmp(kpszAPPEND, kpszElementName, strlen(kpszAPPEND) + 1))
    {
        eElementIs = E_APPEND;
    }
    else if(0 == memcmp(kpszSTDIN, kpszElementName, strlen(kpszSTDIN) + 1))
    {
        eElementIs = E_STDIN;
    }
    else if(0 == memcmp(kpszSTDOUT, kpszElementName, strlen(kpszSTDOUT) + 1))
    {
        eElementIs = E_STDOUT;
    }
    else if(0 == memcmp(kpszUSERLOG, kpszElementName, strlen(kpszUSERLOG) + 1))
    {
        eElementIs = E_USERLOG;
    }
    else if(0 == memcmp(kpszADD, kpszElementName, strlen(kpszADD) + 1))
    {
        eElementIs = E_ADD;
    }
    else if(0 == memcmp(kpszSUBTRACT, kpszElementName, strlen(kpszSUBTRACT) + 1))
    {
        eElementIs = E_SUBTRACT;
    }
    else if(0 == memcmp(kpszMULTIPLY, kpszElementName, strlen(kpszMULTIPLY) + 1))
    {
        eElementIs = E_MULTIPLY;
    }
    else if(0 == memcmp(kpszDIVIDE, kpszElementName, strlen(kpszDIVIDE) + 1))
    {
        eElementIs = E_DIVIDE;
    }
    else if(0 == memcmp(kpszEVAL, kpszElementName, strlen(kpszEVAL) + 1))
    {
        eElementIs = E_EVAL;
    }
    else if(0 == memcmp(kpszLENGTH, kpszElementName, strlen(kpszLENGTH) + 1))
    {
        eElementIs = E_LENGTH;
    }
    else if(0 == memcmp(kpszPOSITION, kpszElementName, strlen(kpszPOSITION) + 1))
    {
        eElementIs = E_POSITION;
    }
    else
    {
        eElementIs = E_UNKNOWN;
    }

    return eElementIs;
}

/*--------------------------------------------------------------------------*/
GetFileBlk*
CreateGetFileBlk()
{
    GetFileBlk* lpGFB;
    long        lIdx;

    lpGFB = malloc(sizeof(GetFileBlk));
    if(lpGFB)
    {
        memset(lpGFB, 0x00, sizeof(GetFileBlk));
        lpGFB->lpCCBNext = NULL;
        lpGFB->lpCCBPrev = NULL;
        lpGFB->eCommandType = C_GETFILE;
        lpGFB->eCommandState = S_UNKNOWN;
        lpGFB->lpBIB = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpGFB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpGFB->lpBreakContinueFSB = NULL;
        }
        lpGFB->lpszMQMDVarName = CloneString(kpMCB->lpszCurrMQMDAttr);
        lpGFB->lpszRFH2VarName = CloneString(kpMCB->lpszCurrRFH2Attr);
        lpGFB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpGFB->lpszFileName = CloneString(kpMCB->lpCSE->lpszFileName);
        lpGFB->lpszMQMDFileName = CloneString(kpMCB->lpCSE->lpszMQMDFileName);
        lpGFB->lpszRFH2FileName = CloneString(kpMCB->lpCSE->lpszRFH2FileName);
        lpGFB->lpszDir = CloneString(kpMCB->lpCSE->lpszDir);
        lpGFB->lpszCmdMaxWait = CloneString(kpMCB->lpCSE->lpszCmdMaxWait);
        lpGFB->lpszResMQMDVarName = NULL;
        lpGFB->lpszResRFH2VarName = NULL;
        lpGFB->lpszResBuffName = NULL;
        lpGFB->lpszResFileName = NULL;
        lpGFB->lpszResMQMDFileName = NULL;
        lpGFB->lpszResRFH2FileName = NULL;
        lpGFB->lpszResDir = NULL;
        lpGFB->lpszResCmdMaxWait = NULL;
        lpGFB->lMaxWait = -1;
        lpGFB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpGFB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpGFB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpGFB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpGFB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpGFB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }
        ClearCSE();
        ClearRC();
    }
    else
    {
        ConsoleMsg(3, sizeof(GetFileBlk), "GetFileBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpGFB;
}

/*--------------------------------------------------------------------------*/
PutFileBlk*
CreatePutFileBlk()
{
    PutFileBlk* lpPFB;
    long        lIdx;

    lpPFB = malloc(sizeof(PutFileBlk));
    if(lpPFB)
    {
        memset(lpPFB, 0x00, sizeof(PutFileBlk));
        lpPFB->lpCCBNext = NULL;
        lpPFB->lpCCBPrev = NULL;
        lpPFB->eCommandType = C_PUTFILE;
        lpPFB->eCommandState = S_UNKNOWN;
        lpPFB->lpBIB = NULL;
        lpPFB->lpTempDataVarBIB = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpPFB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpPFB->lpBreakContinueFSB = NULL;
        }
        /* Attribute buffer pointers always exist so check the string */
        /* length and if 0 set DataVar variable name pointer to NULL  */
        /* to indicate that there was no DataVar attribute            */
        if(0 == StrlenNull(kpMCB->lpszCurrDataVarAttr))
        {
            lpPFB->lpszDataVarName = NULL;
        }
        else
        {
            lpPFB->lpszDataVarName = CloneString(kpMCB->lpszCurrDataVarAttr);
        }
        lpPFB->lpszMQMDVarName = CloneString(kpMCB->lpszCurrMQMDAttr);
        lpPFB->lpszRFH2VarName = CloneString(kpMCB->lpszCurrRFH2Attr);
        lpPFB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpPFB->lpszFileName = CloneString(kpMCB->lpCSE->lpszFileName);
        lpPFB->lpszMQMDFileName = CloneString(kpMCB->lpCSE->lpszMQMDFileName);
        lpPFB->lpszRFH2FileName = CloneString(kpMCB->lpCSE->lpszRFH2FileName);
        lpPFB->lpszDir = CloneString(kpMCB->lpCSE->lpszDir);
        lpPFB->bAppend = kpMCB->lpCSE->bAppend;
        lpPFB->lpszResDataVarName = NULL;
        lpPFB->lpszResMQMDVarName = NULL;
        lpPFB->lpszResRFH2VarName = NULL;
        lpPFB->lpszResBuffName = NULL;
        lpPFB->lpszResFileName = NULL;
        lpPFB->lpszResMQMDFileName = NULL;
        lpPFB->lpszResRFH2FileName = NULL;
        lpPFB->lpszResDir = NULL;
        lpPFB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpPFB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpPFB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpPFB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpPFB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpPFB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }
        ClearCSE();
        ClearRC();
    }
    else
    {
        ConsoleMsg(3, sizeof(PutFileBlk), "PutFileBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpPFB;
}

/*--------------------------------------------------------------------------*/
InlineDataBlk*
CreateInlineDataBlk()
{
    InlineDataBlk* lpIDB;

    lpIDB = malloc(sizeof(InlineDataBlk));
    if(lpIDB)
    {
        memset(lpIDB, 0x00, sizeof(InlineDataBlk));
        lpIDB->lpCCBNext = NULL;
        lpIDB->lpCCBPrev = NULL;
        lpIDB->eCommandType = C_INLINEDATA;
        lpIDB->eCommandState = S_UNKNOWN;
        lpIDB->lpBIB = NULL;
        lpIDB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpIDB->lpszData = CloneString(kpMCB->lpCSE->lpszData);
        lpIDB->lpszResBuffName = NULL;
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(InlineDataBlk), "InlineDataBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpIDB;
}

/*--------------------------------------------------------------------------*/
OverlayBlk*
CreateOverlayBlk()
{
    OverlayBlk* lpOVB;

    lpOVB = malloc(sizeof(OverlayBlk));
    if(lpOVB)
    {
        memset(lpOVB, 0x00, sizeof(OverlayBlk));
        lpOVB->lpCCBNext = NULL;
        lpOVB->lpCCBPrev = NULL;
        lpOVB->eCommandType = C_OVERLAY;
        lpOVB->eCommandState = S_UNKNOWN;
        lpOVB->lpBIB = NULL;
        lpOVB->lpszPos = CloneString(kpMCB->lpszCurrPosAttr);
        lpOVB->lpszLen = CloneString(kpMCB->lpszCurrLenAttr);
        lpOVB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpOVB->lpszData = CloneString(kpMCB->lpCSE->lpszData);
        lpOVB->lpszResBuffName = NULL;
        lpOVB->lpszResData = NULL;
        lpOVB->lpszResPos = NULL;
        lpOVB->lpszResLen = NULL;
        lpOVB->lPos = 0;
        lpOVB->lLen = 0;
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(OverlayBlk), "OverlayBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpOVB;
}

/*--------------------------------------------------------------------------*/
ExtractBlk*
CreateExtractBlk()
{
    ExtractBlk* lpEXB;

    lpEXB = malloc(sizeof(ExtractBlk));
    if(lpEXB)
    {
        memset(lpEXB, 0x00, sizeof(ExtractBlk));
        lpEXB->lpCCBNext = NULL;
        lpEXB->lpCCBPrev = NULL;
        lpEXB->eCommandType = C_EXTRACT;
        lpEXB->eCommandState = S_UNKNOWN;
        lpEXB->lpBIB = NULL;
        lpEXB->lpVIB = NULL;
        lpEXB->lpszVarName = CloneString(kpMCB->lpszCurrNameAttr);
        lpEXB->lpszPos = CloneString(kpMCB->lpszCurrPosAttr);
        lpEXB->lpszLen = CloneString(kpMCB->lpszCurrLenAttr);
        lpEXB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpEXB->lpszResVarName = NULL;
        lpEXB->lpszResBuffName = NULL;
        lpEXB->lpszResPos = NULL;
        lpEXB->lpszResLen = NULL;
        lpEXB->lPos = 0;
        lpEXB->lLen = 0;
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(ExtractBlk), "ExtractBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpEXB;
}

/*--------------------------------------------------------------------------*/
SubstringBlk*
CreateSubstringBlk()
{
    SubstringBlk* lpSSB;

    lpSSB = malloc(sizeof(SubstringBlk));
    if(lpSSB)
    {
        memset(lpSSB, 0x00, sizeof(SubstringBlk));
        lpSSB->lpCCBNext = NULL;
        lpSSB->lpCCBPrev = NULL;
        lpSSB->eCommandType = C_SUBSTRING;
        lpSSB->eCommandState = S_UNKNOWN;
        lpSSB->lpVIB = NULL;
        lpSSB->lpVIBFrom = NULL;
        lpSSB->lpszVarName = CloneString(kpMCB->lpszCurrNameAttr);
        lpSSB->lpszFromVarName = CloneString(kpMCB->lpszCurrFromAttr);
        lpSSB->lpszPos = CloneString(kpMCB->lpszCurrPosAttr);
        lpSSB->lpszLen = CloneString(kpMCB->lpszCurrLenAttr);
        lpSSB->lpszResVarName = NULL;
        lpSSB->lpszResFromVarName = NULL;
        lpSSB->lpszResPos = NULL;
        lpSSB->lpszResLen = NULL;
        lpSSB->lPos = 0;
        lpSSB->lLen = 0;
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(SubstringBlk), "SubstringBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpSSB;
}

/*--------------------------------------------------------------------------*/
GetMsgBlk*
CreateGetMsgBlk()
{
    GetMsgBlk* lpGMB;
    long       lIdx;

    lpGMB = malloc(sizeof(GetMsgBlk));
    if(lpGMB)
    {
        memset(lpGMB, 0x00, sizeof(GetMsgBlk));
        lpGMB->lpCCBNext = NULL;
        lpGMB->lpCCBPrev = NULL;
        lpGMB->eCommandType = C_GETMSG;
        lpGMB->eCommandState = S_UNKNOWN;
        lpGMB->lpBIB = NULL;
        lpGMB->lpQIB = NULL;
        lpGMB->lpCDB = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpGMB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpGMB->lpBreakContinueFSB = NULL;
        }
        lpGMB->lpszConnectionName = CloneString(kpMCB->lpszCurrConnectionAttr);
        lpGMB->lpszMQMDVarName = CloneString(kpMCB->lpszCurrMQMDAttr);
        lpGMB->lpszRFH2VarName = CloneString(kpMCB->lpszCurrRFH2Attr);
        lpGMB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpGMB->lpszQName = CloneString(kpMCB->lpCSE->lpszQName);
        lpGMB->lpszCmdMaxWait = CloneString(kpMCB->lpCSE->lpszCmdMaxWait);
        lpGMB->lpszGmoOptions = CloneString(kpMCB->lpCSE->lpszGmoOptions);
        lpGMB->lpszGmoMatchOptions = CloneString(kpMCB->lpCSE->lpszGmoMatchOptions);
        lpGMB->lpszGmoWait = CloneString(kpMCB->lpCSE->lpszGmoWait);
        lpGMB->bGmoWait = FALSE;
        if(0 < StrlenNull(lpGMB->lpszGmoWait))
        {
            lpGMB->bGmoWait = TRUE;
        }
        /* For the MsgId, CorrelId and GroupId special override variables */
        /* NULL=no-override and EmptyString=MQMI_NONE/MQCI_NONE  */
        /* so only call clone the string if its not NULL         */
        lpGMB->lpszMsgId = CloneStringNull(kpMCB->lpCSE->lpszMsgId);
        lpGMB->lpszCorrelId = CloneStringNull(kpMCB->lpCSE->lpszCorrelId);
        lpGMB->lpszGroupId = CloneStringNull(kpMCB->lpCSE->lpszGroupId);
        lpGMB->lpszMsgSeqNumber = CloneStringNull(kpMCB->lpCSE->lpszMsgSeqNumber);
        lpGMB->lpszResConnectionName = NULL;
        lpGMB->lpszResMQMDVarName = NULL;
        lpGMB->lpszResRFH2VarName = NULL;
        lpGMB->lpszResBuffName = NULL;
        lpGMB->lpszResQName = NULL;
        lpGMB->lpszResCmdMaxWait = NULL;
        lpGMB->lpszResGmoWait = NULL;
        lpGMB->lpszResMsgId = NULL;
        lpGMB->lpszResCorrelId = NULL;
        lpGMB->lpszResGroupId = NULL;
        lpGMB->lpszResMsgSeqNumber = NULL;
        lpGMB->lMaxWait = -1;
        lpGMB->lGmoWait = 0;
        lpGMB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpGMB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpGMB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpGMB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpGMB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpGMB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }
        lpGMB->bRunDoneOnce = FALSE;
        lpGMB->bConvert = kpMCB->lpCSE->bConvert;
        lpGMB->bIntervalInMsgId = kpMCB->lpCSE->bIntervalInMsgId;
        lpGMB->bIntervalInCorrelId = kpMCB->lpCSE->bIntervalInCorrelId;
        lpGMB->bSyncpoint = kpMCB->lpCSE->bSyncpoint;
        lpGMB->bRemoveDLH = kpMCB->lpCSE->bRemoveDLH;
        lpGMB->bRemoveXQH = kpMCB->lpCSE->bRemoveXQH;
        lpGMB->eBrowseType = kpMCB->lpCSE->eBrowseType;

        lpGMB->lpIIB = kpMCB->lpCSE->lpIIB;
        kpMCB->lpCSE->lpIIB = NULL;
        
        ClearCSE();
        ClearRC();
    }
    else
    {
        ConsoleMsg(3, sizeof(GetMsgBlk), "GetMsgBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpGMB;
}

/*--------------------------------------------------------------------------*/
PutMsgBlk*
CreatePutMsgBlk()
{
    PutMsgBlk* lpPMB;
    long       lIdx;

    lpPMB = malloc(sizeof(PutMsgBlk));
    if(lpPMB)
    {
        memset(lpPMB, 0x00, sizeof(PutMsgBlk));
        lpPMB->lpCCBNext = NULL;
        lpPMB->lpCCBPrev = NULL;
        lpPMB->eCommandType = C_PUTMSG;
        lpPMB->eCommandState = S_UNKNOWN;
        lpPMB->lpBIB = NULL;
        lpPMB->lpTempDataVarBIB = NULL;
        lpPMB->lpQIB = NULL;
        lpPMB->lpCDB = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpPMB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpPMB->lpBreakContinueFSB = NULL;
        }
        lpPMB->lpszConnectionName = CloneString(kpMCB->lpszCurrConnectionAttr);
        /* Attribute buffer pointers always exist so check the string */
        /* length and if 0 set DataVar variable name pointer to NULL  */
        /* to indicate that there was no DataVar attribute            */
        if(0 == StrlenNull(kpMCB->lpszCurrDataVarAttr))
        {
            lpPMB->lpszDataVarName = NULL;
        }
        else
        {
            lpPMB->lpszDataVarName = CloneString(kpMCB->lpszCurrDataVarAttr);
        }
        lpPMB->lpszMQMDVarName = CloneString(kpMCB->lpszCurrMQMDAttr);
        lpPMB->lpszRFH2VarName = CloneString(kpMCB->lpszCurrRFH2Attr);
        lpPMB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpPMB->lpszQName = CloneString(kpMCB->lpCSE->lpszQName);
        lpPMB->lpszQMgrName = CloneString(kpMCB->lpCSE->lpszQMgrName);
        lpPMB->lpszPmoOptions = CloneString(kpMCB->lpCSE->lpszPmoOptions);
        /* For the MsgId, CorrelId, GroupId and Format special override  */
        /* variables NULL=no-override and EmptyString=MQMI_NONE */
        /* or MQCI_NONE or MQFMT_NONE so only clone the string  */
        /* if its not NULL                                      */
        lpPMB->lpszMsgId = CloneStringNull(kpMCB->lpCSE->lpszMsgId);
        lpPMB->lpszCorrelId = CloneStringNull(kpMCB->lpCSE->lpszCorrelId);
        lpPMB->lpszGroupId = CloneStringNull(kpMCB->lpCSE->lpszGroupId);
        lpPMB->lpszMsgSeqNumber = CloneStringNull(kpMCB->lpCSE->lpszMsgSeqNumber);
        lpPMB->lpszFormat = CloneStringNull(kpMCB->lpCSE->lpszFormat);
        lpPMB->lpszResDataVarName = NULL;
        lpPMB->lpszResConnectionName = NULL;
        lpPMB->lpszResMQMDVarName = NULL;
        lpPMB->lpszResRFH2VarName = NULL;
        lpPMB->lpszResBuffName = NULL;
        lpPMB->lpszResQName = NULL;
        lpPMB->lpszResQMgrName = NULL;
        lpPMB->lpszResMsgId = NULL;
        lpPMB->lpszResCorrelId = NULL;
        lpPMB->lpszResGroupId = NULL;
        lpPMB->lpszResMsgSeqNumber = NULL;
        lpPMB->lpszResFormat = NULL;
        lpPMB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpPMB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpPMB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpPMB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpPMB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpPMB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }
        lpPMB->bSuppressRFH2 = TRUE;
        lpPMB->bIntervalInMsgId = kpMCB->lpCSE->bIntervalInMsgId;
        lpPMB->bIntervalInCorrelId = kpMCB->lpCSE->bIntervalInCorrelId;
        lpPMB->bSyncpoint = kpMCB->lpCSE->bSyncpoint;
        lpPMB->bSetIdentityContext = kpMCB->lpCSE->bSetIdentityContext;
        lpPMB->bSetAllContext = kpMCB->lpCSE->bSetAllContext;
        lpPMB->eGroupType = kpMCB->lpCSE->eGroupType;

        lpPMB->lpIIB = kpMCB->lpCSE->lpIIB;
        kpMCB->lpCSE->lpIIB = NULL;
        
        lpPMB->lpMRB = kpMCB->lpCSE->lpMRB;
        kpMCB->lpCSE->lpMRB = NULL;
        ClearCSE();
        ClearRC();
    }
    else
    {
        ConsoleMsg(3, sizeof(PutMsgBlk), "PutMsgBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpPMB;
}

/*--------------------------------------------------------------------------*/
SelectBlk*
CreateSelectBlk()
{
    SelectBlk* lpSLB;
    long       lIdx;

    lpSLB = malloc(sizeof(SelectBlk));
    if(lpSLB)
    {
        memset(lpSLB, 0x00, sizeof(SelectBlk));
        lpSLB->lpCCBNext = NULL;
        lpSLB->lpCCBPrev = NULL;
        lpSLB->eCommandType = C_SELECT;
        lpSLB->eCommandState = S_UNKNOWN;
        lpSLB->lpBIB = NULL;
        lpSLB->lpMsgSetHdr = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpSLB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpSLB->lpBreakContinueFSB = NULL;
        }
        lpSLB->lpszMQMDVarName = CloneString(kpMCB->lpszCurrMQMDAttr);
        lpSLB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpSLB->lpszMsgSetName = CloneString(kpMCB->lpszCurrMsgSetNameAttr);
        lpSLB->lpszMsgNum = CloneString(kpMCB->lpszCurrMsgNumAttr);
        lpSLB->lpszResBuffName = NULL;
        lpSLB->lpszResMsgSetName = NULL;
        lpSLB->lpszResMsgNum = NULL;
        lpSLB->lpLastMsgSetTreeNode = NULL;
        lpSLB->lMsgNum = 0;
        lpSLB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpSLB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpSLB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpSLB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpSLB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpSLB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }

        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(SelectBlk), "SelectBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpSLB;
}

/*--------------------------------------------------------------------------*/
WaitDepthBlk*
CreateWaitDepthBlk()
{
    WaitDepthBlk* lpWDB;

    lpWDB = malloc(sizeof(WaitDepthBlk));
    if(lpWDB)
    {
        memset(lpWDB, 0x00, sizeof(WaitDepthBlk));
        lpWDB->lpCCBNext = NULL;
        lpWDB->lpCCBPrev = NULL;
        lpWDB->eCommandType = C_WAITONMSGDEPTH;
        lpWDB->eCommandState = S_UNKNOWN;
        lpWDB->lpQIB = NULL;
        lpWDB->lpCDB = NULL;
        lpWDB->lpszConnectionName = CloneString(kpMCB->lpszCurrConnectionAttr);
        lpWDB->lpszQName = CloneString(kpMCB->lpCSE->lpszQName);
        lpWDB->lpszDepth = CloneString(kpMCB->lpCSE->lpszDepth);
        lpWDB->lpszCmdMaxWait = CloneString(kpMCB->lpCSE->lpszCmdMaxWait);
        lpWDB->lpszResConnectionName = NULL;
        lpWDB->lpszResQName = NULL;
        lpWDB->lpszResDepth = NULL;
        lpWDB->lpszResCmdMaxWait = NULL;
        lpWDB->lDepth = 1;
        lpWDB->lMaxWait = -1;
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(WaitDepthBlk), "WaitDepthBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpWDB;
}

/*--------------------------------------------------------------------------*/
WaitTimeBlk*
CreateWaitTimeBlk()
{
    WaitTimeBlk* lpWTB;

    lpWTB = malloc(sizeof(WaitTimeBlk));
    if(lpWTB)
    {
        memset(lpWTB, 0x00, sizeof(WaitTimeBlk));
        lpWTB->lpCCBNext = NULL;
        lpWTB->lpCCBPrev = NULL;
        lpWTB->eCommandType = C_WAITONTIME;
        lpWTB->eCommandState = S_UNKNOWN;
        lpWTB->lpszInterval = NULL;
        lpWTB->lpszIntervalMillis = NULL;
        lpWTB->lpszResInterval = NULL;
        lpWTB->lpszResIntervalMillis = NULL;
        lpWTB->lpszTime = NULL;
        lpWTB->lpszResTime = NULL;
        /* Not allowed to use combinations of <Interval>, <IntervalMillis> and <Time> */
        if(((0 != StrlenNull(kpMCB->lpCSE->lpszInterval)) && (0 != StrlenNull(kpMCB->lpCSE->lpszIntervalMillis))) ||
           ((0 != StrlenNull(kpMCB->lpCSE->lpszInterval)) && (0 != StrlenNull(kpMCB->lpCSE->lpszTime))) ||
           ((0 != StrlenNull(kpMCB->lpCSE->lpszIntervalMillis)) && (0 != StrlenNull(kpMCB->lpCSE->lpszTime))))
        {
            ConsoleMsg(185);
            kpMCB->lProcessing = FAILURE;
            return NULL;
        }
        /* Was it an Interval request */
        if(0 != StrlenNull(kpMCB->lpCSE->lpszInterval))
        {
            lpWTB->eWaitType = W_INTERVAL;
            lpWTB->lpszInterval = CloneString(kpMCB->lpCSE->lpszInterval);
            lpWTB->lInterval = 10;
        }
        /* Was it an IntervalMillis request */
        if(0 != StrlenNull(kpMCB->lpCSE->lpszIntervalMillis))
        {
            lpWTB->eWaitType = W_INTERVALMILLIS;
            lpWTB->lpszIntervalMillis = CloneString(kpMCB->lpCSE->lpszIntervalMillis);
            lpWTB->lIntervalMillis = 10;
        }
        /* Was it a Time request */
        if(0 != StrlenNull(kpMCB->lpCSE->lpszTime))
        {
            lpWTB->eWaitType = W_TIME;
            lpWTB->lpszTime = CloneString(kpMCB->lpCSE->lpszTime);
        }
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(WaitTimeBlk), "WaitTimeBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpWTB;
}

/*--------------------------------------------------------------------------*/
CompareBlk*
CreateCompareBlk()
{
    CompareBlk* lpCMB;

    lpCMB = malloc(sizeof(CompareBlk));
    if(lpCMB)
    {
        memset(lpCMB, 0x00, sizeof(CompareBlk));
        lpCMB->lpCCBNext = NULL;
        lpCMB->lpCCBPrev = NULL;
        lpCMB->eCommandType = C_COMPARE;
        lpCMB->eCommandState = S_UNKNOWN;
        lpCMB->lpBIB = NULL;
        lpCMB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpCMB->lpszCompFileName = CloneString(kpMCB->lpCSE->lpszFileName);
        lpCMB->lpszCompMaskFileName = CloneString(kpMCB->lpCSE->lpszMaskFileName);
        lpCMB->lpszCompRegexFileName = CloneString(kpMCB->lpCSE->lpszRegexFileName);
        lpCMB->lpszCompRFH2VarName1 = CloneString(kpMCB->lpCSE->lpszCompRFH2VarName1);
        lpCMB->lpszCompRFH2VarName2 = CloneString(kpMCB->lpCSE->lpszCompRFH2VarName2);
        lpCMB->lpszDir = CloneString(kpMCB->lpCSE->lpszDir);
        lpCMB->lpszResBuffName = NULL;
        lpCMB->lpszResCompFileName = NULL;
        lpCMB->lpszResCompMaskFileName = NULL;
        lpCMB->lpszResCompRegexFileName = NULL;
        lpCMB->lpszResDir = NULL;
        lpCMB->lpszCompFileBuff = NULL;
        lpCMB->lCompFileBuffLen = 0;
        lpCMB->lCompFileDataLen = -1;
        lpCMB->lpszCompMaskBuff = NULL;
        lpCMB->lCompMaskBuffLen = 0;
        lpCMB->lCompMaskDataLen = -1;
        lpCMB->lpszCompRegexBuff = NULL;
        lpCMB->lCompRegexBuffLen = 0;
        lpCMB->lCompRegexDataLen = -1;
        lpCMB->bGotCompFile = FALSE;
        lpCMB->bGotCompMask = FALSE;
        lpCMB->bGotCompRegex = FALSE;
        lpCMB->bLogAndContinue = kpMCB->lpCSE->bLogAndContinue;
        lpCMB->bCallOutMade = FALSE;
        lpCMB->lSubjectCurrPos = 0;
        lpCMB->lPatternCurrPos = 0;
        lpCMB->lPatternCurrItemLen = 0;
        memset(&lpCMB->oPcreExtra, 0x00, sizeof(pcre_extra));
        lpCMB->oPcreExtra.flags = PCRE_EXTRA_CALLOUT_DATA;
        lpCMB->oPcreExtra.study_data = NULL;
        lpCMB->oPcreExtra.match_limit = 0;
        lpCMB->oPcreExtra.callout_data = lpCMB;
        lpCMB->oPcreExtra.tables = NULL;
        lpCMB->lpCompiledRegex = NULL;
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(CompareBlk), "CompareBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpCMB;
}

/*--------------------------------------------------------------------------*/
CommitBlk*
CreateCommitBlk()
{
    CommitBlk* lpCOB;
    long       lIdx;

    lpCOB = malloc(sizeof(CommitBlk));
    if(lpCOB)
    {
        memset(lpCOB, 0x00, sizeof(CommitBlk));
        lpCOB->lpCCBNext = NULL;
        lpCOB->lpCCBPrev = NULL;
        lpCOB->eCommandType = C_COMMIT;
        lpCOB->eCommandState = S_UNKNOWN;
        lpCOB->lpCDB = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpCOB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpCOB->lpBreakContinueFSB = NULL;
        }
        lpCOB->lpszConnectionName = CloneString(kpMCB->lpszCurrConnectionAttr);
        lpCOB->lpszResConnectionName = NULL;
        lpCOB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpCOB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpCOB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpCOB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpCOB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpCOB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }
        ClearCSE();
        ClearRC();
    }
    else
    {
        ConsoleMsg(3, sizeof(CommitBlk), "CommitBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpCOB;
}

/*--------------------------------------------------------------------------*/
BackoutBlk*
CreateBackoutBlk()
{
    BackoutBlk* lpBOB;
    long       lIdx;

    lpBOB = malloc(sizeof(BackoutBlk));
    if(lpBOB)
    {
        memset(lpBOB, 0x00, sizeof(BackoutBlk));
        lpBOB->lpCCBNext = NULL;
        lpBOB->lpCCBPrev = NULL;
        lpBOB->eCommandType = C_BACKOUT;
        lpBOB->eCommandState = S_UNKNOWN;
        lpBOB->lpCDB = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpBOB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpBOB->lpBreakContinueFSB = NULL;
        }
        lpBOB->lpszConnectionName = CloneString(kpMCB->lpszCurrConnectionAttr);
        lpBOB->lpszResConnectionName = NULL;
        lpBOB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpBOB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpBOB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpBOB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpBOB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpBOB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }
        ClearCSE();
        ClearRC();
    }
    else
    {
        ConsoleMsg(3, sizeof(BackoutBlk), "BackoutBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpBOB;
}

/*--------------------------------------------------------------------------*/
SystemBlk*
CreateSystemBlk()
{
    SystemBlk* lpSYB;

    lpSYB = malloc(sizeof(SystemBlk));
    if(lpSYB)
    {
        memset(lpSYB, 0x00, sizeof(SystemBlk));
        lpSYB->lpCCBNext = NULL;
        lpSYB->lpCCBPrev = NULL;
        lpSYB->eCommandType = C_SYSTEM;
        lpSYB->eCommandState = S_UNKNOWN;
        lpSYB->lpszCommand = CloneString(kpMCB->lpCSE->lpszCommand);
        lpSYB->bIgnoreRC = kpMCB->lpCSE->bIgnoreRC;
        lpSYB->lpszResCommand = NULL;
        ClearCSE();
    }
    else
    {
        ConsoleMsg(3, sizeof(SystemBlk), "SystemBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpSYB;
}

/*--------------------------------------------------------------------------*/
MqscCommandBlk*
CreateMqscCommandBlk()
{
    MqscCommandBlk* lpSCB;
    long            lIdx;

    lpSCB = malloc(sizeof(MqscCommandBlk));
    if(lpSCB)
    {
        memset(lpSCB, 0x00, sizeof(MqscCommandBlk));
        lpSCB->lpCCBNext = NULL;
        lpSCB->lpCCBPrev = NULL;
        lpSCB->eCommandType = C_MQSCCOMMAND;
        lpSCB->eCommandState = S_UNKNOWN;
        lpSCB->lpBIB = NULL;
        lpSCB->lpQIB = NULL;
        lpSCB->lpQIBMR = NULL;
        if(kpMCB->lpFBRTail)
        {
            lpSCB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpSCB->lpBreakContinueFSB = NULL;
        }
        lpSCB->lpszConnectionName = CloneString(kpMCB->lpszCurrConnectionAttr);
        lpSCB->lpszBuffName = CloneString(kpMCB->lpCSE->lpszBuffName);
        lpSCB->lpszQName = CloneString(kpMCB->lpCSE->lpszQName);
        lpSCB->lpszMqscReplyQName = CloneString(kpszSYSMQSCREPLYQ);
        lpSCB->lpszMqscReplyDynamicQName = CloneString(kpMCB->lpCSE->lpszMqscReplyDynamicQName);
        lpSCB->lpszCommand = CloneString(kpMCB->lpCSE->lpszCommand);
        lpSCB->lpszCmdMaxWait = CloneString(kpMCB->lpCSE->lpszCmdMaxWait);
        lpSCB->lpszResConnectionName = NULL;
        lpSCB->lpszResBuffName = NULL;
        lpSCB->lpszResQName = NULL;
        lpSCB->lpszResMqscReplyDynamicQName = NULL;
        lpSCB->lpszResCommand = NULL;
        lpSCB->lpszCmdMaxWait = NULL;
        lpSCB->lMaxWait = -1;
        lpSCB->lContinueOnRCCount = kpMCB->lContinueOnRCCount;
        lpSCB->lBreakOnRCCount = kpMCB->lBreakOnRCCount;
        lpSCB->lSuppressRCCount = kpMCB->lSuppressRCCount;
        for(lIdx = 0; lIdx < MAX_REASON_CODES; lIdx++)
        {
            lpSCB->lContinueOnRC[lIdx] = kpMCB->lContinueOnRC[lIdx];
            lpSCB->lBreakOnRC[lIdx] = kpMCB->lBreakOnRC[lIdx];
            lpSCB->lSuppressRC[lIdx] = kpMCB->lSuppressRC[lIdx];
        }
        ClearCSE();
        ClearRC();
    }
    else
    {
        ConsoleMsg(3, sizeof(MqscCommandBlk), "MqscCommandBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpSCB;
}

/*--------------------------------------------------------------------------*/
ForStartBlk*
CreateForStartBlk()
{
    ForStartBlk*   lpFSB;
    ForBackRefBlk* lpFBR;
    TestInfoBlk*   lpTIB;
    VarInfoBlk*    lpVIB;

    lpFSB = malloc(sizeof(ForStartBlk));
    if(lpFSB)
    {
        memset(lpFSB, 0x00, sizeof(ForStartBlk));
        lpFSB->lpCCBNext = NULL;
        lpFSB->lpCCBPrev = NULL;
        lpFSB->eCommandType = C_FORSTART;
        lpFSB->eCommandState = S_UNKNOWN;
        lpFSB->lpszForName = CloneString(kpMCB->lpszCurrNameAttr);
        lpFSB->lpVIB = NULL;
        lpFSB->lpszFrom = CloneString(kpMCB->lpszCurrFromAttr);
        lpFSB->lpszTo = CloneString(kpMCB->lpszCurrToAttr);
        lpFSB->lpszIncr = CloneString(kpMCB->lpszCurrIncrAttr);
        lpFSB->lpszList = CloneStringNull(kpMCB->lpszCurrListAttr);
        lpFSB->lFrom = 0;
        lpFSB->lTo = 0;
        lpFSB->lCurrent = 0;
        lpFSB->lIncr = 0;
        lpFSB->lpLIB = NULL;
        lpFSB->lpCurrLEB = NULL;
        lpFSB->eForType = kpMCB->eForType;
        lpFSB->lpszResFrom = NULL;
        lpFSB->lpszResTo = NULL;
        lpFSB->lpszResIncr = NULL;
        lpFSB->lpForEndCmd = NULL;
        lpFSB->bCompleteDuringInit = FALSE;
    }
    else
    {
        ConsoleMsg(3, sizeof(ForStartBlk), "ForStartBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    /* Create a for back reference block that points to this */
    /* ForStartBlk for use by CreateForEndBlk function when  */
    /* it needs to get the pointer to this block.            */
    lpFBR = malloc(sizeof(ForBackRefBlk));
    if(lpFBR)
    {
        memset(lpFBR, 0x00, sizeof(ForBackRefBlk));
        lpFBR->lpFBRNext = NULL;
        lpFBR->lpFBRPrev = NULL;
        lpFBR->lpForStartCmd = (struct ForStartBlk*)lpFSB;
        /* Add it to the MCB's linked list */
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpFBRHead,
                        (LinkedListBlk**)&kpMCB->lpFBRTail,
                        (LinkedListBlk*)lpFBR);
    }
    else
    {
        ConsoleMsg(3, sizeof(ForBackRefBlk), "ForBackRefBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    /* Add a variable with the loops name if one does not already exist */
    lpTIB = kpMCB->lpTIBReadyTail;
    lpVIB = FindVarInfoBlk(lpTIB->lpVIBHead, lpFSB->lpszForName);
    if(! lpVIB)
    {
        switch(lpFSB->eForType)
        {
        case F_FOR:
        case F_FOREVER:
            lpVIB = AddAutoNumVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, lpFSB->lpszForName);
            break;
        case F_FOREACH:
            lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, lpFSB->lpszForName);
            break;
        }
    }

    /* Change format to our own if its been specified */
    if(kpMCB->lpszCurrFormatAttr)
    {
        if(0 < StrlenNull(kpMCB->lpszCurrFormatAttr))
        {
            FreeIfNotNull((void**)&lpVIB->lpszVarFormat);
            lpVIB->lpszVarFormat = CloneString(kpMCB->lpszCurrFormatAttr);
        }
    }

    /* Finally set the for loop VIB pointer */
    lpFSB->lpVIB = lpVIB;

    return lpFSB;
}

/*--------------------------------------------------------------------------*/
ForEndBlk*
CreateForEndBlk()
{
    ForStartBlk*   lpFSB;
    ForEndBlk*     lpFEB;
    ForBackRefBlk* lpFBR;

    lpFEB = malloc(sizeof(ForEndBlk));
    if(lpFEB)
    {
        memset(lpFEB, 0x00, sizeof(ForEndBlk));
        lpFEB->lpCCBNext = NULL;
        lpFEB->lpCCBPrev = NULL;
        lpFEB->eCommandType = C_FOREND;
        lpFEB->eCommandState = S_UNKNOWN;
        /* Get the back reference block so we can point the */
        /* ForStartBlk and ForEndBlk's at each other       */
        lpFBR = kpMCB->lpFBRTail;
        lpFSB = (ForStartBlk*)lpFBR->lpForStartCmd;
        lpFEB->lpForStartCmd = (struct ForStartBlk*)lpFSB;
        lpFSB->lpForEndCmd = (struct ForEndBlk*)lpFEB;
        lpFEB->lpszForName = CloneString(lpFSB->lpszForName);
        /* Done with the back reference block so discard it */
        RemoveFromList((LinkedListBlk**)&kpMCB->lpFBRHead,
                       (LinkedListBlk**)&kpMCB->lpFBRTail,
                       (LinkedListBlk*)lpFBR);
        FreeFBR(&lpFBR);
    }
    else
    {
        ConsoleMsg(3, sizeof(ForEndBlk), "ForEndBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpFEB;
}

/*--------------------------------------------------------------------------*/
IfStartBlk*
CreateIfStartBlk()
{
    IfStartBlk*   lpIFS;
    IfBackRefBlk* lpIFB;

    lpIFS = malloc(sizeof(IfStartBlk));
    if(lpIFS)
    {
        memset(lpIFS, 0x00, sizeof(IfStartBlk));
        lpIFS->lpCCBNext = NULL;
        lpIFS->lpCCBPrev = NULL;
        lpIFS->eCommandType = C_IFSTART;
        lpIFS->eCommandState = S_UNKNOWN;
        lpIFS->lpIFS = (struct IfStartBlk*)lpIFS;
        lpIFS->lpIFE = NULL;
        lpIFS->lpIFGNext = NULL;
        lpIFS->lpszCond = CloneString(kpMCB->lpszCurrCondAttr);
        lpIFS->lpszResCond = NULL;
        lpIFS->bGotATrueCondition = FALSE;

        /* Check if the condition associated with this If checks LastCC */
        if(NULL != strstr(lpIFS->lpszCond, kpszLASTCCVAR))
        {
            lpIFS->bACondChecksLastCC = TRUE;
        }
        else
        {
            lpIFS->bACondChecksLastCC = FALSE;
        }
        
        /* Check if the condition associated with this If checks LastRC */
        if(NULL != strstr(lpIFS->lpszCond, kpszLASTRCVAR))
        {
            lpIFS->bACondChecksLastRC = TRUE;
        }
        else
        {
            lpIFS->bACondChecksLastRC = FALSE;
        }
    }
    else
    {
        ConsoleMsg(3, sizeof(IfStartBlk), "IfStartBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    /* Check the condition contains a valid predicate */
    if((NULL == strstr(lpIFS->lpszCond, kpszEQUALTO)) &&
       (NULL == strstr(lpIFS->lpszCond, kpszNOTEQUALTO)) &&
       (NULL == strstr(lpIFS->lpszCond, kpszGREATER)) &&
       (NULL == strstr(lpIFS->lpszCond, kpszLESS)) &&
       (NULL == strstr(lpIFS->lpszCond, kpszGREATEREQUAL)) &&
       (NULL == strstr(lpIFS->lpszCond, kpszLESSEQUAL)))
    {
        ConsoleMsg(256, lpIFS->lpszCond);
        ConsoleMsg(257);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    /* Create a if back reference block that points to this */
    /* IfStartBlk for use in generating IfCondFalseTarget's */
    lpIFB = malloc(sizeof(IfBackRefBlk));
    if(lpIFB)
    {
        memset(lpIFB, 0x00, sizeof(IfBackRefBlk));
        lpIFB->lpIFBNext = NULL;
        lpIFB->lpIFBPrev = NULL;
        lpIFB->lpIfStartCmd = (struct IfStartBlk*)lpIFS;
        /* Add it to the MCB's linked list */
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpIFBHead,
                        (LinkedListBlk**)&kpMCB->lpIFBTail,
                        (LinkedListBlk*)lpIFB);
    }
    else
    {
        ConsoleMsg(3, sizeof(IfBackRefBlk), "IfBackRefBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpIFS;
}

/*--------------------------------------------------------------------------*/
ElseIfBlk*
CreateElseIfBlk()
{
    ElseIfBlk*    lpELI;
    IfStartBlk*   lpIFS;
    IfGenericBlk* lpIFG;

    lpELI = malloc(sizeof(ElseIfBlk));
    if(lpELI)
    {
        memset(lpELI, 0x00, sizeof(ElseIfBlk));
        lpELI->lpCCBNext = NULL;
        lpELI->lpCCBPrev = NULL;
        lpELI->eCommandType = C_ELSEIF;
        lpELI->eCommandState = S_UNKNOWN;

        /* Get a pointer to the related IfStartBlk */
        lpIFS = (IfStartBlk*)kpMCB->lpIFBTail->lpIfStartCmd;
        if(NULL == lpIFS)
        {
            ConsoleMsg(254);
            kpMCB->lProcessing = FAILURE;
            return NULL;
        }
        lpELI->lpIFS = (struct IfStartBlk*)lpIFS;
        lpELI->lpIFE = NULL;
        lpELI->lpIFGNext = NULL;
        
        /* Add this element to the IFGNext chain of the preceding element */
        lpIFG = (IfGenericBlk*)lpIFS;
        while(NULL != lpIFG->lpIFGNext)
        {
            lpIFG = (IfGenericBlk*)lpIFG->lpIFGNext;
        }
        lpIFG->lpIFGNext = (struct IfGenericBlk*)lpELI;
        lpELI->lpszCond = CloneString(kpMCB->lpszCurrCondAttr);
        lpELI->lpszResCond = NULL;
        
        /* Check if the condition associated with this ElseIf checks LastCC or LastRC */
        /* and if so update the IfStartBlk to which this ElseIf is related            */
        if(NULL != strstr(lpELI->lpszCond, kpszLASTCCVAR))
        {
            lpIFS->bACondChecksLastCC = TRUE;
        }
        if(NULL != strstr(lpELI->lpszCond, kpszLASTRCVAR))
        {
            lpIFS->bACondChecksLastRC = TRUE;
        }
    }
    else
    {
        ConsoleMsg(3, sizeof(ElseIfBlk), "ElseIfBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    /* Check the condition contains a valid predicate */
    if((NULL == strstr(lpELI->lpszCond, kpszEQUALTO)) &&
       (NULL == strstr(lpELI->lpszCond, kpszNOTEQUALTO)))
    {
        ConsoleMsg(256, lpIFS->lpszCond);
        ConsoleMsg(257);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpELI;
}

/*--------------------------------------------------------------------------*/
ElseBlk*
CreateElseBlk()
{
    IfStartBlk*   lpIFS;
    ElseBlk*      lpELS;
    IfGenericBlk* lpIFG;

    lpELS = malloc(sizeof(ElseBlk));
    if(lpELS)
    {
        memset(lpELS, 0x00, sizeof(ElseBlk));
        lpELS->lpCCBNext = NULL;
        lpELS->lpCCBPrev = NULL;
        lpELS->eCommandType = C_ELSE;
        lpELS->eCommandState = S_UNKNOWN;

        /* Get a pointer to the related IfStartBlk */
        lpIFS = (IfStartBlk*)kpMCB->lpIFBTail->lpIfStartCmd;
        if(NULL == lpIFS)
        {
            ConsoleMsg(254);
            kpMCB->lProcessing = FAILURE;
            return NULL;
        }
        lpELS->lpIFS = (struct IfStartBlk*)lpIFS;
        lpELS->lpIFGNext = NULL;
        
        /* Add this element to the IFGNext chain of the preceding element */
        lpIFG = (IfGenericBlk*)lpIFS;
        while(NULL != lpIFG->lpIFGNext)
        {
            lpIFG = (IfGenericBlk*)lpIFG->lpIFGNext;
        }
        lpIFG->lpIFGNext = (struct IfGenericBlk*)lpELS;
    }
    else
    {
        ConsoleMsg(3, sizeof(ElseBlk), "ElseBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpELS;
}

/*--------------------------------------------------------------------------*/
IfEndBlk*
CreateIfEndBlk()
{
    IfStartBlk*   lpIFS;
    IfEndBlk*     lpIFE;
    IfGenericBlk* lpIFG;
    IfBackRefBlk* lpIFB;

    lpIFE = malloc(sizeof(IfEndBlk));
    if(lpIFE)
    {
        memset(lpIFE, 0x00, sizeof(IfEndBlk));
        lpIFE->lpCCBNext = NULL;
        lpIFE->lpCCBPrev = NULL;
        lpIFE->eCommandType = C_IFEND;
        lpIFE->eCommandState = S_UNKNOWN;

        /* Get a pointer to the related IfStartBlk */
        lpIFS = (IfStartBlk*)kpMCB->lpIFBTail->lpIfStartCmd;
        lpIFE->lpIFS = (struct IfStartBlk*)lpIFS;
        lpIFE->lpIFGNext = NULL;
        lpIFE->lpIFE = (struct IfEndBlk*)lpIFE;
        
        /* Add this element to the IFGNext chain of the preceding element */
        lpIFG = (IfGenericBlk*)lpIFS;
        while(NULL != lpIFG->lpIFGNext)
        {
            lpIFG = (IfGenericBlk*)lpIFG->lpIFGNext;
        }
        lpIFG->lpIFGNext = (struct IfGenericBlk*)lpIFE;

        /* Add the IfEndBlk pointers now we have reached the end of the related If elements */
        lpIFG = (IfGenericBlk*)lpIFS;
        while(NULL != lpIFG->lpIFGNext)
        {
            lpIFG->lpIFE = (struct IfEndBlk*)lpIFE;
            lpIFG = (IfGenericBlk*)lpIFG->lpIFGNext;
        }

        /* Done with the back reference block so discard it */
        lpIFB = kpMCB->lpIFBTail;
        RemoveFromList((LinkedListBlk**)&kpMCB->lpIFBHead,
                       (LinkedListBlk**)&kpMCB->lpIFBTail,
                       (LinkedListBlk*)lpIFB);
        FreeIFB(&lpIFB);
    }
    else
    {
        ConsoleMsg(3, sizeof(IfEndBlk), "IfEndBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpIFE;
}

/*--------------------------------------------------------------------------*/
ContinueBlk*
CreateContinueBlk()
{
    ContinueBlk*      lpCNB;

    lpCNB = malloc(sizeof(ContinueBlk));
    if(lpCNB)
    {
        memset(lpCNB, 0x00, sizeof(ContinueBlk));
        lpCNB->lpCCBNext = NULL;
        lpCNB->lpCCBPrev = NULL;
        lpCNB->eCommandType = C_CONTINUE;
        lpCNB->eCommandState = S_UNKNOWN;
        if(kpMCB->lpFBRTail)
        {
            lpCNB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpCNB->lpBreakContinueFSB = NULL;
        }
    }
    else
    {
        ConsoleMsg(3, sizeof(ContinueBlk), "ContinueBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpCNB;
}

/*--------------------------------------------------------------------------*/
BreakBlk*
CreateBreakBlk()
{
    BreakBlk*      lpBRB;

    lpBRB = malloc(sizeof(BreakBlk));
    if(lpBRB)
    {
        memset(lpBRB, 0x00, sizeof(BreakBlk));
        lpBRB->lpCCBNext = NULL;
        lpBRB->lpCCBPrev = NULL;
        lpBRB->eCommandType = C_BREAK;
        lpBRB->eCommandState = S_UNKNOWN;
        if(kpMCB->lpFBRTail)
        {
            lpBRB->lpBreakContinueFSB = (ForStartBlk*)kpMCB->lpFBRTail->lpForStartCmd;
        }
        else
        {
            lpBRB->lpBreakContinueFSB = NULL;
        }
    }
    else
    {
        ConsoleMsg(3, sizeof(BreakBlk), "BreakBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpBRB;
}

/*--------------------------------------------------------------------------*/
ExitTestBlk*
CreateExitTestBlk()
{
    ExitTestBlk*      lpETB;

    lpETB = malloc(sizeof(ExitTestBlk));
    if(lpETB)
    {
        memset(lpETB, 0x00, sizeof(ExitTestBlk));
        lpETB->lpCCBNext = NULL;
        lpETB->lpCCBPrev = NULL;
        lpETB->eCommandType = C_EXITTEST;
        lpETB->eCommandState = S_UNKNOWN;
    }
    else
    {
        ConsoleMsg(3, sizeof(ExitTestBlk), "ExitTestBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpETB;
}

/*--------------------------------------------------------------------------*/
FailTestBlk*
CreateFailTestBlk()
{
    FailTestBlk*      lpFTB;

    lpFTB = malloc(sizeof(FailTestBlk));
    if(lpFTB)
    {
        memset(lpFTB, 0x00, sizeof(FailTestBlk));
        lpFTB->lpCCBNext = NULL;
        lpFTB->lpCCBPrev = NULL;
        lpFTB->eCommandType = C_FAILTEST;
        lpFTB->eCommandState = S_UNKNOWN;
    }
    else
    {
        ConsoleMsg(3, sizeof(FailTestBlk), "FailTestBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpFTB;
}

/*--------------------------------------------------------------------------*/
FinallyStartBlk*
CreateFinallyStartBlk()
{
    FinallyStartBlk*   lpYSB;

    lpYSB = malloc(sizeof(FinallyStartBlk));
    if(lpYSB)
    {
        memset(lpYSB, 0x00, sizeof(FinallyStartBlk));
        lpYSB->lpCCBNext = NULL;
        lpYSB->lpCCBPrev = NULL;
        lpYSB->eCommandType = C_FINALLYSTART;
        lpYSB->eCommandState = S_UNKNOWN;
    }
    else
    {
        ConsoleMsg(3, sizeof(FinallyStartBlk), "FinallyStartBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpYSB;
}

/*--------------------------------------------------------------------------*/
FinallyEndBlk*
CreateFinallyEndBlk()
{
    FinallyEndBlk*     lpYEB;

    lpYEB = malloc(sizeof(FinallyEndBlk));
    if(lpYEB)
    {
        memset(lpYEB, 0x00, sizeof(FinallyEndBlk));
        lpYEB->lpCCBNext = NULL;
        lpYEB->lpCCBPrev = NULL;
        lpYEB->eCommandType = C_FINALLYEND;
        lpYEB->eCommandState = S_UNKNOWN;
    }
    else
    {
        ConsoleMsg(3, sizeof(FinallyEndBlk), "FinallyEndBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpYEB;
}

/*--------------------------------------------------------------------------*/
IntervalStartBlk*
CreateIntervalStartBlk()
{
    IntervalStartBlk* lpISB;
    IntervalInfoBlk*  lpIIB;

    lpISB = malloc(sizeof(IntervalStartBlk));
    if(lpISB)
    {
        memset(lpISB, 0x00, sizeof(IntervalStartBlk));
        lpISB->lpCCBNext = NULL;
        lpISB->lpCCBPrev = NULL;
        lpISB->eCommandType = C_INTERVALSTART;
        lpISB->eCommandState = S_UNKNOWN;
        /* See if the interval already exists */
        lpIIB = FindIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
        if(lpIIB)
        {
            /* If a start has already been defined then its an error */
            if(lpIIB->bHaveStartCmd)
            {
                FreeIfNotNull((void**)&lpISB);
                LogMsg(94, kpMCB->lpszCurrNameAttr);
                kpMCB->lProcessing = FAILURE;
                return NULL;
            }
            else
            {
                lpIIB->bHaveStartCmd = TRUE;
            }
        }
        else
        {
            lpIIB = CreateIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
            if(! lpIIB)
            {
                FreeIfNotNull((void**)&lpISB);
                kpMCB->lProcessing = FAILURE;
                return NULL;
            }
            AddToTailOfList((LinkedListBlk**)&kpMCB->lpIIBHead,
                            (LinkedListBlk**)&kpMCB->lpIIBTail,
                            (LinkedListBlk*)lpIIB);
            lpIIB->bHaveStartCmd = TRUE;
        }
        lpISB->lpIIB = lpIIB;
    }
    else
    {
        ConsoleMsg(3, sizeof(IntervalStartBlk), "IntervalStartBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpISB;
}

/*--------------------------------------------------------------------------*/
IntervalEndBlk*
CreateIntervalEndBlk()
{
    IntervalEndBlk*  lpIEB;
    IntervalInfoBlk* lpIIB;

    lpIEB = malloc(sizeof(IntervalEndBlk));
    if(lpIEB)
    {
        memset(lpIEB, 0x00, sizeof(IntervalEndBlk));
        lpIEB->lpCCBNext = NULL;
        lpIEB->lpCCBPrev = NULL;
        lpIEB->eCommandType = C_INTERVALEND;
        lpIEB->eCommandState = S_UNKNOWN;
        /* See if the interval already exists */
        lpIIB = FindIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
        if(lpIIB)
        {
            /* If an end has already been defined then its an error */
            if(lpIIB->bHaveEndCmd)
            {
                FreeIfNotNull((void**)&lpIEB);
                LogMsg(95, kpMCB->lpszCurrNameAttr);
                kpMCB->lProcessing = FAILURE;
                return NULL;
            }
            else
            {
                lpIIB->bHaveEndCmd = TRUE;
            }
        }
        else
        {
            lpIIB = CreateIntervalInfoBlk(kpMCB->lpszCurrNameAttr);
            if(! lpIIB)
            {
                FreeIfNotNull((void**)&lpIEB);
                kpMCB->lProcessing = FAILURE;
                return NULL;
            }
            AddToTailOfList((LinkedListBlk**)&kpMCB->lpIIBHead,
                            (LinkedListBlk**)&kpMCB->lpIIBTail,
                            (LinkedListBlk*)lpIIB);
            lpIIB->bHaveEndCmd = TRUE;
        }
        lpIEB->lpIIB = lpIIB;
    }
    else
    {
        ConsoleMsg(3, sizeof(IntervalEndBlk), "IntervalEndBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpIEB;
}

/*--------------------------------------------------------------------------*/
MessageRateBlk*
CreateMessageRateBlk()
{
    MessageRateBlk*   lpMRB;

    lpMRB = malloc(sizeof(MessageRateBlk));
    if(lpMRB)
    {
        memset(lpMRB, 0x00, sizeof(MessageRateBlk));
        lpMRB->lpszFrom = CloneString(kpMCB->lpszCurrFromAttr);
        lpMRB->lpszTo = CloneString(kpMCB->lpszCurrToAttr);
        if(0 == memcmp(kpszBURST, kpMCB->lpszCurrModeAttr, strlen(kpszBURST) + 1))
        {
            lpMRB->lpszIncr = CloneString(kpszZERO);
            lpMRB->lpszInterval = CloneString(kpszZERO);
            lpMRB->eMsgRateMode = M_BURST;
        }
        else if(0 == memcmp(kpszPACED, kpMCB->lpszCurrModeAttr, strlen(kpszPACED) + 1))
        {
            lpMRB->lpszIncr = CloneString(kpszZERO);
            lpMRB->lpszInterval = CloneString(kpszZERO);
            lpMRB->eMsgRateMode = M_PACED;
        }
        else if(0 == memcmp(kpszRANDOM, kpMCB->lpszCurrModeAttr, strlen(kpszRANDOM) + 1))
        {
            lpMRB->lpszIncr = CloneString(kpszZERO);
            lpMRB->lpszInterval = CloneString(kpszZERO);
            lpMRB->eMsgRateMode = M_RANDOM;
        }
        else if(0 == memcmp(kpszINCREMENTAL, kpMCB->lpszCurrModeAttr, strlen(kpszINCREMENTAL) + 1))
        {
            lpMRB->lpszIncr = CloneString(kpMCB->lpszCurrIncrAttr);
            lpMRB->lpszInterval = CloneString(kpMCB->lpszCurrIntervalAttr);
            lpMRB->eMsgRateMode = M_INCREMENTAL;
        }
        else
        {
            lpMRB->eMsgRateMode = M_UNKNOWN;
            LogMsg(126, kpMCB->lpszCurrModeAttr);
            kpMCB->lProcessing = FAILURE;
            return NULL;
        }
        lpMRB->lMessagesThisSecond = 0;
        lpMRB->lMessagesLeft = 0;
        lpMRB->bFirstTime = TRUE;
        lpMRB->bInitForLoop = TRUE;
        lpMRB->bIncrementalDone = FALSE;
    }
    else
    {
        ConsoleMsg(3, sizeof(MessageRateBlk), "MessageRateBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpMRB;
}

/*--------------------------------------------------------------------------*/
StdInBlk*
CreateStdInBlk()
{
    StdInBlk* lpSIB;

    lpSIB = malloc(sizeof(StdInBlk));
    if(lpSIB)
    {
        memset(lpSIB, 0x00, sizeof(StdInBlk));
        lpSIB->lpCCBNext = NULL;
        lpSIB->lpCCBPrev = NULL;
        lpSIB->eCommandType = C_STDIN;
        lpSIB->eCommandState = S_UNKNOWN;
        lpSIB->lpszVarName = CloneString(kpMCB->lpszCurrNameAttr);
        lpSIB->lpszResVarName = CloneString(kpszEmptyString);
        lpSIB->lpVIB = NULL;
    }
    else
    {
        ConsoleMsg(3, sizeof(StdInBlk), "StdInBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpSIB;
}

/*--------------------------------------------------------------------------*/
StdOutBlk*
CreateStdOutBlk()
{
    StdOutBlk* lpSOB;

    lpSOB = malloc(sizeof(StdOutBlk));
    if(lpSOB)
    {
        memset(lpSOB, 0x00, sizeof(StdOutBlk));
        lpSOB->lpCCBNext = NULL;
        lpSOB->lpCCBPrev = NULL;
        lpSOB->eCommandType = C_STDOUT;
        lpSOB->eCommandState = S_UNKNOWN;
        lpSOB->lpszTextOut = CloneString(kpMCB->lpszParseCharDataBuff);
        lpSOB->lpszResTextOut = NULL;
    }
    else
    {
        ConsoleMsg(3, sizeof(StdOutBlk), "StdOutBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpSOB;
}

/*--------------------------------------------------------------------------*/
UserLogBlk*
CreateUserLogBlk()
{
    UserLogBlk* lpULB;

    lpULB = malloc(sizeof(UserLogBlk));
    if(lpULB)
    {
        memset(lpULB, 0x00, sizeof(UserLogBlk));
        lpULB->lpCCBNext = NULL;
        lpULB->lpCCBPrev = NULL;
        lpULB->eCommandType = C_USERLOG;
        lpULB->eCommandState = S_UNKNOWN;
        lpULB->lpszTextOut = CloneString(kpMCB->lpszParseCharDataBuff);
        lpULB->lpszResTextOut = NULL;
    }
    else
    {
        ConsoleMsg(3, sizeof(UserLogBlk), "UserLogBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpULB;
}

/*--------------------------------------------------------------------------*/
MsgSetFileLoadBlk*
CreateAndAddMsgSetFileLoadBlk()
{
    MsgSetFileLoadBlk* lpMSFL;

    lpMSFL = malloc(sizeof(MsgSetFileLoadBlk));
    if(lpMSFL)
    {
        memset(lpMSFL, 0x00, sizeof(MsgSetFileLoadBlk));
        lpMSFL->lpMSFLNext = NULL;
        lpMSFL->lpMSFLPrev = NULL;
        lpMSFL->lpszFileName = CloneString(kpMCB->lpCSE->lpszFileName);
        lpMSFL->lpszDir = CloneString(kpMCB->lpCSE->lpszDir);
        if(0 == StrlenNull(kpMCB->lpCIB->lpszParserName))
        {
            lpMSFL->lpszParserName = CloneString(kpszPN_MSGSET);
        }
        else
        {
            lpMSFL->lpszParserName = CloneString(kpMCB->lpCIB->lpszParserName);
        }
        lpMSFL->lpszMsgSetName = CloneStringNull(kpMCB->lpszCurrNameAttr);
        if(0 == StrlenNull(lpMSFL->lpszMsgSetName))
        {
            lpMSFL->lpszMsgSetName = CloneString(kpszTESTMSGSET);
        }
        AddToTailOfList((LinkedListBlk**)&kpMCB->lpCIB->lpMSFLHead,
                        (LinkedListBlk**)&kpMCB->lpCIB->lpMSFLTail,
                        (LinkedListBlk*)lpMSFL);
    }
    else
    {
        ConsoleMsg(3, sizeof(MsgSetFileLoadBlk), "MsgSetFileLoadBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpMSFL;
}

/*--------------------------------------------------------------------------*/
VarBlk*
CreateVarBlk(enum eVariableEnum eVarType)
{
    VarBlk*      lpVRB;
    ListInfoBlk* lpClonedLIB;
    MQMDInfoBlk* lpClonedMIB;
    RFH2InfoBlk* lpClonedRIB;

    lpVRB = malloc(sizeof(VarBlk));
    if(lpVRB)
    {
        memset(lpVRB, 0x00, sizeof(VarBlk));
        lpVRB->lpCCBNext = NULL;
        lpVRB->lpCCBPrev = NULL;
        lpVRB->eCommandType = C_VAR;
        lpVRB->eCommandState = S_UNKNOWN;
        lpVRB->eVarType = eVarType;
        lpVRB->lpszVarName = CloneString(kpMCB->lpszCurrNameAttr);
        lpVRB->lpszVarFormat = CloneString(kpMCB->lpszCurrFormatAttr);
        lpVRB->lpszNewStrValue = NULL;
        lpVRB->lpNewCtrlBlk = NULL;
        lpVRB->lpszRandomNumFrom = NULL;
        lpVRB->lpszRandomNumTo = NULL;
        lpVRB->lpszResRandomNumFrom = NULL;
        lpVRB->lpszResRandomNumTo = NULL;
        lpVRB->lRandomNumFrom = 0;
        lpVRB->lRandomNumTo = 0;
        lpVRB->bRandomNumSeeded = FALSE;
        lpVRB->bClear = kpMCB->lpCSE->bClear;
        lpVRB->lpszResVarName = CloneString(kpszEmptyString);
        lpVRB->lpVIB = NULL;

        switch(lpVRB->eVarType)
        {
        case V_NUM:
            if(NULL == kpMCB->lpszParseCharDataBuff)
            {
                lpVRB->lpszNewStrValue = CloneString(kpszZERO);
            }
            else
            {
                lpVRB->lpszNewStrValue = CloneString(kpMCB->lpszParseCharDataBuff);
            }
            break;
        case V_DOUBLE:
            if(NULL == kpMCB->lpszParseCharDataBuff)
            {
                lpVRB->lpszNewStrValue = CloneString(kpszZERO);
            }
            else
            {
                lpVRB->lpszNewStrValue = CloneString(kpMCB->lpszParseCharDataBuff);
            }
            break;
        case V_STR:
            if(NULL == kpMCB->lpszParseCharDataBuff)
            {
                lpVRB->lpszNewStrValue = CloneString(kpszEmptyString);
            }
            else
            {
                lpVRB->lpszNewStrValue = CloneString(kpMCB->lpszParseCharDataBuff);
            }
            break;
        case V_RANDOMNUM:
            if(NULL == kpMCB->lpszParseCharDataBuff)
            {
                lpVRB->lpszNewStrValue = CloneString(kpszEmptyString);
            }
            else
            {
                lpVRB->lpszNewStrValue = CloneString(kpMCB->lpszParseCharDataBuff);
            }
            lpVRB->lpszRandomNumFrom = CloneString(kpMCB->lpszCurrFromAttr);
            lpVRB->lpszRandomNumTo = CloneString(kpMCB->lpszCurrToAttr);
            break;
        case V_LIST:
            lpClonedLIB = NULL;
            CloneLIB(&lpClonedLIB, kpMCB->lpLIB);
            ClearLIB(kpMCB->lpLIB);
            /* If a file has been specified and directory has not been  */
            /* default to a directory value of %Dir% */
            if(0 < StrlenNull(lpClonedLIB->lpszListFileName))
            {
                if(0 == StrlenNull(lpClonedLIB->lpszDir))
                {
                    FreeIfNotNull((void**)&lpClonedLIB->lpszDir);
                    lpClonedLIB->lpszDir = CloneString(kpszDIRVAR);
                }
            }
            lpVRB->lpNewCtrlBlk = lpClonedLIB;
            break;
        case V_MQMD:
            lpClonedMIB = NULL;
            CloneMIB(&lpClonedMIB, kpMCB->lpMIB);
            ClearMIB(kpMCB->lpMIB);
            /* If a file has been specified and directory has not been  */
            /* default to a directory value of %Dir% */
            if(0 < StrlenNull(lpClonedMIB->lpszMQMDFileName))
            {
                if(0 == StrlenNull(lpClonedMIB->lpszDir))
                {
                    FreeIfNotNull((void**)&lpClonedMIB->lpszDir);
                    lpClonedMIB->lpszDir = CloneString(kpszDIRVAR);
                }
            }
            lpVRB->lpNewCtrlBlk = lpClonedMIB;
            break;
        case V_RFH2:
            lpClonedRIB = NULL;
            CloneRIB(&lpClonedRIB, kpMCB->lpRIB);
            ClearRIB(kpMCB->lpRIB);
            /* If a file has been specified and directory has not been  */
            /* default to a directory value of %Dir% */
            if(0 < StrlenNull(lpClonedRIB->lpszRFH2FileName))
            {
                if(0 == StrlenNull(lpClonedRIB->lpszDir))
                {
                    FreeIfNotNull((void**)&lpClonedRIB->lpszDir);
                    lpClonedRIB->lpszDir = CloneString(kpszDIRVAR);
                }
            }
            lpVRB->lpNewCtrlBlk = lpClonedRIB;
            break;
        }
        ClearCSE();
        ClearPCDB();
    }
    else
    {
        ConsoleMsg(3, sizeof(VarBlk), "VarBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpVRB;
}

/*--------------------------------------------------------------------------*/
VarInfoBlk*
CreateVarInfoBlk(char* lpszVarName)
{
    VarInfoBlk* lpVIB;

    lpVIB = malloc(sizeof(VarInfoBlk));
    if(lpVIB)
    {
        memset(lpVIB, 0x00, sizeof(VarInfoBlk));
        lpVIB->lpVIBNext = NULL;
        lpVIB->lpVIBPrev = NULL;
        lpVIB->eVarType = V_UNKNOWN;
        lpVIB->lpszVarName = CloneString(lpszVarName);
        lpVIB->lpszVarFormat = NULL;
        lpVIB->lpszCurrStrValue = NULL;
        lpVIB->lpCtrlBlk = NULL;
    }
    else
    {
        ConsoleMsg(3, sizeof(VarInfoBlk), "VarInfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpVIB;
}

/*--------------------------------------------------------------------------*/
MathFunctionBlk*
CreateMathFunctionBlk(enum eArithmeticEnum eMathFunction)
{
    MathFunctionBlk* lpMFB;

    lpMFB = malloc(sizeof(MathFunctionBlk));
    if(lpMFB)
    {
        memset(lpMFB, 0x00, sizeof(MathFunctionBlk));
        lpMFB->lpCCBNext = NULL;
        lpMFB->lpCCBPrev = NULL;
        lpMFB->eCommandType = C_MATH;
        lpMFB->eCommandState = S_UNKNOWN;
        lpMFB->eMathFunctionType = eMathFunction;
        lpMFB->lpszVarName = CloneString(kpMCB->lpszCurrNameAttr);
        lpMFB->lpszRemName = CloneString(kpMCB->lpszCurrRemAttr);
        lpMFB->lpszValue = CloneString(kpMCB->lpszParseCharDataBuff);
        lpMFB->lpszResVarName = CloneString(kpszEmptyString);
        lpMFB->lpszResRemName = CloneString(kpszEmptyString);
        lpMFB->lpszResValue = CloneString(kpszEmptyString);
        lpMFB->lpVIB = NULL;
        lpMFB->lpVIBRem = NULL;
        ClearPCDB();
    }
    else
    {
        ConsoleMsg(3, sizeof(MathFunctionBlk), "MathFunctionBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpMFB;
}

/*--------------------------------------------------------------------------*/
LengthBlk*
CreateLengthBlk()
{
    LengthBlk* lpLNB;

    lpLNB = malloc(sizeof(LengthBlk));
    if(lpLNB)
    {
        memset(lpLNB, 0x00, sizeof(LengthBlk));
        lpLNB->lpCCBNext = NULL;
        lpLNB->lpCCBPrev = NULL;
        lpLNB->eCommandType = C_LENGTH;
        lpLNB->eCommandState = S_UNKNOWN;
        lpLNB->lpszVarName = CloneString(kpMCB->lpszCurrNameAttr);
        lpLNB->lpszOf = CloneString(kpMCB->lpszCurrOfAttr);
        lpLNB->lpszResVarName = CloneString(kpszEmptyString);
        lpLNB->lpszResOf = CloneString(kpszEmptyString);
        ClearPCDB();
    }
    else
    {
        ConsoleMsg(3, sizeof(LengthBlk), "LengthBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpLNB;
}

/*--------------------------------------------------------------------------*/
PositionBlk*
CreatePositionBlk()
{
    PositionBlk* lpPSB;

    lpPSB = malloc(sizeof(PositionBlk));
    if(lpPSB)
    {
        memset(lpPSB, 0x00, sizeof(PositionBlk));
        lpPSB->lpCCBNext = NULL;
        lpPSB->lpCCBPrev = NULL;
        lpPSB->eCommandType = C_POSITION;
        lpPSB->eCommandState = S_UNKNOWN;
        lpPSB->lpszVarName = CloneString(kpMCB->lpszCurrNameAttr);
        lpPSB->lpszOf = CloneString(kpMCB->lpszCurrOfAttr);
        lpPSB->lpszIn = CloneString(kpMCB->lpszCurrInAttr);
        lpPSB->lpszFrom = CloneString(kpMCB->lpszCurrFromAttr);
        lpPSB->lpszResVarName = CloneString(kpszEmptyString);
        lpPSB->lpszResOf = CloneString(kpszEmptyString);
        lpPSB->lpszResIn = CloneString(kpszEmptyString);
        lpPSB->lpszResFrom = CloneString(kpszEmptyString);
        lpPSB->lFrom = 0;
        ClearPCDB();
    }
    else
    {
        ConsoleMsg(3, sizeof(PositionBlk), "PositionBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpPSB;
}

/*--------------------------------------------------------------------------*/
IntervalInfoBlk*
CreateIntervalInfoBlk(char* lpszIntervalName)
{
    IntervalInfoBlk* lpIIB;

    lpIIB = malloc(sizeof(IntervalInfoBlk));
    if(lpIIB)
    {
        memset(lpIIB, 0x00, sizeof(IntervalInfoBlk));
        lpIIB->lpIIBNext = NULL;
        lpIIB->lpIIBPrev = NULL;
        lpIIB->lpszIntervalName = CloneString(lpszIntervalName);
        lpIIB->lpIIRHead = NULL;
        lpIIB->lpIIRTail = NULL;
        lpIIB->lIIRCount = 0;
        lpIIB->lpIntervalFile = NULL;
        lpIIB->bHaveIntervalFile = FALSE;
        lpIIB->bHaveStartCmd = FALSE;
        lpIIB->bHaveEndCmd = FALSE;
    }
    else
    {
        ConsoleMsg(3, sizeof(IntervalInfoBlk), "IntervalInfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpIIB;
}

/*--------------------------------------------------------------------------*/
FolderInfoBlk*
CreateFolderInfoBlk(TestInfoBlk* lpTIB, long bPad)
{
    FolderInfoBlk* lpFIB;
    long           lRem4;
    long           bNameResult;

    lpFIB = malloc(sizeof(FolderInfoBlk));
    if(lpFIB)
    {
        memset(lpFIB, 0x00, sizeof(FolderInfoBlk));
        lpFIB->lpFIBNext = NULL;
        lpFIB->lpFIBPrev = NULL;
        if(NULL == kpMCB->lpszParseCharDataBuff)
        {
            lpFIB->lpszFolderName = CloneString(kpszEmptyString);
            lpFIB->lpszFolderData = CloneString(kpszEmptyString);
        }
        else
        {
            bNameResult = GetFolderName(lpTIB, &kpMCB->lpszParseCharDataBuff,
                                        &lpFIB->lpszFolderName);
            if(FAILURE == bNameResult)
            {
                kpMCB->lProcessing = FAILURE;
                return NULL;
            }
            lpFIB->lpszFolderData = CloneString(kpMCB->lpszParseCharDataBuff);
        }
        lpFIB->bAlreadyMatched = FALSE;
        /* Folder data in an MQRFH2 header is always on a four byte boundary  */
        /* and is blank padded. A PCD string always has at least nine         */
        /* trailing nulls  so we can safely add the necessary trailing blanks */
        /* to the folder data */
        lpFIB->lFolderDataLen = StrlenNull(lpFIB->lpszFolderData);
        /* Add traling blanks if the RFH2 folder is not already padded */
        if(bPad)
        {
            lRem4 = lpFIB->lFolderDataLen % 4;
            switch(lRem4)
            {
            case 1:
                lpFIB->lFolderDataLen += 3;
                strncat(lpFIB->lpszFolderData, "   \0", 3);
                break;
            case 2:
                lpFIB->lFolderDataLen += 2;
                strncat(lpFIB->lpszFolderData, "  \0", 2);
                break;
            case 3:
                lpFIB->lFolderDataLen += 1;
                strncat(lpFIB->lpszFolderData, " \0", 1);
                break;
            }
        }
    }
    else
    {
        ConsoleMsg(3, sizeof(FolderInfoBlk), "FolderInfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpFIB;
}


/*--------------------------------------------------------------------------*/
ListElementInfoBlk*
CreateListElementInfoBlk(const char* const kpszListElement)
{
    ListElementInfoBlk* lpLEB;

    lpLEB = malloc(sizeof(ListElementInfoBlk));
    if(lpLEB)
    {
        memset(lpLEB, 0x00, sizeof(ListElementInfoBlk));
        lpLEB->lpLEBNext = NULL;
        lpLEB->lpLEBPrev = NULL;
        if(0 == StrlenNull(kpszListElement))
        {
            lpLEB->lpszListElementValue = CloneString(kpszEmptyString);
        }
        else
        {
            lpLEB->lpszListElementValue = CloneString(kpszListElement);
        }
    }
    else
    {
        ConsoleMsg(3, sizeof(ListElementInfoBlk), "ListElementInfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpLEB;
}


/*--------------------------------------------------------------------------*/
ListInfoBlk*
CreateListInfoBlk(long bDynamicLIB)
{
    ListInfoBlk* lpLIB;
    ListElementInfoBlk* lpLEB;

    lpLIB = malloc(sizeof(ListInfoBlk));
    if(lpLIB)
    {
        /* Initialise the List info block fields */
        memset(lpLIB, 0x00, sizeof(ListInfoBlk));
        lpLIB->lpLEBHead = NULL;
        lpLIB->lpLEBTail = NULL;
        lpLIB->lpLEBPointerArray = NULL;
        lpLIB->lpszListFileName = CloneString(kpMCB->lpLIB->lpszListFileName);
        lpLIB->lpszDir = CloneString(kpMCB->lpLIB->lpszDir);
        lpLIB->lpszResListFileName = NULL;
        lpLIB->lpszResDir = NULL;
        lpLIB->lListElementCount = 0;
        lpLIB->bDynamicLIB = bDynamicLIB;
        /* Now move the ListElement info blocks from the MCB LIB's */
        /* linked list to this List info blocks list               */
        lpLEB = kpMCB->lpLIB->lpLEBHead;
        while(NULL != lpLEB)
        {
            RemoveFromList((LinkedListBlk**)&kpMCB->lpLIB->lpLEBHead,
                           (LinkedListBlk**)&kpMCB->lpLIB->lpLEBTail,
                           (LinkedListBlk*)lpLEB);
            AddToTailOfList((LinkedListBlk**)&lpLIB->lpLEBHead,
                            (LinkedListBlk**)&lpLIB->lpLEBTail,
                            (LinkedListBlk*)lpLEB);
            lpLIB->lListElementCount++;
            lpLEB = kpMCB->lpLIB->lpLEBHead;
        }
        /* Moved the ListElement info blocks so reset chain head and tail */
        kpMCB->lpLIB->lpLEBHead = NULL;
        kpMCB->lpLIB->lpLEBTail = NULL;
        /* Free up the remaining contents of the MCB's LIB */
        ClearLIB(kpMCB->lpLIB);
    }
    else
    {
        ConsoleMsg(3, sizeof(ListInfoBlk), "ListInfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpLIB;
}

/*--------------------------------------------------------------------------*/
MQMDInfoBlk*
CreateMQMDInfoBlk(long bDynamicMIB)
{
    MQMDInfoBlk* lpMIB;

    lpMIB = malloc(sizeof(MQMDInfoBlk));
    if(lpMIB)
    {
        /* Copy the MCB's MIB to the one we just created and then free */
        /* the contents of the MCB's MIB but not the MIB itself as it  */
        /* is reused                                                   */
        memset(lpMIB, 0x00, sizeof(MQMDInfoBlk));
        lpMIB->lpszVersion = CloneStringNull(kpMCB->lpMIB->lpszVersion);
        lpMIB->lpszReport = CloneStringNull(kpMCB->lpMIB->lpszReport);
        lpMIB->lpszMsgType = CloneStringNull(kpMCB->lpMIB->lpszMsgType);
        lpMIB->lpszExpiry = CloneStringNull(kpMCB->lpMIB->lpszExpiry);
        lpMIB->lpszFeedback = CloneStringNull(kpMCB->lpMIB->lpszFeedback);
        lpMIB->lpszEncoding = CloneStringNull(kpMCB->lpMIB->lpszEncoding);
        lpMIB->lpszCodedCharSetId = CloneStringNull(kpMCB->lpMIB->lpszCodedCharSetId);
        lpMIB->lpszFormat = CloneStringNull(kpMCB->lpMIB->lpszFormat);
        lpMIB->lpszPriority = CloneStringNull(kpMCB->lpMIB->lpszPriority);
        lpMIB->lpszPersistence = CloneStringNull(kpMCB->lpMIB->lpszPersistence);
        lpMIB->lpszMsgId = CloneStringNull(kpMCB->lpMIB->lpszMsgId);
        lpMIB->lpszCorrelId = CloneStringNull(kpMCB->lpMIB->lpszCorrelId);
        lpMIB->lpszBackoutCount = CloneStringNull(kpMCB->lpMIB->lpszBackoutCount);
        lpMIB->lpszReplyToQ = CloneStringNull(kpMCB->lpMIB->lpszReplyToQ);
        lpMIB->lpszReplyToQMgr = CloneStringNull(kpMCB->lpMIB->lpszReplyToQMgr);
        lpMIB->lpszUserIdentifier = CloneStringNull(kpMCB->lpMIB->lpszUserIdentifier);
        lpMIB->lpszAccountingToken = CloneStringNull(kpMCB->lpMIB->lpszAccountingToken);
        lpMIB->lpszApplIdentityData = CloneStringNull(kpMCB->lpMIB->lpszApplIdentityData);
        lpMIB->lpszPutApplType = CloneStringNull(kpMCB->lpMIB->lpszPutApplType);
        lpMIB->lpszPutApplName = CloneStringNull(kpMCB->lpMIB->lpszPutApplName);
        lpMIB->lpszPutDate = CloneStringNull(kpMCB->lpMIB->lpszPutDate);
        lpMIB->lpszPutTime = CloneStringNull(kpMCB->lpMIB->lpszPutTime);
        lpMIB->lpszApplOriginData = CloneStringNull(kpMCB->lpMIB->lpszApplOriginData);
        lpMIB->lpszGroupId = CloneStringNull(kpMCB->lpMIB->lpszGroupId);
        lpMIB->lpszMsgSeqNumber = CloneStringNull(kpMCB->lpMIB->lpszMsgSeqNumber);
        lpMIB->lpszOffset = CloneStringNull(kpMCB->lpMIB->lpszOffset);
        lpMIB->lpszOriginalLength = CloneStringNull(kpMCB->lpMIB->lpszOriginalLength);

        lpMIB->lpszMQMDFileName = CloneString(kpMCB->lpMIB->lpszMQMDFileName);
        lpMIB->lpszDir = CloneString(kpMCB->lpMIB->lpszDir);
        lpMIB->lpszResMQMDFileName = NULL;
        lpMIB->lpszResDir = NULL;
        lpMIB->bDynamicMIB = bDynamicMIB;
        /* Free the MIBS contents */
        ClearMIB(kpMCB->lpMIB);
    }
    else
    {
        ConsoleMsg(3, sizeof(MQMDInfoBlk), "MQMDInfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpMIB;
}


/*--------------------------------------------------------------------------*/
RFH2InfoBlk*
CreateRFH2InfoBlk(long bDynamicRIB, MQRFH2* lpoRFH2)
{
    RFH2InfoBlk*   lpRIB;
    FolderInfoBlk* lpFIB;

    lpRIB = malloc(sizeof(RFH2InfoBlk));
    if(lpRIB)
    {
        /* Initialise the RFH2 info block fields */
        memset(lpRIB, 0x00, sizeof(RFH2InfoBlk));
        lpRIB->lpFIBHead = NULL;
        lpRIB->lpFIBTail = NULL;
        lpRIB->lpszFormat = CloneStringNull(kpMCB->lpRIB->lpszFormat);
        lpRIB->lpszRFH2FileName = CloneString(kpMCB->lpRIB->lpszRFH2FileName);
        lpRIB->lpszDir = CloneString(kpMCB->lpRIB->lpszDir);
        lpRIB->lpszResRFH2FileName = NULL;
        lpRIB->lpszResDir = NULL;
        lpRIB->lRFH2FolderDataLen = 0;
        lpRIB->lRFH2FolderCount = 0;
        lpRIB->bDynamicRIB = bDynamicRIB;
        /* If we have an actual RFH2 control block copy its Encoding and CCSID */
        if(NULL != lpoRFH2)
        {
            lpRIB->lEncoding = lpoRFH2->Encoding;
            lpRIB->lCodedCharSetId = lpoRFH2->CodedCharSetId;
            lpRIB->bUseRIBEncodingAndCCSID = TRUE;
        }
        /* Now move the Folder info blocks from the MCB RIB's */
        /* linked list to this RFH2 info blocks list          */
        lpFIB = kpMCB->lpRIB->lpFIBHead;
        while(NULL != lpFIB)
        {
            RemoveFromList((LinkedListBlk**)&kpMCB->lpRIB->lpFIBHead,
                           (LinkedListBlk**)&kpMCB->lpRIB->lpFIBTail,
                           (LinkedListBlk*)lpFIB);
            AddToTailOfList((LinkedListBlk**)&lpRIB->lpFIBHead,
                            (LinkedListBlk**)&lpRIB->lpFIBTail,
                            (LinkedListBlk*)lpFIB);
            /* Each folder in an RFH2 is preceded by a four byte   */
            /* length field. Take this into account                */
            lpRIB->lRFH2FolderDataLen += lpFIB->lFolderDataLen + 4;
            lpRIB->lRFH2FolderCount++;
            lpFIB = kpMCB->lpRIB->lpFIBHead;
        }
        /* Moved the Folder info blocks so reset chain head and tail */
        kpMCB->lpRIB->lpFIBHead = NULL;
        kpMCB->lpRIB->lpFIBTail = NULL;
        /* Free up the remaining contents of the MCB's RIB */
        ClearRIB(kpMCB->lpRIB);
    }
    else
    {
        ConsoleMsg(3, sizeof(RFH2InfoBlk), "RFH2InfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpRIB;
}

/*--------------------------------------------------------------------------*/
ConnectionDefBlk*
CreateConnectionDefBlk(const char* const kpszConnectionName)
{
    ConnectionDefBlk* lpCDB;

    lpCDB = malloc(sizeof(ConnectionDefBlk));
    if(lpCDB)
    {
        memset(lpCDB, 0x00, sizeof(ConnectionDefBlk));
        lpCDB->lpCDBNext = NULL;
        lpCDB->lpCDBPrev = NULL;
        lpCDB->lpszConnectionName = CloneString(kpszConnectionName);
        lpCDB->lpszConnQMgrName = NULL;
        lpCDB->lpszConnChannelName = NULL;
        lpCDB->lpszConnHostName = NULL;
        lpCDB->lpszConnPortNum = NULL;
        lpCDB->lpszConnKeyRepository = NULL;
        lpCDB->lpszConnSSLCipherSpec = NULL;
        lpCDB->lpszConnSSLPeerName = NULL;
        lpCDB->lpszConnMaxMsgLength = NULL;
        lpCDB->lCCSID = 0;
        lpCDB->hConn = 0;
        lpCDB->bWasAlreadyConnected = FALSE;
    }
    else
    {
        ConsoleMsg(3, sizeof(ConnectionDefBlk), "ConnectionDefBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    return lpCDB;
}


void
SetCDBToCIBValues(ConnectionDefBlk* lpCDB)
{
    ControlInfoBlk* lpCIB;

    /* Get a pointer to the CIB */
    lpCIB = kpMCB->lpCIB;

    /* Copy the CIB values into the connection def blk */
    lpCDB->lpszConnQMgrName = CloneStringNull(lpCIB->lpszConnQMgrName);
    lpCDB->lpszConnChannelName = CloneStringNull(lpCIB->lpszConnChannelName);
    lpCDB->lpszConnHostName = CloneStringNull(lpCIB->lpszConnHostName);
    lpCDB->lpszConnPortNum = CloneStringNull(lpCIB->lpszConnPortNum);
    lpCDB->lpszConnKeyRepository = CloneStringNull(lpCIB->lpszConnKeyRepository);
    lpCDB->lpszConnSSLCipherSpec = CloneStringNull(lpCIB->lpszConnSSLCipherSpec);
    lpCDB->lpszConnSSLPeerName = CloneStringNull(lpCIB->lpszConnSSLPeerName);
    lpCDB->lpszConnMaxMsgLength = CloneStringNull(lpCIB->lpszConnMaxMsgLength);

    /* Now free the CIB values and reset the pointers */
    FreeIfNotNull((void**)&lpCIB->lpszConnQMgrName);
    FreeIfNotNull((void**)&lpCIB->lpszConnChannelName);
    FreeIfNotNull((void**)&lpCIB->lpszConnHostName);
    FreeIfNotNull((void**)&lpCIB->lpszConnPortNum);
    FreeIfNotNull((void**)&lpCIB->lpszConnKeyRepository);
    FreeIfNotNull((void**)&lpCIB->lpszConnSSLCipherSpec);
    FreeIfNotNull((void**)&lpCIB->lpszConnSSLPeerName);
    FreeIfNotNull((void**)&lpCIB->lpszConnMaxMsgLength);
}

/*--------------------------------------------------------------------------*/
TestInfoBlk*
CreateTestInfoBlk()
{
    TestInfoBlk* lpTIB;
    VarInfoBlk*  lpVIB;

    lpTIB = malloc(sizeof(TestInfoBlk));
    if(lpTIB)
    {
        memset(lpTIB, 0x00, sizeof(TestInfoBlk));
        lpTIB->lpszTestName = CloneString(kpMCB->lpszCurrNameAttr);
        if(FAILURE != kpMCB->lProcessing)
        {
            lpTIB->lpTIBNext = NULL;
            lpTIB->lpTIBPrev = NULL;
            lpTIB->lpCCBHead = NULL;
            lpTIB->lpCCBTail = NULL;
            lpTIB->lpCCBCurr = NULL;
            lpTIB->lpVIBHead = NULL;
            lpTIB->lpVIBTail = NULL;
            lpTIB->lpBIBHead = NULL;
            lpTIB->lpBIBTail = NULL;
            lpTIB->lpQIBHead = NULL;
            lpTIB->lpQIBTail = NULL;
            lpTIB->lTestNum = 0;
            lpTIB->bCmdResult = SUCCESS;
            lpTIB->lLastCC = MTCC_OK;
            lpTIB->lLastRC = MTRC_NONE;
            lpTIB->lLastDataLen = 0;
            lpTIB->lTestCurrentMsgRate = 0;
            lpTIB->lTestTotalGetFile = 0;
            lpTIB->lTestSuccessfulGetFile = 0;
            lpTIB->lTestFailedGetFile = 0;
            lpTIB->lTestTotalPutFile = 0;
            lpTIB->lTestSuccessfulPutFile = 0;
            lpTIB->lTestFailedPutFile = 0;
            lpTIB->lTestTotalGetMsg = 0;
            lpTIB->lTestSuccessfulGetMsg = 0;
            lpTIB->lTestFailedGetMsg = 0;
            lpTIB->lTestTotalPutMsg = 0;
            lpTIB->lTestSuccessfulPutMsg = 0;
            lpTIB->lTestFailedPutMsg = 0;
            lpTIB->lTestTotalCompare = 0;
            lpTIB->lTestSuccessfulCompare = 0;
            lpTIB->lTestFailedCompare = 0;
            lpTIB->bTestHasGetFile = FALSE;
            lpTIB->bTestHasPutFile = FALSE;
            lpTIB->bTestHasGetMsg = FALSE;
            lpTIB->bTestHasPutMsg = FALSE;
            lpTIB->bTestHasCompare = FALSE;
            lpTIB->lpszLastFile = CloneString(kpszEmptyString);
            lpTIB->lpszLastDir = CloneString(kpszEmptyString);
            lpTIB->lpszLastQ = CloneString(kpszEmptyString);
            lpTIB->lpszLastQMgr = CloneString(kpszEmptyString);
            lpTIB->lpBreakContinueFSB = NULL;
            AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBReadyHead,
                            (LinkedListBlk**)&kpMCB->lpTIBReadyTail,
                            (LinkedListBlk*)lpTIB);
        }
    }
    else
    {
        ConsoleMsg(3, sizeof(TestInfoBlk), "TestInfoBlk", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return NULL;
    }

    /* Add the time related automatic variables to the test info block */
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszYEAR4);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszYEAR2);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszMONTH3);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszMONTH2);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszDAY3);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszDAY2);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszHOURS);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszMINUTES);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSECONDS);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszPID);
    AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTNAME);

    /* Add automatic variables for MsgId and CorrelId */
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszMSGID);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszCORRELID);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszGROUPID);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszMSGSEQNUMBER);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);

    /* Add automatic variables for other MQMD related fields */
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszREPLYTOQ);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszREPLYTOQMGR);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszMSGTYPE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszPRIORITY);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszPERSISTENCE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);

    /* Add automatic variable for LastXXX */
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszLASTCC);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszLASTRC);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszLASTDATALEN);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszLASTFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszLASTDIR);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszLASTQ);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszLASTQMGR);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);

    /* Add automatic variable for CurrentMessageRate */
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTCURRENTMSGRATE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);

    /* Create script and test basic statistics automatic variables */
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTTOTALGETFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTSUCCESSFULGETFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTFAILEDGETFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTTOTALPUTFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTSUCCESSFULPUTFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTFAILEDPUTFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTTOTALGETMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTSUCCESSFULGETMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTFAILEDGETMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTTOTALPUTMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTSUCCESSFULPUTMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTFAILEDPUTMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTTOTALCOMPARE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTSUCCESSFULCOMPARE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszTESTFAILEDCOMPARE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTTOTALGETFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTSUCCESSFULGETFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTFAILEDGETFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTTOTALPUTFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTSUCCESSFULPUTFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTFAILEDPUTFILE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTTOTALGETMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTSUCCESSFULGETMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTFAILEDGETMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTTOTALPUTMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTSUCCESSFULPUTMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTFAILEDPUTMSG);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTTOTALCOMPARE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTSUCCESSFULCOMPARE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
    lpVIB = AddAutoStrVar(&lpTIB->lpVIBHead, &lpTIB->lpVIBTail, kpszSCRIPTFAILEDCOMPARE);
    lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);

    return lpTIB;
}
